﻿/**
* Dies ist der erste Einstiegspunkt der mobilen Applikation - Hier werden alle wichtigen Klassen Initialisiert und anschließend auf das Menü/Login Screen weitergeleitet
*
* @class AppStarter.js
*/

//Damit die App im Browser (Chrome) läuft
//Disable Cross-domain Javascript security in Chrome for Development
//http://documentumcookbook.wordpress.com/2012/03/13/disable-cross-domain-javascript-security-in-chrome-for-development/
$(document).on("click", "a:not([data-bypass])", function (evt) {
    var href = { prop: $(this).prop("href"), attr: $(this).attr("href") };
    var root = location.protocol + "//" + location.host;
    if (href.attr != undefined) {
        if (href.prop && href.prop.slice(0, root.length) === root) {
            evt.preventDefault();
            window.app.navigate(href.attr, { trigger: true });
        }
    }
});

/*
 * Hardware backbutton EventHandler
 * Leaves App if triggered on ModuleView
 * Navigates one Step back if triggered anywehre but ModuleView
 */
document.addEventListener("backbutton", function (e) {
    if (navigator.notification) {
        e.preventDefault();
        if (ActionHelper.CurrentView.Type == 'Module') {
            //Checks if user is on windows device
            if (window.devicePlatform == "WinCE" || window.devicePlatform == "Win32NT") {
                //Special event for exiting app on windows device
                cordova.exec(function () { }, function () { }, "ExitApp", "now", []);
            } else {
                //Standard event for exiting app
                navigator.app.exitApp();
            }
            //Checks if in app browser is open and user is on windows device
        } else if (window.InAppBrowserOpen != null & (window.devicePlatform == "WinCE" || window.devicePlatform == "Win32NT")) {
            //Closes in app browser and returns to app
            window.InAppBrowserOpen.close();
            window.InAppBrowserOpen = null;
            return;
        } else {
            //navigates one step back
            if (ActionHelper.ViewDeactivated) {
                ActionHelper.doNavigate(new Object(), null, 1, null, null, true);
            } else {
                ActionHelper.navigate(new Object(), null, 1, null, null, true);
            }
        }
    }
}, false);

function replaceLanguageStrings(htmlTemplate) {
    if(!Utils.isNull(htmlTemplate)) {
        htmlTemplate.find('#backButton').html(Utils.getText('ZURUECK'));
        htmlTemplate.find('#homeButton').html(Utils.getText('START'));
    }
}

//$(window).bind('storage', function (e) {
//    console.log("storage event for '" + e.originalEvent.key + "'"); //, e.originalEvent.newValue);
//});

/*
 * BROWSER TESTING AREA
 * Code inside this function is executed when the user is testing in the browser
 */
$(document).ready(function () {
    if (!navigator.notification) {

        //THIS CODE IS ONLY EXECUTED WHEN TESTING IN BROWSER       

        //INCLUDE THIS WHEN TESTING THE OFFLINE VERSIONING IN BROWSER
        var useOfflineConfig = false;//= localStorage.getItem('UseOfflineApp');

        if (useOfflineConfig) {
            loadJSONfromFile(0);
        }
        console.log("INFO: $(document).ready() started...");
        window.deviceId = localStorage.getItem("deviceId");
        if (window.deviceId == null) {
            window.deviceId = window.generateGuid();
            localStorage.setItem("deviceId", window.deviceId);
        }

        // determin Browser and version
        navigator.sayswho = (function () {
            var ua = navigator.userAgent, tem,
            M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
            if (/trident/i.test(M[1])) {
                tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
                return 'IE ' + (tem[1] || '');
            }
            if (M[1] === 'Chrome') {
                tem = ua.match(/\bOPR\/(\d+)/);
                if (tem != null) return 'Opera ' + tem[1];
            }
            M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
            if ((tem = ua.match(/version\/(\d+)/i)) != null) M.splice(1, 1, tem[1]);
            return M.join(' ');
        })();

        window.devicePlatform = "BROWSER";
        window.language = navigator.language;

        if (!Utils.isNull(navigator.sayswho)) {
            window.browserVersion = navigator.sayswho;
        }

        window.deviceready = true;
        Utils.initializeHacks();
        generateModels();

        window.app = new AppRouter();
        var location = window.location;
        var pathname = window.location.pathname;
        var urlParamsPos = pathname.indexOf("?");
        var urlWithoutParams = pathname;

        if (urlParamsPos > 0) {
            urlWithoutParams = pathname.substr(0, urlParamsPos);
        }
        var routePos = location.href.indexOf("#");
        var route = '';
        if (routePos > 0) {
            route = location.href.substr(routePos + 1, location.href.length);
        }

        window.app.basePage = location.href;
        console.log("INFO: BasePage = " + window.app.basePage);
        window.app.root = urlWithoutParams + '#/';
        Backbone.history.start({ pushState: true, root: window.app.root });
        window.app.navigate(route, { trigger: true });

        replaceLanguageStrings($(document));
    }
});

/*
 * PHONE AREA
 * Code inside this function is executed when the user is on mobile device
 */
document.addEventListener("deviceready", function () {

    doInit();
    var msgGetsInitialized = Utils.getText('WIRD_INITIALISIERT');

    if (Utils.isNull(msgGetsInitialized)) {
        msgGetsInitialized = 'App wird initialisiert...';
    }

    if (localStorage.getItem('getOfflineConfig')) {
        if (window.currentUser) {
            $.mobile.loading('show', {
                text: msgGetsInitialized,
                textVisible: true,
                theme: 'a',
            });
            $('#loader_page').show();
        }
        loadJSONfromFile(0);
    } else {
        $.mobile.loading('hide');
        $('#loader_page').hide();
    }

    if(!!window.devicePlatform && window.devicePlatform.toLowerCase() === 'ios' && !!Keyboard) {
        Keyboard.shrinkView(true);
    }
}, false);

function doInit() {
    //TMP
    //alert(localStorage.getItem('lastClosed'));
    //localStorage.setItem('lastClosed', null);

    replaceLanguageStrings($(document));

    console.log("INFO: onDeviceReady() started...");

    window.deviceId = window.device.uuid;
    window.devicePlatform = window.device.platform;

    var osVersion = (navigator.userAgent).match(/Android\s+([\d\.]+)|OS\s+([\d\_]+)|Windows Phone\s+([\d\.]+)/i);
    osVersion = osVersion.toString().split(',');
    if (!Utils.isNull(osVersion[1])) {
        osVersion = osVersion[1];
    }

    window.osVersion = osVersion;
    window.deviceModel = window.device.model;
    window.language = navigator.language;
    window.languageShort = this.getLangForJSON();

    window.userAgent = 'userAgent unknown'
    if(!Utils.isNull(navigator.userAgent)) {
        window.userAgent = navigator.userAgent;
    }
    

    window.deviceready = true;
    Utils.initializeHacks();
    generateModels();

    window.app = new AppRouter();
    var location = window.location;
    var pathname = window.location.pathname;
    var urlParamsPos = pathname.indexOf("?");
    var urlWithoutParams = pathname;
    if (urlParamsPos > 0) {
        urlWithoutParams = pathname.substr(0, urlParamsPos);
    }
    window.app.basePage = location.href;
    window.app.root = urlWithoutParams;
    requirejs.config({
        enforceDefine: true,
        waitSeconds: 0,
    });
    console.log("INFO: Attempting to start History");
    if (!Backbone.history.isHistoryStarted()) {
        //window.app.root = '/mobile-dev/index.html';
        Backbone.history.start({ pushState: true, root: window.app.root });
    }
    window.app.navigate("", { trigger: true });

    console.log("INFO: Init Poly");
    initPoly();

    document.addEventListener("pause", function () {
        window.persistGenericData();
    }, false);

    if (GlobalSettings.IsBoso()) {
        Boso.startBluetoothBackgroundWorker();
    }

    var icon = GlobalSettings.CustomIcon();
    if (icon.indexOf("##NO_LOGO##") == -1) {
        $('#homeButton').replaceWith('<img id="homeButton" class="logo" src="' + icon + '"/>');
    }

    changeWindowZoom();
}

function getLangForJSON() {
    var lang = window.language.split('-');
    lang = lang[0];

    if(lang === 'nb') {
        lang = 'no'
    }

    var isPossible = $.inArray(lang, CONSTS.POSSIBLE_LANGUAGES);

    if (Utils.isNull(lang) || isPossible == -1) {
        lang = 'en';
    }

    return lang;
}

//// refresh page after cache is finally updated
//window.addEventListener('load', function (e) {
//    if (window.applicationCache) {
//        window.applicationCache.addEventListener('updateready', function (e) {
//            window.location.reload();
//        }, false);
//    }
//}, false);
function handleCacheEvent(e) {
    alert(e.type);
}

function handleCacheError(e) {
    //alert('Error: Cache failed to update!');
}

//// Fired after the first cache of the manifest.
//window.applicationCache.addEventListener('cached', handleCacheEvent, false);

//// Checking for an update. Always the first event fired in the sequence.
//window.applicationCache.addEventListener('checking', handleCacheEvent, false);

//// An update was found. The browser is fetching resources.
//window.applicationCache.addEventListener('downloading', handleCacheEvent, false);

//// The manifest returns 404 or 410, the download failed,
//// or the manifest changed while the download was in progress.
////window.applicationCache.addEventListener('error', handleCacheError, false);

//// Fired after the first download of the manifest.
//window.applicationCache.addEventListener('noupdate', handleCacheEvent, false);

//// Fired if the manifest file returns a 404 or 410.
//// This results in the application cache being deleted.
//window.applicationCache.addEventListener('obsolete', handleCacheEvent, false);

//// Fired for each resource listed in the manifest as it is being fetched.
//window.applicationCache.addEventListener('progress', handleCacheEvent, false);

//// Fired when the manifest resources have been newly redownloaded.
////window.applicationCache.addEventListener('updateready', handleCacheEvent, false);


window.addEventListener('load', function (e) {
    //Check if a new cache is available 
    //if (window.applicationCache.status != window.applicationCache.UNCACHED) {
    //    window.applicationCache.update(); // Attempt to update the user's cache.
    //}

    window.applicationCache.addEventListener('updateready', function (e) {
        if (window.applicationCache.status == window.applicationCache.UPDATEREADY) {
            localStorage.setItem('LoadConfig', 1);
            // Browser downloaded a new app cache.
            // Swap it in and reload the page to get the new version.
            window.applicationCache.swapCache();
            alert('Eine neue Version wurde installiert. Diese wird nun automatisch installiert. Sie können wie gewohnt weiterarbeiten!');
            window.location.replace(window.app.basePage);
            //setTimeout(SyncController.syncConfiguration(true), 0);


            //console.log("INFO: BasePage = " + window.app.basePage);
            //window.app.navigate("", { trigger: true });
        } else {
            // Manifest didn't changed. Nothing new yet.
        }
    }, false);
}, false);

function generateModels() {
    generateModelAppVersionRawElement();
    generateModelUserRawElement();
    generateModelFeedbackRawElement();
    generateModelGenericViewRawElement();
    generateModelGenericViewFieldRawElement();
    generateModelGenericEntityRawElement();
    generateModelGenericPropertyRawElement();
    generateModelGenericDataRawElement();
    generateModelGenericValidationRawElement();
    generateModelDeviceRawElement();
    generateModelGenericViewActionRawElement();
    generateModelGenericViewFilterRawElement();
}

function changeWindowZoom() {

    var globalZoom = GlobalSettings.ZoomFaktor();

    if (globalZoom != undefined && globalZoom != null) {
        /*IE,Safari, Chrome*/
        $(document.body).css("zoom", globalZoom);
        /*FF*/
        $(document.body).css("-moz-transform", globalZoom);
        $(document.body).css("-moz-transform-origin", "0 0");


        /* Für header kein Zoom. Bug Chrome Android KitKat workaround */
        $('#header').css('zoom', 1 / globalZoom)
        $('#header').css('-moz-transform', 1 / globalZoom)
    }
}

function parseDataFromFile(data) {
    var IsUpToDate = false;

    var currentCollection;
    var currentIdentifier;
    var currentModel;
    var currentPersistMethod;
    
   
    
    $.each(data.split("\n"), function (index, element) {	
        if (IsUpToDate) {
            return;
        }
        
        var key = '';
        var content = '';
        if (element.indexOf(',') > -1) {
            key = element.substring(0, element.indexOf(','));
            content = element.substring(element.indexOf(',') + 1);
        } else {
            key = element;
        }

        if (key === 'OfflineConfigVersion') {
            console.log('CHECK ' + key);
            var currentOfflineConfigVersion = localStorage.getItem('OfflineConfigVersion');

            console.log('TEST: currentOflineConfig:', currentOfflineConfigVersion);
            if(currentOfflineConfigVersion < 50) {
                localStorage.removeItem('GenericViewActions');
                localStorage.removeItem('GenericViewFields');
            }

            if (!Utils.isNull(currentOfflineConfigVersion) && !Utils.isNull(content)) {
                content = parseInt(content);
                currentOfflineConfigVersion = parseInt(currentOfflineConfigVersion);
            }

            if (content > currentOfflineConfigVersion) {
                localStorage.setItem('OfflineConfigVersion', content);
                console.log('Update : ' + currentOfflineConfigVersion + ' to ' + content);
            } else {
                //VERSION IS UP TO DATE!
                console.log('IS UP TO DATE!');
                IsUpToDate = true;
            }
        } else if (key === 'InitConfigVersion') {
            localStorage.clear();

            //window.Devices.reset();
            window.genericData.reset();
            window.genericEntities.reset();
            window.genericProperties.reset();
            window.genericValidation.reset();
            window.genericViewActions.reset();
            window.genericViewFields.reset();
            window.genericViewFilters.reset();
            window.genericViews.reset();
            window.userRawElementEntries.reset();
        } else {
            //console.log('LOAD ' + key);
            switch (key) {
                case 'GenericData':
                	currentIdentifier = 'DataId';
                    currentModel = window.GenericDataRawElement;
                    currentCollection = window.genericData;
                    currentPersistMethod = window.persistGenericData;
                    break;
                    /*case 'Devices':
                        currentModel = window.DeviceRawElement;
                        currentCollection = window.Devices;
                        break;*/
                case 'GenericEntities':
                	currentIdentifier = 'EntityId';
                    currentModel = window.GenericEntityRawElement;
                    currentCollection = window.genericEntities;
                    currentPersistMethod = window.persistGenericEntitiesData;
                    break;
                case 'GenericProperties':
                	currentIdentifier = 'PropertyId';
                    currentModel = window.GenericPropertyRawElement;
                    currentCollection = window.genericProperties;
                    currentPersistMethod = window.persistGenericPropertiesData;
                    break;
                case 'GenericValidation':
                	currentIdentifier = 'ValidationId';
                    currentModel = window.GenericValidationRawElement;
                    currentCollection = window.genericValidation;
                    currentPersistMethod = window.persistGenericValidationsData;
                    break;
                case 'GenericViews':
                	currentIdentifier = 'ViewId';
                    currentModel = window.GenericViewRawElement;
                    currentCollection = window.genericViews;
                    currentPersistMethod = window.persistGenericViewsData;
                    break;
                case 'GenericViewFields':
                	currentIdentifier = 'FieldId';
                    currentModel = window.GenericViewFieldRawElement;
                    currentCollection = window.genericViewFields;
                    currentPersistMethod = window.persistGenericViewFieldsData;
                    break;
                case 'GenericViewFilters':
                	currentIdentifier = 'FilterId';
                    currentModel = window.GenericViewFilterRawElement;
                    currentCollection = window.genericViewFilters;
                    currentPersistMethod = window.persistGenericViewFiltersData;
                    break;
                case 'GenericViewActions':
                	currentIdentifier = 'ViewActionId';
                    currentModel = window.GenericViewActionRawElement;
                    currentCollection = window.genericViewActions;
                    currentPersistMethod = window.persistGenericViewActionsData;
                    break;
                case 'UserRawElementEntries':
                	currentIdentifier = 'UserId';
                    currentModel = window.UserRawElement;
                    currentCollection = window.userRawElementEntries;
                    currentPersistMethod = window.persistUserRawElementData;
                    break;
                case 'currentUser':
                    setCurrentUser(JSON.parse(content));
                    break;
                case 'currentDevice':
                    setCurrentDevice(JSON.parse(content));
                    break;
                default:
                    localStorage.setItem(key, content);
            }
            if (currentCollection != null) {
                var collection = JSON.parse(content);
                if (collection != null) {
                    $.each(collection, function (id, obj) {
                        var newModel = new currentModel;
                        newModel.attributes = obj;
                        newModel.id = id;
                        newModel.PersistToLocalStorageImmediately = false;
                        newModel.attributes.SyncTime = moment().toDate();
                                           
                        if(!!currentIdentifier){                             	
                        	var tmp = currentCollection.get(newModel.get(currentIdentifier));                       	
                        	
                        	if(!!tmp)
                        	{     
                        		currentCollection.remove(tmp);
	                			tmp = null;
                        	}
                        }
                        
                        currentCollection.add(newModel);
                        newModel.save();
                    });
                    collection = null;
                }
            }
            
            if ($.isFunction(currentPersistMethod)) {
                currentPersistMethod();
            }
            currentCollection = null;
            currentModel = null;
            currentPersistMethod = null;
        }
    });
};

function loadJSONfromFile(count) {
    var lang = this.getLangForJSON()

    console.log('lang:', lang, 'count:', count);
    var url = 'localStorageJSON-' + lang + '.csv';

    if (count > 0) {
        url = 'localStorageJSON-' + lang + count + '.csv';
    }

    $.ajax({
        url: url,
        dataType: "text",
        contentType: "text/plain; charset=iso-8859-1",
        beforeSend: function (jqXHR) {
            jqXHR.overrideMimeType('text/html;charset=iso-8859-1');
        },
        success: function (data) {
            parseDataFromFile(data);
            if (window.navigator.notification) {
                doInit();
            }
            $('#homeButton').attr('src', GlobalSettings.CustomIcon());
            window.app.navigate("moduleView", { trigger: true });
            $.mobile.loading('hide');
            $('#loader_page').hide();

            count++;
            loadJSONfromFile(count);
        },
        error: function (err) {
            $.mobile.loading('hide');
            $('#loader_page').hide();
        }
    });
}