﻿/**
* Implementiert Methoden für das Synchronisieren von Daten auf die mobile Applikation
*
* @class appController.js
*/
var SyncController = {

    SyncQueue: new Array,
    SyncIsRunning: false,
    TmpData: new Array,
    Initialize: false,
    Uploads: new Array,
    SyncCancelTimer: null,
    LastSync: null,

    dataRetention: function (ignoreLastRetention) {
        // überprüfe ob die letzte Reinigung ignoriert werden soll
        if (ignoreLastRetention == undefined)
            ignoreLastRetention = false;

        // hole die Letzte Reinigung aus dem localStorage
        var LastRetention = localStorage.getItem('LastRetention');
        var passedDays = 2;
        if (LastRetention != null) {
            var timeHlp = moment(LastRetention.toString(), CONSTS.DATETIME_PERSIST_FORMAT);
            var time = timeHlp.toDate().getTime();
            var passedTime = moment().toDate().getTime() - time;
            passedDays = passedTime / 86400000;
        }
        // wenn die passed Days unter 1 sind mache nichts
        if (passedDays < 1 && !ignoreLastRetention) {
            return;
        }

        // Arrays die gefüllt werden mit Entities welche Retention Properties enthalten
        var retentionEntities = [];
        var parentRetentionEntities = [];

        // Für jede Entity überprüfen ob RetentionProperties gesetzt sind Parent und Child und retentionEntities befüllen
        _.each(window.currentDevice.Entities, function (devEntity) { // window.currentDevice.Entities wird wohl der cache sein
            var entity = window.genericEntities.get(devEntity.EntityId);
            if (entity != null) { // nicht leer
                if (entity.attributes.ParentRetentionPropertyId != null && entity.attributes.ParentRetentionPropertyId != CONSTS.GUID_DEFAULT) { // nicht leer oder standard guid
                    parentRetentionEntities.push(entity);
                } else if ((entity.attributes.RetentionPropertyId != null && entity.attributes.RetentionPropertyId != CONSTS.GUID_DEFAULT) ||
                    entity.attributes.RetentionJS != null && entity.attributes.RetentionJS != '') { // nicht leer oder (keine standard id und keine JS Fkt)
                    retentionEntities.push(entity);
                }
            }
            entity = null;
        });// Ende der Schleife


        _.each(retentionEntities, function (entity) { //jede entity im retentionArray
            var property = window.genericProperties.get(entity.attributes.RetentionPropertyId); // setze jede Property aus der entity
            _.each(window.genericData.models, function (model) { // für jedes model im GenericData

                // wenn model mit entity übereinstimmt und SyncTime nicht leer ist und nicht dem Standarddatums wert entspricht
                if (model.attributes.EntityId == entity.attributes.EntityId && model.attributes.SyncTime != null && model.attributes.SyncTime.getTime() != CONSTS.DATE_DEFAULT.getTime()) {
                    var retentionCondition = false; // setze retention Condition  = false
                    var retentionDaysCondition = false; // eben so die retentionDaysCondition = false
                    // wenn eine Retention Funktion gesetzt ist
                    if (entity.attributes.RetentionJS != '' && entity.attributes.RetentionJS != null) {
                        retentionCondition = eval(entity.attributes.RetentionJS); //führe diese aus
                    }
                    else { // Andernfalls
                        // wenn property != null und RetentionPropertyId !=null und RetentionPropertyId != standard guid
                        if (property != null && entity.attributes.RetentionPropertyId != null && entity.attributes.RetentionPropertyId != CONSTS.GUID_DEFAULT) {
                            var date = model.get(property.attributes.GenericColumnName); // hole datum der property
                            if (date != null && date != "") { // wenn das Datum != null & datum !=""
                                var timeHlp = moment(date.toString(), CONSTS.DATETIME_PERSIST_FORMAT);
                                var time = timeHlp.toDate().getTime(); // hole die aktuelle Zeit
                                timeHlp = null;
                                if (time != "NaN") { // wenn in time eine Sinnvolle angabe enthalten ist
                                    passedTime = moment().toDate().getTime() - time; // ziehe von der aktuellen Zeit die eingetragene Zeit ab um die verstrichenen Tage zu erhalten
                                    passedDays = passedTime / 86400000; // umwandlung in tage, 86400000 entspricht 1 Tag in ms

                                    if (passedDays > entity.attributes.RetentionDays) { // wenn die verstrichenen Tage > als der eingetragene Wert ist
                                        retentionDaysCondition = true;// retentionDaysCondition = true
                                    }
                                    else { // Andernfalls
                                        retentionCondition = false; // retentionCondition false
                                    }
                                }
                                time = null;
                            }
                        }
                    }

                    if (retentionCondition || retentionDaysCondition) { // wenn retentionCondition === true oder retentionDaysCondition === true
                        var signatureField = GenericHelper.getFirstGenericColumnNameByDataType(entity.id, "signature");
                        if (signatureField != "") { // wenn unterschrift vorhanden 
                            var objectId = GenericHelper.getCustomValue(model, signatureField);
                            if (objectId != null) {
                                var genericDataSignature = _.filter(window.genericData.models, function (data) { // suche nach der Entity ID
                                    //unterschrift auch löschen!!
                                    return data.attributes.EntityId == "17f795ed-907b-0568-0cb1-e793873c224d" && data.attributes.ObjectId == objectId
                                    && data.attributes.SyncTime != null && data.attributes.SyncTime.getTime() != CONSTS.DATE_DEFAULT.getTime();
                                    // liefere alle Daten aus der Datenbank zurück welche die Objekt ID beinhalten, Synctime!=null ist und eine andere Zeit als der Standardwert gesetzt ist
                                });

                                _.each(genericDataSignature, function (modelSig) { // entferne alle Unterschriften die gefunden wurden
                                    window.genericData.remove(modelSig);
                                    modelSig.destroy();
                                });
                            }
                        }

                        window.genericData.remove(model); // entferne alle gefundenen Modells
                        model.destroy();

                        signatureField = null;
                    }
                }// kein RetentionFlag gesetzt !
            }); // Ende der Schleife
            property = null;
            // Ende der Schleife
        });

        // Code Block um zu prüfen ob der Parent bereits gelöscht ist
        _.each(parentRetentionEntities, function (entity) { // Für jede parentEntity
            var parentRetentionProperty = window.genericProperties.get(entity.attributes.ParentRetentionPropertyId); // hole die ParentProperties aus dem Cache

            _.each(window.genericData.models, function (model) { // für jedes im cache gespeicherten model
                //überprüfe ob model.attribut mit dem entity.attribut übereinstimmt & ob Synctime gesetzt ist & ob Synctime nicht dem Standardwert entspricht
                if (model.attributes.EntityId === entity.attributes.EntityId && model.attributes.SyncTime != null && model.attributes.SyncTime.getTime() != CONSTS.DATE_DEFAULT.getTime()) {
                    var parentId = model.get(parentRetentionProperty.attributes.GenericColumnName); // hole für jedes Model die Id aus dem Cache

                    var parents = _.filter(window.genericData.models, function (parent) {
                        return parent.attributes.ObjectId == parentId; // liefere alle parents für das model zurück
                    });

                    if (parents.length <= 0) { // wenn keine parent
                        window.genericData.remove(model); // entferne das Model
                        model.destroy();
                    }

                    parentId = null;

                    parents = null;
                }
            }); // Ende der Schleife
            parentRetentionProperty = null;
        }); // End der Schleife

        // Auch aus dem Cache löschen
        var getOfflineConfig = localStorage.getItem('getOfflineConfig');
        var deadModels;
        if (getOfflineConfig) {
            //Special handling to delete unsynced, inactive models when is offline app
            deadModels = _.filter(window.genericData.models, function (model) {
                return model.attributes.IsActive == false;
            });
        } else {
            deadModels = _.filter(window.genericData.models, function (model) {
                return model.attributes.IsActive == false && !model.toBeSynchronized();
            });
        }
        _.each(deadModels, function (model) {
            window.genericData.remove(model); // Entferne tote Models
            model.destroy();
        });

        ActionHelper.globalAfterSync();

        localStorage.setItem("LastRetention", moment().format(CONSTS.DATETIME_PERSIST_FORMAT, 'de')); // letzter Cleanup der Daten
        retentionEntities = null;
        parentRetentionEntities = null;
        deadModels = null;
        getOfflineConfig = null;
    },

    checkConnection: function (initial, manually) {
        if (manually == undefined)
            manually = true;
        if (navigator != null && navigator.network != null) {
            var networkState = navigator.network.connection.type;
            if (networkState == Connection.NONE) {
                SyncController.SyncQueue = new Array();
                SyncController.SyncIsRunning = false;
                $.mobile.loading('hide');
                $('#loader_page').hide();
                if (manually) {
                    if (initial) {
                        alert('Ihre Internetverbindung ist zu schwach für diese Aktion. Bitte versuchen Sie es erneut wenn Sie eine stärkerer Verbindung zum Internet haben.');
                    } else {
                        alert('Es kann keine Verbindung zum Server aufgebaut werden!');
                    }
                }
                return false;
            }
        }
        return true;
    },

    resetApp: function () {
        localStorage.clear();
        Utils.clearDB();
        /*files aus MF_DATA und MF_TMP löschen*/
        FileHelper.deleteDirectory("MF_DATA");
        FileHelper.deleteDirectory("MF_TMP");

        window.app.navigate("", { trigger: true });
        location.reload();
    },

    deleteGenericData: function () {
        _.each(window.genericData.models, function (data) {
            window.genericData.remove(data);
            data.destroy();
        });
    },

    deleteData: function () {
        //localStorage.clear();
        _.each(window.genericData.models, function (data) {
            window.genericData.remove(data);
            data.destroy();
        });
        _.each(window.genericEntities.models, function (model) {
            window.genericEntities.remove(model);
            model.destroy();
        });
        _.each(window.genericProperties.models, function (model) {
            window.genericProperties.remove(model);
            model.destroy();
        });
        _.each(window.genericValidation.models, function (model) {
            window.genericValidation.remove(model);
            model.destroy();
        });
        _.each(window.genericViewActions.models, function (model) {
            window.genericViewActions.remove(model);
            model.destroy();
        });
        _.each(window.genericViewFields.models, function (model) {
            window.genericViewFields.remove(model);
            model.destroy();
        });
        _.each(window.genericViewFilters.models, function (model) {
            window.genericViewFilters.remove(model);
            model.destroy();
        });
        _.each(window.genericViews.models, function (model) {
            window.genericViews.remove(model);
            model.destroy();
        });
        _.each(window.userRawElementEntries.models, function (model) {
            window.userRawElementEntries.remove(model);
            model.destroy();
        });
        _.each(window.Devices.models, function (model) {
            window.Devices.remove(model);
            model.destroy();
        });
        localStorage.removeItem('synchronizeData');
        localStorage.removeItem('currentUser');
        localStorage.removeItem('currentDevice');
        localStorage.removeItem('Devices');
        localStorage.removeItem('GenericData');

        localStorage.removeItem('register');
        for (var i = 0, len = window.localStorage.length; i < len; ++i) {
            if (localStorage.key(i) != null && localStorage.key(i).indexOf('gd_') >= 0) {
                localStorage.removeItem(window.localStorage.key(i));
            }
        }


        localStorage.removeItem('GenericEntities');
        localStorage.removeItem('GenericProperties');
        localStorage.removeItem('GenericValidation');
        localStorage.removeItem('GenericViewActions');
        localStorage.removeItem('GenericViewFields');
        localStorage.removeItem('GenericViews');
        localStorage.removeItem('UserRawElementEntries');

        Utils.clearDB();


        $('#loader_page').hide();
        $.mobile.loading('hide');
        window.app.navigate("/moduleView", { trigger: true });
    },

    getAppVersion: function () {

        window.appVersion = new window.AppVersionRawElement();

        if (!this.checkConnection()) {
            return;
        }

        var svcWrapper = {};
        svcWrapper.version = {
            AppVersion: window.appVersion.attributes.AppVersion
        };

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'appVersions/GetAppVersion',
            type: 'POST',
            async: true,
            data: window.appVersion.toJSON(),
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetAppVersion: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var obj = $.parseJSON(AjaxReturnObject.ReturnValues).AppVersionRawElement;

                    if (!window.appVersion) {
                        window.appVersion = new window.AppVersionRawElement();
                    }

                    // do not overwrite missing attributes
                    window.appVersion.attributes.AppVersion = obj.AppVersion;
                    window.appVersion.attributes.WsMainUrl = obj.WsMainUrl;
                    window.appVersion.attributes.WsUsersUrl = obj.WsUsersUrl;
                    window.appVersion.attributes.WsTimeRecordingsUrl = obj.WsTimeRecordingsUrl;
                    window.appVersion.attributes.WsLogbookUrl = obj.WsLogbookUrl;
                    window.appVersion.attributes.WsReceiptsUrl = obj.WsReceiptsUrl;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler!', 'Ok');
                    }
                }
                else {
                    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    Utils.ConsoleLog("ERROR: Webservice GetAppVersion: " + AjaxReturnObject.DebugInfo);
                }
            },
            error: function (response) {

                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice GetAppVersion: " + AjaxReturnObject.ReturnMsg);
                } else {
                    alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                }
            }
        });

    },

    registerNewUser: function (email, salutationId, firstname, lastname, country) {
        if (!this.checkConnection()) {
            return;
        }
        $('#loader_page').show();
        $.mobile.loading('show', {
            text: 'Ihr Account wird eingerichtet.',
            textVisible: true,
            theme: 'a',
        });
        var conditionsAccepted = true;
        SyncController.registerUser(email, salutationId, firstname, lastname, country, conditionsAccepted);
    },

    registerUser: function (email, salutationId, firstname, lastname, country, conditionsAccepted) {
        if (!this.checkConnection()) {
            return;
        }
        var moduleBundleId = localStorage.getItem("moduleBundle");
        if (moduleBundleId == "" || moduleBundleId == null) {
            moduleBundleId = 0;
        }
        $.ajax({
            type: "POST",
            url: window.appVersion.attributes.WsMainUrl + "account/register",
            data: {
                UserName: email,
                Password: 'tmp_pw',
                ConfirmPassword: 'tmp_pw',
                Salutation: salutationId,
                Firstname: firstname,
                Lastname: lastname,
                Country: country,
                Language: (navigator.language) ? navigator.language : navigator.userLanguage,
                AcceptedAgbs: conditionsAccepted,
                MandatorId: CONSTS.GUID_DEFAULT,
                ModuleBundleId: moduleBundleId,
            },
            success: function (AjaxReturnObject) {

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var userRawElement = new window.UserRawElement($.parseJSON(AjaxReturnObject.ReturnValues).UserRawElement);
                    userRawElement.save();
                    setCurrentUser(userRawElement);
                    SyncController.validateDeviceInitial(userRawElement.attributes.Email, userRawElement.attributes.Password, true);
                }
                else {
                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    $.mobile.loading('hide');
                    $('#loader_page').hide();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice RegisterUser: " + AjaxReturnObject.ReturnMsg);
                    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                } else {
                    alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                }
                $.mobile.loading('hide');
                $('#loader_page').hide();
            }
        });

    },

    validateDeviceInitial: function (email, password, isInitial) {
        var ok = false;

        if (!this.checkConnection()) {
            return;
        }

        if (isInitial == null) {
            isInitial = false;
        }

        var devObj = new window.DeviceRawElement();
        devObj.attributes.DeviceId = window.generateGuid();
        devObj.attributes.PhoneId = window.deviceId;
        devObj.attributes.AppVersion = window.appVersion.attributes.AppVersion;
        devObj.attributes.DevicePlatform = window.devicePlatform;
        var usrObj = new window.UserRawElement();
        if (window.currentUser) {
            usrObj = new window.UserRawElement(window.currentUser);
        }

        if (usrObj.attributes.LanguageCode == null || usrObj.attributes.LanguageCode.length < 1) {
            usrObj.attributes.LanguageCode = (navigator.language) ? navigator.language : navigator.userLanguage;
        }

        usrObj.attributes.PhoneId = window.deviceId;
        usrObj.attributes.DevicePlatform = window.devicePlatform;
        usrObj.attributes.Email = email;
        usrObj.attributes.Password = password;

        //var usrJSON = usrObj.toJSON();
        var devJSON = devObj.toJSON();

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'devices/ValidateDeviceInitial',
            type: 'POST',
            async: true,
            data: {
                DeviceElement: devObj.toJSON(),
                UserElement: usrObj.toJSON(),
                IsInitial: isInitial,
            },
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice ValidateUserInitial: " + JSON.stringify(AjaxReturnObject));
                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var userRawElement = new window.UserRawElement($.parseJSON(AjaxReturnObject.ReturnValues).UserRawElement);
                    userRawElement.attributes.StatusId = 0;
                    userRawElement.save();
                    setCurrentUser(userRawElement);

                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);

                    if ($('#SynchronizeData').val() == 'on') {
                        window.localStorage.setItem('synchronizeData', true);
                    } else {
                        window.localStorage.setItem('synchronizeData', false);
                    }

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        alert(AjaxReturnObject.ReturnMsg);//, null, 'Fehler', 'Ok');
                    }
                    $.mobile.loading('hide');
                    $('#loader_page').hide();
                    $('#SynchronizeData').val('on').slider('refresh');
                    window.localStorage.setItem('synchronizeData', true);
                    setTimeout(SyncController.initialize(), 0);
                }
                else {
                    $.mobile.loading('hide');
                    $('#loader_page').hide();
                    window.localStorage.setItem('synchronizeData', false);
                    $('#SynchronizeData').val('off').slider('refresh');
                    Utils.ConsoleLog("ERROR: Webservice ValidateUserInitial: " + AjaxReturnObject.DebugInfo);
                    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice ValidateUserInitial: " + AjaxReturnObject.ReturnMsg);
                    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                } else {
                    alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                }
                $.mobile.loading('hide');
                $('#loader_page').hide();
                window.localStorage.setItem('synchronizeData', false);
                $('#SynchronizeData').val('off').slider('refresh');
            }
        });
    },

    resetDeviceEntities: function () {

        var ok = false;

        if (!this.checkConnection()) {
            return;
        }

        var devObj = new window.DeviceRawElement();
        var usrObj = new window.UserRawElement();

        if (window.currentUser) {
            usrObj = new window.UserRawElement(window.currentUser);
        } else {
            $.mobile.loading('hide');
            $('#loader_page').hide();
            alert('Sie sind nicht angemeldet!');
            return ok;
        }

        if (window.currentUser) {
            devObj = new window.DeviceRawElement(window.currentDevice);
        } else {
            $.mobile.loading('hide');
            $('#loader_page').hide();
            alert('Sie sind nicht angemeldet!');
            return ok;
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'devices/ResetDeviceEntities',
            type: 'POST',
            async: true,
            data: {
                DeviceElement: devObj.toJSON(),
                UserElement: usrObj.toJSON(),
            },
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice ValidateUserInitial: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    $.mobile.loading('hide');
                    $('#loader_page').hide();
                    $('#SynchronizeData').val('on').slider('refresh');
                    window.localStorage.setItem('synchronizeData', true);
                    setTimeout(SyncController.initialize(), 0);
                }
                else {
                    $.mobile.loading('hide');
                    $('#loader_page').hide();
                    window.localStorage.setItem('synchronizeData', false);
                    $('#SynchronizeData').val('off').slider('refresh');
                    Utils.ConsoleLog("ERROR: Webservice ValidateUserInitial: " + AjaxReturnObject.DebugInfo);
                    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice ValidateUserInitial: " + AjaxReturnObject.ReturnMsg);
                    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                } else {
                    alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                }
                $.mobile.loading('hide');
                $('#loader_page').hide();
                window.localStorage.setItem('synchronizeData', false);
                $('#SynchronizeData').val('off').slider('refresh');
            }
        });
    },

    sendFeedback: function (execAsync) {

        if (!this.checkConnection()) {
            return;
        }

        if (execAsync == null) {
            execAsync = true;
        }

        var uploads = _.filter(
            window.feedbacks.models,
            function (obj) { return (obj.toBeSynchronized()); }
        );

        _.each(
            uploads,
            function (obj) {

                var feedback = new window.FeedbackRawElement();
                var svcWrapper = {};

                obj.attributes.MandatorId = window.currentUser.MandatorId;
                obj.attributes.OrgUnitId = window.currentUser.OrgUnitId;
                obj.attributes.LiveId = window.currentUser.LiveId;
                obj.attributes.PhoneId = window.currentUser.PhoneId;
                obj.attributes.UserId = window.currentUser.UserId;

                //Utils.ConsoleLog(svcWrapper);

                $.ajax({
                    url: '/action/api/feedbacks/SendFeedback',
                    data: obj.toJSON(),
                    async: execAsync,
                    success: function (AjaxReturnObject) {
                        //Utils.ConsoleLog("INFO: Webservice SendFeedback: " + JSON.stringify(AjaxReturnObject));

                        if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                            // update sync time for all uploads (and downloads)
                            _.each(
                                uploads,
                                function (obj) {
                                    obj.attributes.SyncTime = moment().toDate();
                                    obj.save();
                                }
                            );

                            // show warning, if occured
                            if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                                alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                            }

                            Utils.ConsoleLog("INFO: Webservice SendFeedback: SUCCESS: " + AjaxReturnObject.ReturnMsg);
                        }
                        else {
                            alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                            Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.DebugInfo);
                        }
                    },
                    error: function (response) {
                        if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                            var AjaxReturnObject = $.parseJSON(response.responseText);
                            Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                        } else {
                            alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                        }
                    }
                });
            }
        );
    },

    synchronize: function () {
        this.sendFeedback(true);
        this.syncData();
        this.syncConfiguration();
    },

    updateApplication: function () {

        var appCache = window.applicationCache;
        var status;

        switch (appCache.status) {
            case appCache.UNCACHED: // UNCACHED == 0
                status = 'UNCACHED';
                break;
            case appCache.IDLE: // IDLE == 1
                status = 'IDLE';
                break;
            case appCache.CHECKING: // CHECKING == 2
                status = 'CHECKING';
                break;
            case appCache.DOWNLOADING: // DOWNLOADING == 3
                status = 'DOWNLOADING';
                break;
            case appCache.UPDATEREADY:  // UPDATEREADY == 4
                status = 'UPDATEREADY';
                break;
            case appCache.OBSOLETE: // OBSOLETE == 5
                status = 'OBSOLETE';
                break;
            default:
                status = 'UKNOWN CACHE STATUS';
                break;
        };

        Utils.ConsoleLog("INFO: Application Cache Status: " + status);

        if (appCache.status != window.applicationCache.UNCACHED) {
            Utils.ConsoleLog("INFO: Application Cache: Start update ");
            appCache.update(); // Attempt to update the user's cache.
        }

        //if (window.applicationCache.status != window.applicationCache.UNCACHED) {
        //    window.applicationCache.update(); // Attempt to update the user's cache.
        //}
    },


    syncNext: function () {
        //this.SyncQueue = jQuery.unique(this.SyncQueue);

        if (localStorage.getItem('LoadConfig') != null && localStorage.getItem('LoadConfig') == 1) {
            localStorage.setItem('LoadConfig', 0);
            this.SyncQueue.push({ Type: 'GenericViewActions', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'GenericViews', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'GenericViewFields', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'GenericEntities', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'GenericProperties', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'GenericViewFilters', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'GenericValidation', Manually: false, Async: true });
            this.SyncQueue.push({ Type: 'Users', Manually: false, Async: true });
        }
        if (this.SyncQueue.length > 0) {
            if (!SyncController.SyncIsRunning) {
                if (SyncController.SyncCancelTimer != null) {
                    window.clearTimeout(SyncController.SyncCancelTimer);
                    SyncController.SyncCancelTimer = null;
                }
                SyncController.SyncIsRunning = true;
                var syncParams = this.SyncQueue[0];
                switch (syncParams.Type) {
                    case 'Attachments':
                        SyncController.synchronizeAttachments(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncQueue.removeValue('Type', 'Attachments');
                                SyncController.SyncIsRunning = false;
                                SyncController.syncNext();

                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type);
                        break;
                    case 'Users':
                        SyncController.synchronizeUsers(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncQueue.removeValue('Type', 'Users');
                                SyncController.SyncIsRunning = false;
                                SyncController.syncNext();

                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type);
                        break;
                    case 'GenericViewActions':
                        SyncController.synchronizeGenericViewActions(syncParams.Async, syncParams.Manually,
                            function () {
                                /*SyncController.SyncQueue.removeValue('Type', 'GenericViewActions');
                                SyncController.syncNext();*/
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_VIEW_ACTIONS, 'GenericViewActions');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericViews':
                        SyncController.synchronizeGenericViews(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_VIEWS, 'GenericViews');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericViewFields':
                        SyncController.synchronizeGenericViewFields(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_VIEW_FIELDS, 'GenericViewFields');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericEntities':
                        SyncController.synchronizeGenericEntities(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_ENTITIES, 'GenericEntities');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericProperties':
                        SyncController.synchronizeGenericProperties(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_PROPERTIES, 'GenericProperties');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericViewFilters':
                        SyncController.synchronizeGenericViewFilters(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_VIEW_FILTERS, 'GenericViewFilters');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericValidation':
                        SyncController.synchronizeGenericValidation(syncParams.Async, syncParams.Manually,
                            function () {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(CONSTS.GENERIC_ENTITY_ID_VALIDATION, 'GenericValidation');
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_CONFIG, syncParams.Type, syncParams.Manually);
                        break;
                    case 'GenericData':
                        SyncController.synchronizeGenericData(syncParams.Async, syncParams.Manually,
                            function (lastEntityId, HandleID) {
                                SyncController.SyncIsRunning = false;
                                SyncController.synchronizeConfirm(lastEntityId, 'GenericData', HandleID);
                                if (syncParams.Callback) {
                                    syncParams.Callback();
                                }
                            });
                        SyncController.syncCancelTimer(CONSTS.TIMEOUT_GDATA, syncParams.Type, syncParams.Manually);
                        break;
                    default:
                }
            }
        } else {
            if (SyncController.SyncCancelTimer != null) {
                window.clearTimeout(SyncController.SyncCancelTimer);
                SyncController.SyncCancelTimer = null;
                SyncController.SyncIsRunning = false;
            }
            setTimeout(function () { SyncController.dataRetention(); }, 5000);
            //AFTER SYNC
            ActionHelper.globalAfterSync();
            SystemCommands.Execute();
            SyncController.Execute_UserChangeTracking();





            $('#loader_page').hide();
            $.mobile.loading('hide');
            if (this.Initialize) {
                this.Initialize = false;
                window.app.navigate("/moduleView", { trigger: true });
            }



            SyncController.checkSync();
        }
    },
    
    checkSync: function () {
        var syncStatusButton = $('#sync_status_button');
        if (syncStatusButton != undefined) {
            var syncedCount = _.filter(window.genericData.models, function (model) {
                return (model.toBeSynchronized());
            }).length;

            syncStatusButton.text(syncedCount);

            if (syncedCount > 0) {
                syncStatusButton.css('background-color', '#BB0000');
            } else {
                syncStatusButton.css('background-color', 'green');
            }
        }
        if (!SyncController.SyncIsRunning) {
            var uploadData_tmp = _.filter(
            window.genericData.models,
            function (obj) {
                var sync = obj.toBeSynchronized() && obj.attributes.EntityId == CONSTS.ATTACHEMENTS_ENTITY_ID;
                return (sync);
            });
            if (uploadData_tmp.length > 0) {
                SyncController.SyncQueue.push({ Type: 'GenericData', Manually: false, Async: true });
                SyncController.syncNext();
            }
        }
    },

    getNotSyncedItemsCount: function (entity) {
        var uploadData = _.filter(
                window.genericData.models,
                function (obj) {
                    var sync = obj.toBeSynchronized() && (entity == undefined || entity == obj.attributes.EntityId);
                    return (sync);
                }
            );
        var syncedCount = uploadData.length;
        return syncedCount;
    },

    syncCancelTimer: function (time, type, manually) {
        SyncController.SyncCancelTimer = setTimeout(function () {
            SyncController.SyncQueue.removeValue('Type', type);
            SyncIsRunning = false;
            if (SyncController.SyncQueue.length > 0) {
                SyncController.syncNext();
            } else {
                SyncController.SyncIsRunning = false;
                if (manually) {
                    showMessage('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                }
                $('#loader_page').hide();
                $.mobile.loading('hide');
            }
        }, time);
    },

    initialize: function () {
        if (!this.checkConnection(true, true)) {
            return;
        }

        $('#loader_page').show();
        $.mobile.loading('show', {
            text: 'App wird initialisiert',
            textVisible: true,
            theme: 'a',
        });

        var manually = true;

        SyncController.SyncQueue.push({ Type: 'GenericViewActions', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericViews', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericViewFields', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericEntities', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericProperties', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericViewFilters', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericValidation', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'Users', Manually: true, Async: true });
        SyncController.SyncQueue.push({ Type: 'GenericData', Manually: true, Async: true });
        SyncController.syncNext();
        SyncController.Initialize = true;
    },

    syncData: function (manually, callback) {
        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            return;
        }

        if (!manually && SyncController.LastSync != undefined && SyncController.SyncIsRunning && moment().subtract('seconds', 30).toDate() < SyncController.LastSync)
            return;

        SyncController.SyncQueue = new Array();
        SyncController.SyncIsRunning = false;
        SyncController.syncNext();

        //check if we have connection
        if (!this.checkConnection(undefined, manually)) {
            return;
        }

        //if (this.SyncQueue.length < 1) {
        if (manually) {
            $('#loader_page').show();
            $.mobile.loading('show', {
                text: 'Lade Daten',
                textVisible: true,
                theme: 'a',
            });
        }
        //SyncController.syncCancelTimer(CONSTS.TIMEOUT_GDATA);
        if (!manually) {
            SyncController.SyncQueue.push({
                Type: 'GenericData', Manually: false, Async: true, Callback: function () {
                    ActionHelper.globalAfterSync();
                    SyncController.SyncIsRunning = false;
                }
            });
            if (SyncController.getUnsyncedAttachmentCount() > 0) {
                SyncController.SyncQueue.push({ Type: 'Attachments', Manually: false, Async: true })
            }
            else
                SyncController.SyncQueue.removeValue('Type', 'Attachments');
            SyncController.syncNext();
        } else {
            SyncController.SyncQueue.push({
                Type: 'GenericData', Manually: true, Async: true, Callback: function () {
                    if (callback != null) callback();
                    SyncController.SyncIsRunning = false;
                }
            });
            SyncController.syncNext();
        }
    },

    syncConfiguration: function (manually) {
        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            return;
        }

        //check if we have connection
        if (!this.checkConnection(undefined, manually)) {
            return;
        }
        //if (this.SyncQueue < 1) {
        if (manually) {
            $('#loader_page').show();
            $.mobile.loading('show', {
                text: 'Lade Daten',
                textVisible: true,
                theme: 'a',
            });
        }
        this.SyncQueue.push({ Type: 'GenericViewActions', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'GenericViews', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'GenericViewFields', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'GenericEntities', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'GenericProperties', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'GenericViewFilters', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'GenericValidation', Manually: true, Async: true });
        this.SyncQueue.push({ Type: 'Users', Manually: true, Async: true });
        this.syncNext();
        this.updateApplication();
    },

    synchronizeConfirm: function (lastEntityId, syncType, HandleId) {
        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }
        svcWrapper.LastEntityId = lastEntityId;
        svcWrapper.HandleId = HandleId;


        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericData/ConfirmSync',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: true,
            success: function (AjaxReturnObject) {
                SyncController.SyncQueue.removeValue('Type', syncType);
                //hier müsste man noch ein Objekt einfügen wenn zuvor der Sync Menge <> 0 hatte.... aber wie das herausfinden --> aufrufkette
                //sync --> getSyncAnswer --> if success confirmSync --> getcCnfirmSyncAnswer --> nun sind wir hier..

                if ((syncType == 'GenericData' && globalStatus('SYNC_LAST_DOWNLOAD_COUNT') > 1)
                || (syncType == 'GenericData' && globalStatus('SYNC_LAST_UPLOAD_COUNT') > 1)) {
                    SyncController.SyncQueue.push({ Type: 'GenericData', Manually: false, Async: true });
                }
                SyncController.syncNext();
                Utils.ConsoleLog("SUCCESS: Confirm Sync OK.");
            },
            error: function (response) {
                SyncController.SyncQueue.removeValue('Type', syncType);
                SyncController.syncNext();
                Utils.ConsoleLog("ERROR: Confirm Sync FAILED.");
            },
        });

    },

    synchronizeUsers: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            if (callback) {
                callback();
            }
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'users/SynchronizeUsers',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            success: function (AjaxReturnObject) {

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedUserRawElements;

                    _.each(
                        downloads,
                        function (downloadObj) {
                            var isNew = false;
                            var obj = window.userRawElementEntries.get(downloadObj.UserId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.UserRawElement();
                                obj.id = downloadObj.UserId;
                            }

                            obj.attributes.UserId = downloadObj.UserId;
                            obj.attributes.MandatorId = downloadObj.MandatorId;
                            obj.attributes.OrgUnitId = downloadObj.OrgUnitId;
                            obj.attributes.PhoneId = downloadObj.PhoneId;
                            obj.attributes.DevicePlatform = downloadObj.DevicePlatform;
                            obj.attributes.LiveId = downloadObj.LiveId;
                            obj.attributes.SalutationId = downloadObj.SalutationId;
                            obj.attributes.Lastname = downloadObj.Lastname;
                            obj.attributes.Firstname = downloadObj.Firstname;
                            obj.attributes.Company = downloadObj.Company;
                            obj.attributes.Street = downloadObj.Street;
                            obj.attributes.HouseNo = downloadObj.HouseNo;
                            obj.attributes.ZipCode = downloadObj.ZipCode;
                            obj.attributes.City = downloadObj.City;
                            obj.attributes.CountryCode = downloadObj.CountryCode;
                            obj.attributes.Phone = downloadObj.Phone;
                            obj.attributes.Fax = downloadObj.Fax;
                            obj.attributes.Email = downloadObj.Email;
                            obj.attributes.StatusId = downloadObj.StatusId;
                            obj.attributes.RegisterDate = downloadObj.RegisterDate;
                            obj.attributes.ActivationDate = downloadObj.ActivationDate;
                            obj.attributes.DeactivationDate = downloadObj.DeactivationDate;

                            obj.attributes.DisplayName = obj.attributes.Lastname + ', ' + obj.attributes.Firstname;

                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();

                            //obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.userRawElementEntries.add(obj);
                            }
                            obj = null;

                        }
                    );

                    //if (downloads.length > 0) {
                    //    // workaround for the memory leak while saving to local storage in loop
                    //    // this method call writes the backbone collection/model to the local storage after processing the loop
                    //    window.persistUserRawElementData();
                    //}

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetUsers: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);

                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("ERROR: Webservice GetUsers: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                if (callback) {
                    callback();
                }
            }
        });
    },

    synchronizeAttachmentsWorker: function (execAsync, manually, callback) {
        SyncController.loadFileContents();
        if (callback)
            callback();

        //var Attachment = _.first(genericData.where({ IsActive: true, EntityId: CONSTS.ATTACHEMENTS_ENTITY_ID, Custom_020: undefined }));

        //if (Attachment != undefined)
        //{
        //    SyncController.LoadAttachment(Attachment.id);
        //    SyncController.SyncIsRunning = false;
        //    SyncController.syncNext();
        //}
        //else {
        //    SyncController.SyncQueue.removeValue('Type', 'Attachments');
        //    SyncController.SyncIsRunning = false;
        //    SyncController.syncNext();
        //}

        //function () {


        //}

        //alert('Attachments for download:' + Attachments.length);

    },

    synchronizeAttachments: function (execAsync, manually, callback) {
        if (manually) {
            SyncController.synchronizeAttachmentsWorker(execAsync, manually, callback);
        }
        else {
            setTimeout(function () {
                SyncController.synchronizeAttachmentsWorker(execAsync, manually, callback);
            }
            , 0);
        }
    },

    synchronizeGenericViews: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericViews');
            SyncController.SyncIsRunning = false;
            SyncController.syncNext();
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericViews/SynchronizeGenericViews',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericViewRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {
                            //Utils.ConsoleLog(downloadObj);

                            //var obj = new window.NewsRawElement(downloadObj);
                            //obj.id = downloadObj.NewsId;
                            //obj.save();

                            var isNew = false;
                            var obj = window.genericViews.get(downloadObj.ViewId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericViewRawElement();
                                obj.id = downloadObj.ViewId;
                            }

                            obj.attributes.ViewId = downloadObj.ViewId;
                            obj.attributes.EntityId = downloadObj.EntityId;
                            obj.attributes.ViewName = downloadObj.ViewName;
                            obj.attributes.ViewType = downloadObj.ViewType;
                            obj.attributes.IsMobileEntity = downloadObj.IsMobileEntity;
                            obj.attributes.IsTopLevel = downloadObj.IsTopLevel;
                            obj.attributes.IsMobile = downloadObj.IsMobile;
                            obj.attributes.IconCode = downloadObj.IconCode;
                            obj.attributes.IsDefault = downloadObj.IsDefault;
                            obj.attributes.SortPropertyId = downloadObj.sortPropertyId;
                            obj.attributes.SortJs = downloadObj.SortJs
                            obj.attributes.SortDesc = downloadObj.SortDesc;
                            obj.attributes.MenuSortNumber = downloadObj.MenuSortNumber;
                            obj.attributes.CustomRoute = downloadObj.CustomRoute;
                            obj.attributes.IsActive = downloadObj.IsActive;
                            obj.attributes.Param01 = downloadObj.Param01;

                            obj.attributes.SelectableFieldCount = downloadObj.SelectableFieldCount;
                            obj.attributes.MultiEditSaveOnlyEdits = downloadObj.MultiEditSaveOnlyEdits;
                            obj.attributes.RemoveLabesFromListView = downloadObj.RemoveLabesFromListView;
                            obj.attributes.StartSearchImmediately = downloadObj.StartSearchImmediately;

                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();


                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericViews.add(obj);
                            }

                            if (!downloadObj.IsActive) {
                                window.genericViews.remove(obj);
                                obj.destroy();
                            }

                        }
                    );


                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericViewsData();

                    }

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericViews: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);

                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericViews: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncQueue.removeValue('Type', 'GenericViews');
                SyncController.syncNext();
            }
        });
    },

    synchronizeGenericViewFields: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericViewFields');
            SyncController.SyncIsRunning = false;
            SyncController.syncNext();
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericViewFields/SynchronizeGenericViewFields',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericViewFieldRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {
                            //Utils.ConsoleLog(downloadObj);

                            //var obj = new window.NewsRawElement(downloadObj);
                            //obj.id = downloadObj.NewsId;
                            //obj.save();

                            var isNew = false;
                            var obj = window.genericViewFields.get(downloadObj.FieldId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericViewFieldRawElement();
                                obj.id = downloadObj.FieldId;
                            }

                            obj.attributes.FieldId = downloadObj.FieldId;
                            obj.attributes.ViewId = downloadObj.ViewId;
                            obj.attributes.PropertyId = downloadObj.PropertyId;
                            obj.attributes.SortPosition = downloadObj.SortPosition;
                            obj.attributes.IsReadonly = downloadObj.IsReadonly;
                            obj.attributes.DefaultValue = downloadObj.DefaultValue;
                            obj.attributes.DefaultValueLookupPropertyId = downloadObj.DefaultValueLookupPropertyId;
                            obj.attributes.IsLogicalKey = downloadObj.IsLogicalKey;
                            obj.attributes.IsActive = downloadObj.IsActive;
                            obj.attributes.DisplayProperty1 = downloadObj.DisplayProperty1;
                            obj.attributes.DisplayProperty2 = downloadObj.DisplayProperty2;
                            obj.attributes.DisplayProperty3 = downloadObj.DisplayProperty3;
                            obj.attributes.ViewFieldLabel = downloadObj.ViewFieldLabel;
                            obj.attributes.DropDownFilterJS = downloadObj.DropDownFilterJS;
                            obj.attributes.VisibleJS = downloadObj.VisibleJS;
                            obj.attributes.OnChangeJS = downloadObj.OnChangeJS;
                            obj.attributes.UseForMasterSearch = downloadObj.UseForMasterSearch;
                            obj.attributes.ToolTip = downloadObj.ToolTip;
                            obj.attributes.PropertyStyleField = downloadObj.PropertyStyleField;
                            obj.attributes.AssociatedViewField = downloadObj.AssociatedViewField;
                            obj.attributes.TakeOverOnCopy = downloadObj.TakeOverOnCopy;
                            obj.attributes.RequiredField = downloadObj.RequiredField;
                            obj.attributes.CssClass = downloadObj.CssClass;


                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();

                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericViewFields.add(obj);
                            }

                            if (!downloadObj.IsActive) {
                                window.genericViewFields.remove(obj);
                                obj.destroy();
                            }

                            obj = null;

                        }
                    );


                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericViewFieldsData();

                    }

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericViewFields: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);

                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericViewFields: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncQueue.removeValue('Type', 'GenericViewFields');
                SyncController.SyncIsRunning = false;
                SyncController.syncNext();
            }
        });
    },

    synchronizeGenericEntities: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericEntities');
            SyncController.syncNext();
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericEntities/SynchronizeGenericEntities',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericEntityRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {
                            //Utils.ConsoleLog(downloadObj);

                            //var obj = new window.NewsRawElement(downloadObj);
                            //obj.id = downloadObj.NewsId;
                            //obj.save();

                            var isNew = false;
                            var obj = window.genericEntities.get(downloadObj.EntityId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericEntityRawElement();
                                obj.id = downloadObj.EntityId;
                            }

                            obj.attributes.EntityId = downloadObj.EntityId;
                            obj.attributes.EntityName = downloadObj.EntityName;
                            obj.attributes.ModuleId = downloadObj.ModuleId;
                            obj.attributes.AttachmentsAllowed = downloadObj.AttachmentsAllowed;
                            obj.attributes.IconCode = downloadObj.IconCode;
                            obj.attributes.DisplayPropertyId = downloadObj.DisplayPropertyId;
                            obj.attributes.SortPropertyId = downloadObj.SortPropertyId;
                            obj.attributes.IsSystemEntity = downloadObj.IsSystemEntity;
                            obj.attributes.EntityOrgId = downloadObj.EntityOrgId;
                            obj.attributes.IsMobileEntity = downloadObj.IsMobileEntity;
                            obj.attributes.IsCachedOffline = downloadObj.IsCachedOffline;
                            obj.attributes.RetentionPropertyId = downloadObj.RetentionPropertyId;
                            obj.attributes.RetentionDays = downloadObj.RetentionDays;
                            obj.attributes.SyncSort = downloadObj.SyncSort;
                            obj.attributes.SortDesc = downloadObj.SortDesc;
                            obj.attributes.SortJs = downloadObj.SortJs;
                            obj.attributes.RetentionJS = downloadObj.RetentionJS;
                            obj.attributes.ParentRetentionPropertyId = downloadObj.ParentRetentionPropertyId;

                            obj.attributes.IsActive = downloadObj.IsActive;
                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();

                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericEntities.add(obj);
                            }

                            if (!downloadObj.IsActive) {
                                window.genericEntities.remove(obj);
                                obj.destroy();
                            }
                            obj = null;
                        }
                    );

                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericEntitiesData();

                    }

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericEntities: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericEntities: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncQueue.removeValue('Type', 'GenericEntities');
                SyncController.SyncIsRunning = false;
                SyncController.syncNext();
            }
        });
    },

    synchronizeGenericProperties: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericProperties');
            SyncController.syncNext();
            return;
        }
        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericProperties/SynchronizeGenericProperties',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericPropertyRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {
                            //Utils.ConsoleLog(downloadObj);

                            //var obj = new window.NewsRawElement(downloadObj);
                            //obj.id = downloadObj.NewsId;
                            //obj.save();

                            var isNew = false;
                            var obj = window.genericProperties.get(downloadObj.PropertyId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericPropertyRawElement();
                                obj.id = downloadObj.PropertyId;
                            }

                            obj.attributes.PropertyId = downloadObj.PropertyId;
                            obj.attributes.EntityId = downloadObj.EntityId;
                            obj.attributes.PropertyName = downloadObj.PropertyName;
                            obj.attributes.PropertyReportName = downloadObj.PropertyReportName;
                            obj.attributes.DataType = downloadObj.DataType;
                            obj.attributes.Size = downloadObj.Size;
                            obj.attributes.Precision = downloadObj.Precision;
                            obj.attributes.Scale = downloadObj.Scale;
                            obj.attributes.LookupEntityId = downloadObj.LookupEntityId;
                            obj.attributes.IsIndexed = downloadObj.IsIndexed;
                            obj.attributes.GenericColumnName = downloadObj.GenericColumnName;
                            obj.attributes.ToolTip = downloadObj.ToolTip;
                            obj.attributes.PropertyStyleField = downloadObj.PropertyStyleField;
                            obj.attributes.AutoCompleteGroup = downloadObj.AutoCompleteGroup;
                            obj.attributes.IsActive = downloadObj.IsActive;
                            obj.attributes.Param_01 = downloadObj.Param_01;
                            obj.attributes.RequiredField = downloadObj.RequiredField;
                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();

                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericProperties.add(obj);
                            }
                            if (!downloadObj.IsActive) {
                                window.genericProperties.remove(obj);
                                obj.destroy();
                            }
                            obj = null;

                        }
                    );

                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericPropertiesData();

                    }


                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericProperties: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericProperties: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncQueue.removeValue('Type', 'GenericProperties');
                SyncController.syncNext();
            }
        });
    },

    synchronizeGenericValidation: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericValidation');
            SyncController.SyncIsRunning = false;
            SyncController.syncNext();
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericValidation/SynchronizeGenericValidation',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericValidationRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {
                            //Utils.ConsoleLog(downloadObj);

                            //var obj = new window.NewsRawElement(downloadObj);
                            //obj.id = downloadObj.NewsId;
                            //obj.save();

                            var isNew = false;
                            var obj = window.genericValidation.get(downloadObj.ValidationId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericValidationRawElement();
                                obj.id = downloadObj.ValidationId;
                            }

                            obj.attributes.ValidationId = downloadObj.ValidationId;
                            obj.attributes.ViewId = downloadObj.ViewId;
                            obj.attributes.ValidationType = downloadObj.ValidationType;
                            obj.attributes.Value_01 = downloadObj.Value_01;
                            obj.attributes.Value_02 = downloadObj.Value_02;
                            obj.attributes.Value_03 = downloadObj.Value_03;
                            obj.attributes.Value_04 = downloadObj.Value_04;
                            obj.attributes.Value_05 = downloadObj.Value_05;
                            obj.attributes.Value_06 = downloadObj.Value_06;
                            obj.attributes.Comment = downloadObj.Comment;
                            obj.attributes.IsActive = downloadObj.IsActive;

                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();
                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericValidation.add(obj);
                            }
                            if (!downloadObj.IsActive) {
                                window.genericValidation.remove(obj);
                                obj.destroy();
                            }
                            obj = null;

                        }
                    );

                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericValidationsData();

                    }

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericValidation: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericValidation: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncQueue.removeValue('Type', 'GenericValidation');
                SyncController.SyncIsRunning = false;
                SyncController.syncNext();
            }
        });
    },

    synchronizeGenericViewActions: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericViewActions');
            SyncController.SyncIsRunning = false;
            SyncController.syncNext();
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericViewActions/SynchronizeGenericViewActions',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericViewActionRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {

                            var isNew = false;
                            var obj = window.genericViewActions.get(downloadObj.ViewActionId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericViewActionRawElement();
                                obj.id = downloadObj.ViewActionId;
                            }

                            obj.attributes.ViewActionId = downloadObj.ViewActionId;
                            obj.attributes.ViewId = downloadObj.ViewId;
                            obj.attributes.ActionName = downloadObj.ActionName;
                            obj.attributes.IconName = downloadObj.IconName;
                            obj.attributes.ActionType = downloadObj.ActionType;
                            obj.attributes.MinRightLevelId = downloadObj.ActionType;
                            obj.attributes.CommandName = downloadObj.CommandName;
                            obj.attributes.Event = downloadObj.Event;
                            obj.attributes.Selector = downloadObj.Selector;
                            obj.attributes.SortPosition = downloadObj.SortPosition;
                            obj.attributes.RedirectViewId = downloadObj.RedirectViewId;
                            obj.attributes.RedirectHistory = downloadObj.RedirectHistory;
                            obj.attributes.Param_01 = downloadObj.Param_01;
                            obj.attributes.Param_02 = downloadObj.Param_02;
                            obj.attributes.Param_03 = downloadObj.Param_03;
                            obj.attributes.Param_04 = downloadObj.Param_04;
                            obj.attributes.Param_05 = downloadObj.Param_05;
                            obj.attributes.RefActionId = downloadObj.RefActionId;
                            obj.attributes.ConfirmMessageText = downloadObj.ConfirmMessageText;
                            obj.attributes.SelectableFieldCount = downloadObj.SelectableFieldCount;
                            obj.attributes.IsVisible = downloadObj.IsVisible;
                            obj.attributes.IsActive = downloadObj.IsActive;
                            obj.attributes.CssClass = downloadObj.CssClass;

                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();

                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericViewActions.add(obj);
                            }

                            if (!downloadObj.IsActive) {
                                window.genericViewActions.remove(obj);
                                obj.destroy();
                            }

                            obj = null;

                        }
                    );

                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericViewActionsData();

                    }

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericViewAction: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericViewAction: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncQueue.removeValue('Type', 'GenericViewActions');
                SyncController.SyncIsRunning = false;
                SyncController.syncNext();
            }
        });
    },

    synchronizeGenericViewFilters: function (execAsync, manually, callback) {

        var that = this;

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncQueue.removeValue('Type', 'GenericViewFilters');
            SyncController.SyncIsRunning = false;
            SyncController.syncNext();
            return;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericViewFilters/SynchronizeGenericViewFilters',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            async: execAsync,
            timeout: CONSTS.TIMEOUT_CONFIG,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice GetNews: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);
                    // save downloads
                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericViewFilterRawElements;
                    //Utils.ConsoleLog(downloads);

                    _.each(
                        downloads,
                        function (downloadObj) {
                            //Utils.ConsoleLog(downloadObj);

                            //var obj = new window.NewsRawElement(downloadObj);
                            //obj.id = downloadObj.NewsId;
                            //obj.save();

                            var isNew = false;
                            var obj = window.genericViewFilters.get(downloadObj.ViewFilterId);
                            if (!obj) {
                                isNew = true;
                                obj = new window.GenericViewFilterRawElement();
                                obj.id = downloadObj.ViewFilterId;
                            }

                            obj.attributes.FilterId = downloadObj.FilterId;
                            obj.attributes.ViewId = downloadObj.ViewId;
                            obj.attributes.PropertyId = downloadObj.PropertyId;
                            obj.attributes.LookupPropertyId = downloadObj.LookupPropertyId;
                            obj.attributes.SortPosition = downloadObj.SortPosition;
                            obj.attributes.IsNegated = downloadObj.IsNegated;
                            obj.attributes.Operator = downloadObj.Operator;
                            obj.attributes.DefaultValue = downloadObj.DefaultValue;
                            obj.attributes.IsVisible = downloadObj.IsVisible;
                            obj.attributes.IsReadonly = downloadObj.IsReadonly;
                            obj.attributes.IsActive = downloadObj.IsActive;

                            obj.attributes.CreatedBy = downloadObj.CreatedBy;
                            obj.attributes.ModifiedBy = downloadObj.ModifiedBy;
                            obj.attributes.CreatedDate = moment(downloadObj.CreatedDate).toDate();
                            obj.attributes.ModifiedDate = moment(downloadObj.ModifiedDate).toDate();
                            obj.attributes.TriggerStamp = moment(downloadObj.TriggerStamp).toDate();

                            obj.PersistToLocalStorageImmediately = false;

                            obj.save();

                            if (isNew) {
                                window.genericViewFilters.add(obj);
                            }
                            if (!downloadObj.IsActive) {
                                window.genericViewFilters.remove(obj);
                                obj.destroy();
                            }
                            obj = null;
                        }
                    );

                    if (downloads.length > 0) {

                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop
                        window.persistGenericViewFiltersData();

                    }

                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }

                    Utils.ConsoleLog("INFO: Webservice GetGenericViewFilter: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice GetGenericViewFilter: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback();
                }
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SendFeedback: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncIsRunning = false;
                SyncController.SyncQueue.removeValue('Type', 'GenericViewFilters');
                SyncController.syncNext();
            }
        });
    },

    //sleep: function (millis, execAsync, manually, callback) {
    //    setTimeout(function ()
    //    { SyncController.synchronizeGenericDataWorker(execAsync, manually, callback); }
    //    , millis);
    //},


    //test - Problem das es blockiert??
    synchronizeGenericData: function (execAsync, manually, callback) {
        if (manually) {
            SyncController.synchronizeGenericDataWorker(execAsync, manually, callback);
        }
        else {
            setTimeout(function ()
            { SyncController.synchronizeGenericDataWorker(execAsync, manually, callback); }
            , 0);
        }
    },


    //synchronizeFileUploads: function (fileUploads, manually) {


    synchronizeFileUploads: function (fileUploads, manually, callback) {
        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);
        var currentDevice = window.currentDevice;
        //SyncController.Uploads = fileUploads;
        this.syncFiles = function () {
            if (SyncController.fileUploads[0] == undefined || SyncController.fileUploads[0].CustomMax_001 == undefined || SyncController.fileUploads[0].length == 0) {
                if (SyncController.fileUploads[0] != undefined) {
                    var genericDataElement = _.first(_.filter(genericData.models, function (model) {
                        return model.attributes.ObjectId == SyncController.fileUploads[0].DataId;
                    }));

                    if (genericDataElement != null) {
                        genericDataElement.attributes.IsSync = true;
                        genericDataElement.attributes.IsConflict = false;
                        genericDataElement.attributes.SyncTime = moment().toDate();
                        //genericDataElement.attributes.PersistToLocalStorageImmediately = false;
                        genericDataElement.save();
                    }
                }
                return false;
            }
            $.ajax({
                url: window.appVersion.attributes.WsMainUrl + 'genericData/SynchronizeGenericData',
                data: JSON.stringify(this.svcWrapper),
                contentType: "application/json; charset=utf-8",
                timeout: CONSTS.TIMEOUT_GDATA,
                async: true,
                success: function (AjaxReturnObject, dataid) {

                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS) {// || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        //var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                        var UploadedDataIDs = $.parseJSON(AjaxReturnObject.ReturnValues).UploadedDataIDs;

                        _.each(UploadedDataIDs, function (obj) {
                            var genericDataElement = _.first(_.filter(genericData.models, function (model) {
                                return model.attributes.ObjectId == obj;
                            }));

                            if (genericDataElement != null) {
                                genericDataElement.attributes.IsSync = true;
                                genericDataElement.attributes.IsConflict = false;
                                genericDataElement.attributes.SyncTime = moment().toDate();
                                //genericDataElement.attributes.PersistToLocalStorageImmediately = false;
                                genericDataElement.save();
                            }
                        });
                        //deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                        //deviceRawElement.save();
                        //setCurrentDevice(deviceRawElement);

                        //TODO: Implement download logic for files

                        genericDataElement = null;
                        uploadElement = null;


                        if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                            alert(AjaxReturnObject.ReturnMsg, null, "CONFILCTED SYNCHRONISATION");
                        }
                        Utils.ConsoleLog("INFO: Webservice synchronizeFileUploads: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: -" + " UploadCout: -");
                    } else {
                        Utils.ConsoleLog("ERROR: Webservice synchronizeFileUploads: " + AjaxReturnObject.DebugInfo);
                    }
                    //var uploadData_tmp = _.filter(
                    //window.genericData.models,
                    //function (obj) {
                    //    var sync = obj.toBeSynchronized() && obj.attributes.EntityId == CONSTS.ATTACHEMENTS_ENTITY_ID;
                    //    return (sync);
                    //});
                    //if (uploadData_tmp.length > 0) {
                    //    SyncController.SyncQueue.push({ Type: 'GenericData', Manually: false, Async: true });
                    //}
                },
                error: function (response) {
                    if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                        var AjaxReturnObject = $.parseJSON(response.responseText);
                        if (manually) {
                            showMessage(AjaxReturnObject.ReturnMsg);
                        }
                        Utils.ConsoleLog("ERROR: Webservice synchronizeFileUploads: " + AjaxReturnObject.ReturnMsg);
                    } else {
                        if (manually) {
                            showMessage('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                        }
                    }
                }
            });
            //this.fileUploads = null;
            this.fileHelper = null;
            this.svcWrapper = null;
        }

        this.svcWrapper = {};
        this.svcWrapper.PhoneId = phoneId;
        this.svcWrapper.DeviceElement = {
            DeviceId: currentDevice.DeviceId,
            UserId: currentDevice.UserId,
            PhoneId: currentDevice.PhoneId,
            DevicePlatform: currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: currentDevice.IsActive,
        };
        this.svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }

        this.fileUploads = fileUploads;
        this.fileHelper = FileHelper;
        this.count = fileUploads.length;

        function doNext() {
            if (this.count <= 0) {
                this.svcWrapper.UploadElements = this.fileUploads;
                SyncController.fileUploads = this.svcWrapper.UploadElements;
                this.syncFiles();
            } else {
                this.currentFile = this.fileUploads[this.count - 1];
                //if (window.navigator.notification) { // window.navigator.notification ist nur auf mobilen Geräten present
                if (this.currentFile != null) {
                    if (this.currentFile.IsActive == false) {
                        //DO NOT GET FILE CONTENT FOR INACTIVE ATTACHEMENTS
                        this.currentFile = null;
                        this.count--;
                        $.proxy(doNext, this)();
                    } else {
                        this.fileHelper.loadFile(this.currentFile.DataId, this.currentFile.Custom_001, $.proxy(function (fileContent) {
                            this.fileUploads[this.count - 1].CustomMax_001 = fileContent;
                            //this.svcWrapper.UploadElements = this.fileUploads;
                            //SyncController.fileUploads = this.svcWrapper.UploadElements;
                            //this.syncFiles();
                            //this.currentFile = null;
                            this.count--;
                            $.proxy(doNext, this)();
                        }, this), $.proxy(function (errorCode) {
                            //this.currentFile.CustomMax_001 = '';
                            //this.currentFile = null;
                            this.count--;
                            $.proxy(doNext, this)();
                        }, this));
                    }
                }
                //} else {
                //    //BROWSER TESTING
                //    //this.currentFile.CustomMax_001 = 'DUMMY';
                //    //this.currentFile = null;
                //    this.count--;
                //    $.proxy(doNext, this)();
                //}
            }
        } $.proxy(doNext, this)();
    },

    //synchronizeGenericData: function (execAsync, manually, callback) {




    synchronizeGenericDataAttachmentsWorker: function (execAsync, manually, callback) {
        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncIsRunning = false;
            SyncController.SyncQueue.removeValue('Type', 'GenericData');
            SyncController.syncNext();
            return;
        }

        //if (downloadObj.EntityId == CONSTS.ATTACHEMENTS_ENTITY_ID && downloadObj.Custom_006 != '' && downloadObj.Custom_006 != null) {

        var uploadData_tmp = _.filter(
            window.genericData.models,
            function (obj) {
                var sync = obj.toBeSynchronized() && obj.attributes.EntityId == CONSTS.ATTACHEMENTS_ENTITY_ID;
                return (sync);
            }
        );

        var uploadData = _.first(uploadData_tmp, 1);

        if (uploadData_tmp != null) {
            uploadData_tmp.length = 0;
            uploadData_tmp = null;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);
        var currentDevice = window.currentDevice;
        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: currentDevice.DeviceId,
            UserId: currentDevice.UserId,
            PhoneId: currentDevice.PhoneId,
            DevicePlatform: currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }
        svcWrapper.UploadElements = [];
        var SuperDatum = moment().toDate();

        var FileUploads = [];

        _.each(
            uploadData,
            function (obj) {
                var syncObj = new Object();
                //var syncObj = {};
                for (var attr in obj.attributes) {
                    syncObj[attr] = obj.attributes[attr];
                    //eval('syncObj.' + attr + ' = obj.attributes[attr];');
                }
                syncObj.UserElementAuth = window.currentUser.UserElementAuth;
                if (syncObj.EntityId === CONSTS.ATTACHEMENTS_ENTITY_ID) {
                    this.currentFile = syncObj;
                    //FileHelper.loadFile(this.currentFile.DataId, this.currentFile.Custom_001, function (fileContent) {
                    //    this.currentFile.CustomMax_001 = fileContent;
                    //}, this);
                    FileUploads.push(syncObj);
                    //SyncController.synchronizeFileUploads(FileUploads, manually);

                    //var genericDataElement = _.first(_.filter(genericData.models, function (model) {
                    //    return model.attributes.ObjectId == this.currentFile.DataId;
                    //}));

                    //if (genericDataElement != null) {
                    //    genericDataElement.attributes.IsSync = true;
                    //    genericDataElement.attributes.IsConflict = false;
                    //    genericDataElement.attributes.SyncTime = moment().toDate();
                    //    //genericDataElement.attributes.PersistToLocalStorageImmediately = false;
                    //    genericDataElement.save();
                    //}
                    //genericDataElement = null;
                    //uploadElement = null;

                    //FILE UPLOAD
                    //ATTACHMENT WITH A FILE ATTACHED - NEED TO BE SYNCED IN OWN PROCEDURE

                }

                syncObj = null;
            }
        );

        SyncController.synchronizeFileUploads(FileUploads, manually, callback);
        //if (FileUploads.length > 0) {
        //    setTimeout(function () {
        //        SyncController.synchronizeFileUploads(FileUploads, manually);
        //    }, 100);
        //}



    },
    synchronizeGenericDataWorker: function (execAsync, manually, callback) {

        if (execAsync == null) {
            execAsync = true;
        }

        // check, if synchronization is enabled in settings
        if (window.localStorage.getItem('synchronizeData') == null || !window.localStorage.getItem('synchronizeData').bool()) {
            SyncController.SyncIsRunning = false;
            SyncController.SyncQueue.removeValue('Type', 'GenericData');
            SyncController.syncNext();
            return;
        }
        SyncController.synchronizeGenericDataAttachmentsWorker(execAsync, manually, callback);


        var uploadData_tmp = _.filter(
            window.genericData.models,
            function (obj) {
                var sync = obj.toBeSynchronized() && obj.attributes.EntityId != CONSTS.ATTACHEMENTS_ENTITY_ID;
                return (sync);
            }
        );

        var uploadData = _.first(uploadData_tmp, 100);

        if (uploadData_tmp != null) {
            uploadData_tmp.length = 0;
            uploadData_tmp = null;
        }

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);
        var currentDevice = window.currentDevice;
        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: currentDevice.DeviceId,
            UserId: currentDevice.UserId,
            PhoneId: currentDevice.PhoneId,
            DevicePlatform: currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }
        svcWrapper.UploadElements = [];
        var SuperDatum = moment().toDate();

        var FileUploads = [];

        _.each(
            uploadData,
            function (obj) {
                var syncObj = new Object();
                //var syncObj = {};
                for (var attr in obj.attributes) {
                    syncObj[attr] = obj.attributes[attr];
                    //eval('syncObj.' + attr + ' = obj.attributes[attr];');
                }
                syncObj.UserElementAuth = window.currentUser.UserElementAuth;
                if (syncObj.EntityId === CONSTS.ATTACHEMENTS_ENTITY_ID) {
                    //FILE UPLOAD
                    //ATTACHMENT WITH A FILE ATTACHED - NEED TO BE SYNCED IN OWN PROCEDURE
                    //FileUploads.push(syncObj);
                } else {
                    //NORMAL UPLOAD ELEMENT
                    svcWrapper.UploadElements.push(syncObj);
                }
                syncObj = null;
            }
        );

        //if (FileUploads.length > 0) {
        //    setTimeout(function () {
        //        SyncController.synchronizeFileUploads(FileUploads, manually);
        //    }, 100);
        //}

        SyncController.Uploads = uploadData;

        uploadData = null;

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericData/SynchronizeGenericData',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            timeout: CONSTS.TIMEOUT_GDATA,
            async: execAsync,
            success: function (AjaxReturnObject) {
                var genericData = window.genericData;
                var uploads = SyncController.Uploads;

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    deviceRawElement.save();
                    setCurrentDevice(deviceRawElement);

                    _.each(uploads, function (uploadElement) {
                        if (uploadElement.attributes.IsActive == false) {
                            genericData.remove(uploadElement.id);
                            uploadElement.destroy();
                            uploadElement = null;
                        } else {

                            var genericDataElement = _.first(_.filter(genericData.models, function (model) {
                                return model.attributes.ObjectId == uploadElement.attributes.ObjectId && moment(model.attributes.ModifiedDate, CONSTS.DATETIME_PERSIST_FORMAT) < SuperDatum;
                            }));

                            if (genericDataElement != null) {
                                uploadElement.attributes.SyncTime = moment().toDate();
                                uploadElement.PersistToLocalStorageImmediately = false;
                                uploadElement.save();
                            }
                            genericDataElement = null;
                            uploadElement = null;
                        }
                    });


                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericDataRawElements;

                    // ###############################
                    if (downloads.length > 700) {
                        console.log(downloads.length);
                    }
                    // ###############################

                    var lastEntityId = null;
                    var HandleID = $.parseJSON(AjaxReturnObject.ReturnValues).HandleID
                    var FileDownloads = [];

                    _.each(
                        downloads,
                        function (downloadObj) {
                            if (downloadObj.EntityId == CONSTS.ATTACHEMENTS_ENTITY_ID && downloadObj.Custom_006 != '' && downloadObj.Custom_006 != null) {
                                //FILE DOWNLOADS
                                //ATTACHMENT WITH A FILE ATTACHED - NEED TO BE SAVED IN ITS OWN PROCEDURE
                                //Custom_006 -> FileUrl, Path where the file will be stored
                                FileDownloads.push(downloadObj);
                            }

                            {
                                lastEntityId = downloadObj.EntityId;
                                var isNew = false;
                                var obj = genericData.get(downloadObj.DataId);

                                if (downloadObj.IsActive == false) {
                                    if (obj != null) {
                                        genericData.remove(obj);
                                        obj.destroy();
                                    }
                                } else {
                                    if (!obj) {
                                        isNew = true;
                                        obj = new window.GenericDataRawElement();
                                        obj.id = downloadObj.DataId;
                                    }

                                    obj.attributes = downloadObj

                                    obj.IsNew = isNew;

                                    obj.attributes.IsConflict = false;
                                    obj.attributes.SyncTime = moment().toDate();

                                    obj.IsSync = true;
                                    obj.PersistToLocalStorageImmediately = false;
                                    obj.saveItem();
                                    // window.genericData.add(obj);
                                    downloadObj = null;
                                    obj = null;
                                }
                            }
                        }
                    );

                    //Check if files need to be stored on phone
                    if (FileDownloads.length > 0) {
                        setTimeout(function () {
                            SyncController.saveFileDownloads(FileDownloads);
                        }, 100);
                    }

                    if (downloads.length > 0 || (uploads != null && uploads.length > 0)) {

                        _.each(
                          downloads,
                          function (downloadObj) {
                              var obj = genericData.get(downloadObj.id);
                              if (obj != null) obj.PersistToLocalStorageImmediately = true;
                          }
                      );
                        // workaround for the memory leak while saving to local storage in loop
                        // this method call writes the backbone collection/model to the local storage after processing the loop

                        Utils.ConsoleLog("persist on sync complete");
                        window.persistGenericData();
                        // window.genericData.localStorage.persistToStorage();
                    }

                    //wenn leer --> dann emailversand als letztes schicken...
                    if (lastEntityId == null) {
                        lastEntityId = "1bc28e66-4663-4837-b177-5339891493c8";
                    }
                    var up = 0;
                    var down = 0;
                    if (uploads != null) {
                        up = uploads.length;

                        uploads.length = 0;
                        uploads = null;
                        SyncController.Uploads.length = 0;
                        SyncController.Uploads = null;
                    }
                    if (downloads != null) {
                        down = downloads.length;
                        downloads.length = 0;
                        downloads = null;
                    }

                    setGlobalStatus('SYNC_LAST_DOWNLOAD_COUNT', down);
                    setGlobalStatus('SYNC_LAST_UPLOAD_COUNT', up);

                    // if conflicts exist => show warning
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, "CONFILCTED SYNCHRONISATION");
                    }

                    Utils.ConsoleLog("INFO: Webservice synchronizeGenericDataWorker: SUCCESS: " + AjaxReturnObject.ReturnMsg + " Last entity: " + lastEntityId + " DownloadCount: " + down + " UploadCout: " + up);
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice SynchronizeGenericData: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    callback(lastEntityId, HandleID);
                }
                genericData = null;
                SyncController.SyncQueue.removeValue('Type', 'GenericData');
                uploads = null;
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    if (manually) {
                        showMessage(AjaxReturnObject.ReturnMsg);
                    }
                    Utils.ConsoleLog("ERROR: Webservice SynchronizeGenericData: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        showMessage('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                SyncController.SyncIsRunning = false;
                SyncController.SyncQueue.removeValue('Type', 'GenericData');
                SyncController.syncNext();
            }
        });

        svcWrapper.UploadElements = null;
        currentDevice = null;
        svcWrapper = null;
        SyncController.LastSync = moment().toDate();

    },

    LoadAttachment: function (DataID, callback) {
        var TmpData = new Array();

        if (DataID != undefined && DataID != "") {
            SyncController.searchGenericData(TmpData, "", undefined, CONSTS.ATTACHEMENTS_ENTITY_ID, "", DataID, true, true, function () {
                if (TmpData != undefined && TmpData.length == 1)
                    SyncController.saveFile(TmpData[0], callback)
                return;
            });
        }



    },

    //Aktuell nur für Temp Models. Tempmodels sind Models, die in OnlineListen angezeigt werden.
    OnlineUpsert: function (parameters, hideDevice, callback) {
        var manually = true;
        var execAsync = false;

        if (execAsync == null) {
            execAsync = true;
        }


        var newModel = _.find(SyncController.TmpData, function (TmpData) {
            return TmpData.attributes.DataId == ActionHelper.CurrentView.options.modelId;
        });

        var customValues = [];

        customValues = eval(parameters);

        _.each(customValues, function (customValue) {
            if (newModel && customValue) {
                var substr = customValue.split('||');
                var gcn = substr[0];
                var value = substr[1];
                value = DefaultValueHelper.getConstantValue(value);
                var gp = window.genericProperties.get(gcn);
                if (gp !== undefined) {
                    gcn = gp.attributes.GenericColumnName;
                }
                newModel.set(gcn, value);
            }
        });

        var uploadData = [];
        uploadData.push(newModel);

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);
        var currentDevice = window.currentDevice;

        var deviceID = currentDevice.DeviceId;

        if (hideDevice)
            deviceID = undefined;

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: deviceID,//currentDevice.DeviceId,
            UserId: currentDevice.UserId,
            PhoneId: currentDevice.PhoneId,
            DevicePlatform: currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }
        svcWrapper.UploadElements = [];
        var SuperDatum = moment().toDate();

        svcWrapper.UploadElements.push(newModel);

        SyncController.Uploads = uploadData;

        uploadData = null;

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericData/UpsertGenericData',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            timeout: CONSTS.TIMEOUT_GDATA,
            async: execAsync,
            success: function (AjaxReturnObject) {
                var genericData = window.genericData;
                var uploads = SyncController.Uploads;

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {


                    var downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericDataRawElements;

                    _.each(
                        downloads,
                        function (downloadObj) {
                            if (downloadObj.EntityId == CONSTS.ATTACHEMENTS_ENTITY_ID && downloadObj.Custom_006 != '' && downloadObj.Custom_006 != null) {
                                //FILE DOWNLOADS
                                //ATTACHMENT WITH A FILE ATTACHED - NEED TO BE SAVED IN ITS OWN PROCEDURE
                                //Custom_006 -> FileUrl, Path where the file will be stored
                                //FileDownloads.push(downloadObj);
                            } else {
                                var isNew = false;
                                var obj = genericData.get(downloadObj.DataId);

                                if (downloadObj.IsActive == false) {
                                    if (obj != null) {
                                        genericData.remove(obj);
                                        obj.destroy();
                                    }
                                } else {
                                    if (!obj) {
                                        isNew = true;
                                        obj = new window.GenericDataRawElement();
                                        obj.id = downloadObj.DataId;
                                    }

                                    obj.attributes = downloadObj

                                    obj.IsNew = isNew;

                                    obj.attributes.IsConflict = false;
                                    obj.attributes.SyncTime = moment().toDate();

                                    obj.IsSync = true;
                                    obj.PersistToLocalStorageImmediately = false;
                                    //obj.saveItem();
                                    GenericHelper.addModel(obj, false, false)
                                    // window.genericData.add(obj);
                                    downloadObj = null;
                                    obj = null;
                                }
                            }
                        }
                    );
                }
                else {
                    if (manually) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    }
                    Utils.ConsoleLog("ERROR: Webservice SynchronizeGenericData: " + AjaxReturnObject.DebugInfo);
                }
                if (callback) {
                    //callback(lastEntityId);
                }
                genericData = null;
                uploads = null;
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    if (manually) {
                        showMessage(AjaxReturnObject.ReturnMsg);
                    }
                    Utils.ConsoleLog("ERROR: Webservice SynchronizeGenericData: " + AjaxReturnObject.ReturnMsg);
                } else {
                    if (manually) {
                        showMessage('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    }
                }
                //SyncController.SyncIsRunning = false;
                //SyncController.SyncQueue.removeValue('Type', 'GenericData');
                this.syncData();
            }
        });

        svcWrapper.UploadElements = null;
        //currentDevice = null;
        svcWrapper = null;
        //SyncController.LastSync = moment().toDate();
    },


    loadFileContents: function () {

        this.fileHelper = FileHelper;
        var count = 0;
        function doNext() {
            count++;
            if (count > 5) {
                //SyncController.SyncQueue.push({ Type: 'Attachments', Manually: false, Async: true })
                //SyncController.syncNext();
                return;
            }
            this.currentFile = _.first(genericData.where({ EntityId: CONSTS.ATTACHEMENTS_ENTITY_ID, Custom_020: undefined }));
            if (this.currentFile != null && (this.currentFile.attributes.CustomMax_001 == null || this.currentFile.attributes.CustomMax_001 == '')) {
                if (this.currentFile.attributes.IsActive == false) {
                    this.fileHelper.deleteFile(this.currentFile.attributes.DataId, "MF_DATA");
                    this.currentFile = null;
                    this.count--;
                    $.proxy(doNext, this)();
                } else {
                    SyncController.LoadAttachment(this.currentFile.attributes.DataId, $.proxy(function (fileConent) {
                        $.proxy(doNext, this)();
                    }, this));
                }

            }
            else {
                return;
            }
        } $.proxy(doNext, this)();
    },

    saveFileDownloads: function (files) {
        //this.currentFile = _.first(genericData.where({ EntityId: CONSTS.ATTACHEMENTS_ENTITY_ID, Custom_020: undefined }));
        this.fileHelper = FileHelper;
        this.count = files.length;

        function doNext() {
            if (this.count <= 0) {
                window.persistGenericData();
                this.fileHelper = null;
                this.count = null;
                return;
            } else {
                this.currentFile = files[this.count - 1];
                if (this.currentFile != null) {
                    if (this.currentFile.IsActive == false) {
                        this.fileHelper.deleteFile(this.currentFile.DataId, "MF_DATA");
                    }
                }
            }
            this.currentFile = null;
            this.count--;
            $.proxy(doNext, this)();
        } $.proxy(doNext, this)();
    },


    saveFile: function (file, callback) {
        this.fileHelper = FileHelper;
        //this.count = files.length;

        if (file == undefined)
            return;

        this.currentFile = file;

        if (!navigator.notification) {
            var obj = genericData.get(this.currentFile.attributes.ObjectId);

            if (!obj) {
                isNew = true;
                obj = new window.GenericDataRawElement();
                obj.id = this.currentFile.ObjectId;
            }

            obj.attributes.Custom_020 = true;
            obj.IsSync = true;
            obj.PersistToLocalStorageImmediately = true;
            obj.saveItem();
            obj = null;
            if (callback) {
                callback();
            }
            return;
        }

        this.fileHelper.saveFile(this.currentFile.attributes.CustomMax_001, this.currentFile.attributes.DataId, this.currentFile.attributes.Custom_001, "MF_DATA", LocalFileSystem.PERSISTENT, true, function (fileContent, fileName, shortfileName) {

            var obj = genericData.get(shortfileName);

            if (!obj) {
                isNew = true;
                obj = new window.GenericDataRawElement();
                obj.id = shortfileName;
            }

            obj.attributes.Custom_020 = true;

            obj.IsSync = true;
            obj.PersistToLocalStorageImmediately = true;
            obj.saveItem();
            obj = null;

            if (callback) {
                callback();
            }
        });




        return;
        function doNext() {
            if (this.count <= 0) {
                //DOWNLOAD FILES DONE!
                window.persistGenericData();
                this.fileHelper = null;
                this.count = null;
            } else {
                this.currentFile = files[this.count - 1];
                if (navigator.notification) {
                    if (this.currentFile != null) {
                        if (this.currentFile.attributes.IsActive == false) {
                            this.fileHelper.deleteFile(this.currentFile.attributes.DataId, "MF_DATA");
                            this.currentFile = null;
                            this.count--;
                            $.proxy(doNext, this)();
                        } else {
                            //this.fileHelper.persistFile(this.currentFile.CustomMax_001, 'txt', this.currentFile.DataId, $.proxy(function (fileConent) {
                            this.fileHelper.saveFile(this.currentFile.attributes.CustomMax_001, this.currentFile.attributes.DataId, this.currentFile.attributes.Custom_001, "MF_DATA", LocalFileSystem.PERSISTENT, true, $.proxy(function (fileConent) {
                                this.currentFile.attributes.CustomMax_001 = '';
                                var isNew = false;

                                var obj = genericData.get(this.currentFile.attributes.ObjectId);

                                if (!obj) {
                                    isNew = true;
                                    obj = new window.GenericDataRawElement();
                                    obj.id = this.currentFile.ObjectId;
                                }

                                obj.attributes = this.currentFile

                                obj.IsNew = isNew;

                                obj.attributes.IsConflict = false;
                                obj.attributes.SyncTime = moment().toDate();

                                obj.IsSync = true;
                                obj.PersistToLocalStorageImmediately = false;
                                obj.saveItem();
                                window.genericData.add(obj);
                                obj = null;

                                this.currentFile = null;
                                this.count--;
                                $.proxy(doNext, this)();
                            }, this));
                        }
                    }
                } else {
                    //BROWSER TESTING
                    this.currentFile.CustomMax_001 = '';

                    var isNew = false;

                    var obj = genericData.get(this.currentFile.ObjectId);

                    if (!obj) {
                        isNew = true;
                        obj = new window.GenericDataRawElement();
                        obj.id = this.currentFile.ObjectId;
                    }

                    obj.attributes = this.currentFile

                    obj.IsNew = isNew;

                    obj.attributes.IsConflict = false;
                    obj.attributes.SyncTime = moment().toDate();

                    obj.IsSync = true;
                    obj.PersistToLocalStorageImmediately = false;
                    obj.saveItem();
                    obj = null;

                    this.currentFile = null;
                    this.count--;
                    $.proxy(doNext, this)();
                }
            }
        } $.proxy(doNext, this)();
    },

    sendMail: function (to, cc, bcc, subject, body, attachmentFilename, attachmentContent) {

        MailObject = {
            To: to,
            CC: cc,
            Subject: subject,
            Body: body,
            FileContent: null,
            FileName: null,
            FileType: null,
        };

        $.ajax({
            url: window.location.origin + '/action/api/emails/SendEmail',
            data: JSON.stringify(MailObject),
            type: 'post',
            contentType: "application/json; charset=utf-8",
            timeout: CONSTS.TIMEOUT_SUPPORT_DATA,
            success: function (AjaxReturnObject) {

            },
            error: function (response) {

            }
        });
    },

    searchData: function (search, viewid, entityid, callback, ParentObjectID, filter) {
        if (!this.checkConnection()) {
            callback();
            return;
        }

        SyncController.TmpData = new Array();

        this.searchGenericData(SyncController.TmpData, search, viewid, entityid, "", "", true, false, function () {
            callback();
            return;
            //SyncController.searchDone()
        }, ParentObjectID, filter);

        //$('#loader_page').hide();
        //$.mobile.loading('hide');
    },

    loading: function (showOrHide) {
        setTimeout(function () {
            if (showOrHide) {
                $('#loader_page').show();
                $.mobile.loading('show', {
                    text: 'Suche',
                    textVisible: true,
                    theme: 'a',
                });
            }
            else {
                $('#loader_page').hide();
                $.mobile.loading('hide');
            }
        }, 1);
    },

    searchDataByObjectID: function (objectId, viewid, entityid) {
        if (!this.checkConnection()) {
            return;
        }

        SyncController.TmpData = new Array();

        this.searchGenericData(SyncController.TmpData, "", viewid, entityid, "", objectId, false, true, function () {
            return;
            //SyncController.searchDone()
        });

        //$('#loader_page').hide();
        //$.mobile.loading('hide');
    },


    searchDataByDataID: function (dataID, viewid, entityid) {
        if (!this.checkConnection()) {
            return;
        }

        SyncController.TmpData = new Array();

        this.searchGenericData(SyncController.TmpData, "", viewid, entityid, dataID, "", false, true, function () {
            return;
            //SyncController.searchDone()
        });

        //$('#loader_page').hide();
        //$.mobile.loading('hide');
    },
    searchDone: function () {
        //this.SyncQueue.remove(data);
        //$('#loader_page').hide();
        //$.mobile.loading('hide');
        //SearchView.buildView(this)
    },

    getUnsyncedAttachment: function () {
        return genericData.where({ EntityId: CONSTS.ATTACHEMENTS_ENTITY_ID, Custom_020: undefined });
    },
    getUnsyncedAttachmentCount: function () {
        return genericData.where({ EntityId: CONSTS.ATTACHEMENTS_ENTITY_ID, Custom_020: undefined }).length;
    },
    //search--> Mastersuche
    //filter-->CustomXXX|Value
    searchGenericData: function (data, search, viewid, entityid, DataId, ObjectId, execAsync, loadOnlyRawData, callback, ParentObjectID, filter) {

        var that = this;
        var GenericDataResult;


        if (execAsync == null) {
            execAsync = true;
        }

        var uploadData;

        var phoneId = CryptoJSHelper.getEncryptedString(window.currentUser.UserId);

        var svcWrapper = {};
        svcWrapper.PhoneId = phoneId;
        svcWrapper.DeviceElement = {
            DeviceId: window.currentDevice.DeviceId,
            UserId: window.currentDevice.UserId,
            PhoneId: window.currentDevice.PhoneId,
            DevicePlatform: window.currentDevice.DevicePlatform,
            AppVersion: CONSTS.APP_VERSION,
            IsActive: window.currentDevice.IsActive,
        };
        svcWrapper.DeviceElement.UserElementAuth = {
            MandatorId: window.currentUser.MandatorId
        }
        //SearchGenericDataModel
        svcWrapper.Search = search;
        svcWrapper.ViewId = viewid;
        svcWrapper.EntityId = entityid;
        svcWrapper.ObjectId = ObjectId;
        svcWrapper.LoadRawData = loadOnlyRawData;
        svcWrapper.DataId = DataId;
        svcWrapper.ParentObjectID = ParentObjectID;
        svcWrapper.Filter = filter;
        //data = new Array();
        //SyncController.TmpData = new Array();

        $.ajax({
            url: window.appVersion.attributes.WsMainUrl + 'genericData/SearchGenericData',
            data: JSON.stringify(svcWrapper),
            contentType: "application/json; charset=utf-8",
            timeout: CONSTS.TIMEOUT_SEARCH,
            async: execAsync,
            success: function (AjaxReturnObject) {
                //Utils.ConsoleLog("INFO: Webservice SynchronizeGenericData: " + JSON.stringify(AjaxReturnObject));

                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    //var deviceRawElement = new window.DeviceRawElement($.parseJSON(AjaxReturnObject.ReturnValues).DeviceRawElement);
                    //deviceRawElement.id = deviceRawElement.attributes.DeviceId;
                    //deviceRawElement.save();
                    //setCurrentDevice(deviceRawElement);

                    downloads = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericDataRawElements;
                    //SyncController.TmpData = $.parseJSON(AjaxReturnObject.ReturnValues).DownloadedGenericDataRawElements;
                    //return;

                    _.each(
                        downloads,
                        function (downloadObj) {

                            var isNew = false;
                            var obj = new window.GenericDataRawElement();
                            // obj.attributes = {};

                            for (var attr in downloadObj) {
                                //eval('obj.attributes.' + attr + ' = downloadObj[attr];');
                                obj.attributes[attr] = downloadObj[attr];
                            }

                            obj.attributes.IsConflict = false;
                            obj.attributes.SyncTime = moment().toDate();
                            obj.save();
                            data.push(obj);
                            //SyncController.TmpData.push(obj);

                        }
                    );

                    //Retention Time Recordings after synchronization
                    //that.genericDataRetention();
                    var down = 0;
                    if (downloads != null) {
                        down = downloads.length;
                    }

                    downloads = null;

                    // show warning, if occured
                    //if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING && manually) {
                    //    alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    //}

                    Utils.ConsoleLog("INFO: Webservice SearchGenericData: SUCCESS: " + AjaxReturnObject.ReturnMsg + " DownloadCount: " + down);
                }
                else {
                    //alert(AjaxReturnObject.ReturnMsg, null, 'Fehler', 'Ok');
                    Utils.ConsoleLog("ERROR: Webservice SearchGenericData: " + AjaxReturnObject.DebugInfo);
                }

                if (callback) {
                    callback();
                }
                return data;
            },
            error: function (response) {
                if (response.statusText != null && response.statusText != undefined && response.statusText != 'timeout') {
                    var AjaxReturnObject = $.parseJSON(response.responseText);
                    Utils.ConsoleLog("ERROR: Webservice SearchGenericData: " + AjaxReturnObject.ReturnMsg);
                } else {
                    //alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                }
                if (callback) {
                    callback();
                }

            }

        });
    },


    Execute_UserChangeTracking: function (execAsync, manually, callback) {
        var UserChangeTrackingEntityID = '21367915-53ec-4d00-b1ec-414fdaadc2a3';
        var genericData = window.genericData;
        var self = this;

        //var SystemCommands = genericData.where({ IsActive: true, EntityId: self.SystemCommandsEntityID })
        var SystemCommands = genericData.where({ IsActive: true, EntityId: UserChangeTrackingEntityID, Custom_005: undefined })

        if (SystemCommands == null || SystemCommands.length == 0)
            return;

        if (execAsync == null) {
            execAsync = true;
        }

        _.each(
        SystemCommands,
        function (obj) {
            //var updateValue = obj.attributes.CustomMax_002
            //if (updateValue == undefined || updateValue.length == 0)
            //    updateValue = obj.attributes.Custom_002;


            var Record = _.first(genericData.where({ IsActive: true, ObjectId: obj.attributes.Custom_002.toLowerCase() }));
            if (Record != undefined) {
                Record.attributes.IsActive = false;
                Record.saveItem();
            }
            else {
                obj.attributes.CustomMax_001 = 'Record not found';
            }

            //var Record = _.first(genericData.where({ IsActive: true, ObjectId: obj.attributes.Custom_003.toLowerCase() }));
            //if (Record != undefined) {
            //    genericData.remove(Record);
            //    Record.destroy();
            //}


            obj.attributes.EntryTime = moment().toDate();//moment().format(CONSTS.DATETIME_PERSIST_FORMAT);
            obj.attributes.SyncTime = CONSTS.DATE_DEFAULT;
            obj.set('Custom_005', moment().format(CONSTS.DATETIME_PERSIST_FORMAT));
            obj.saveItem();
        }
        );
        window.persistGenericData();

        if (callback) {
            callback();
        }

    },
};