﻿/**
* Der ListViewBuilderHelper erstellt die DOM Elemente (HTML) für ListViews. 
* Er unterscheidet dabaei zwischen ListViewTableStyle und der normalen ListView. 
* Der ListViewBuilderHelper hat keinerlei Programm Logik, er ist lediglich zum rendern da.
*
* @class ListViewBuilderHelper.js
*/
ListViewBuilderHelper = {
    listView: null,
    init: function(fieldtype, container)
    {
        this.listView = document.createDocumentFragment();
        $(container).empty();

        if (fieldtype != 'tablestyle') {
            this.ListViewNormalAndOnline.listElement = null;
        } else {
            this.ListViewTableStyle.init(container);
        }
    },

    render: function(container) {
        $(container).append(this.listView);
    },

    createListElement: function(fieldtype, id) { 
        if (fieldtype != 'tablestyle') {
            return this.ListViewNormalAndOnline.createListElement(id);
        }
        else {
            return this.ListViewTableStyle.createListElement(id);
        }
    },
    createWrapperPosZeroElement: function (fieldtype, listelement, displaytext, customCssClass) {
        if (fieldtype != 'tablestyle') {
            this.ListViewNormalAndOnline.createWrapperPosZeroElement(listelement, displaytext, customCssClass);
        }
        else
        {
            this.ListViewTableStyle.createWrapperPosZeroElement(listelement, displaytext, customCssClass);
        }
    },
    createWrapperPosMinusTwoElement: function (fieldtype, listelement, displaytext, customCssClass) {
        if (fieldtype != 'tablestyle') {
            this.ListViewNormalAndOnline.createWrapperPosMinusTwoElement(listelement, displaytext);
        }
    },
    createThumbnailPosMinusOneElement: function (fieldtype, listelement, displaytext, customCssClass) {
        if (fieldtype != 'tablestyle') {
            this.ListViewNormalAndOnline.createThumbnailPosMinusOneElement(listelement, displaytext, customCssClass);
        }
    },

    createWrapperContent: function (fieldtype, listelement, lableText, displayText, removeLabels, customCssClass) {
        if (fieldtype != 'tablestyle') {
            this.ListViewNormalAndOnline.createWrapperContent(listelement, lableText, displayText, removeLabels, customCssClass);
        }
        else {
            this.ListViewTableStyle.createWrapperContent(listelement, lableText, displayText, customCssClass);
        }
    },
    
    createWrapperCheckBox: function (fieldtype, listelement, id) {
        if (fieldtype !== 'tablestyle') {
            this.ListViewNormalAndOnline.createWrapperCheckBox(listelement, id);
        }
        else {
            this.ListViewTableStyle.createWrapperCheckBox(listelement, id);
        }
    },

    createWrapperCheckBoxBoso: function (fieldtype, listelement, id) {
        if (fieldtype !== 'tablestyle') {
            this.ListViewNormalAndOnline.createWrapperCheckBox(listelement, id);
        } else {
            this.ListViewTableStyle.createWrapperCheckBoxBoso(listelement, id);
        }
    },

    createLoader: function(fieldtype) {
        if (fieldtype != 'tablestyle') {
            return $('<form>', {
                id: 'listviewloader',
                class: 'list_item_wrapper',
                alt: 'Lade',
                html: '<img src="css/default/images/ajax-loader.gif" />'
            }).appendTo(ListViewBuilderHelper.listView);
        }
    },


    ListViewNormalAndOnline: {
        listElement: null,
        createListElement: function (id) {
            var li;
            if (this.listElement == null) {
                this.listElement = $('<li/>', {});
                var a = $('<a/>', {
                    class: 'list_item'
                }).appendTo(this.listElement);

                var listItemWrapper = $('<form/>', {
                    class: 'list_item_wrapper'
                }).appendTo(a);
            }

            var li = this.listElement.clone(true);
            li.find('.list_item').attr('id', id);
            $(ListViewBuilderHelper.listView).append(li);

            return li;
        },

        createWrapperPosZeroElement: function (listelement, displaytext, customCSSClass) {
            var listItemWrapper = $(listelement).find('.list_item_wrapper');
            
            var classname = 'ui-li-aside listviewWrapperStatus';
            if (customCSSClass != undefined) {
                classname += ' ' + customCSSClass;
            }

            var WrapperStatus = $('<div/>', {
                class: classname,
                text: displaytext,
            }).appendTo(listItemWrapper);
           
        },

        createWrapperPosMinusTwoElement: function (listelement, displayText, customCSSClass) {
            var listItemWrapper = $(listelement).find('.list_item_wrapper');
      
            var classname = 'listviewWrapperTitle';
            if (customCSSClass != undefined) {
                classname += ' ' + customCSSClass;
            }
            //value rechts
            var columnValue = $('<div/>', {
                class: classname,
                text: displayText
            }).appendTo(listItemWrapper);

            $('<div class="listcontentclear"/>').appendTo(listItemWrapper);
        },

        createThumbnailPosMinusOneElement: function (listelement, displaytext, customCSSClass) {
            var img = $('<img/>', {
                class: customCSSClass,
            }).prependTo(listelement);

        },

        createWrapperContent: function (listelement, lableText, displayText, removeLabels, customCSSClass) {
            var listItemWrapper = $(listelement).find('.list_item_wrapper');

            //überschrift im wrapper links
            var classname = 'list_content listviewColumnName';

            if (GlobalSettings.IsBoso() && ActionHelper.CurrentView.options.view.get('EntityId') === Boso.BOSO_GEREATE_ENTITY_ID) {
                classname = 'list_content bosoDeviceslistviewColumnName'
            }

            var columnName = $('<div/>', {
                class: classname,
            }).appendTo(listItemWrapper);

            var removeAllLabels = false
            if (!Utils.isNull(removeLabels)) {
                removeAllLabels = removeLabels;
            }

            if (!removeAllLabels) {
                $('<p>', {
                    text: lableText,
                }).appendTo(columnName);
            }

            classname = 'list_content listviewColumnValue';
            if (customCSSClass != undefined) {
                classname += ' ' + customCSSClass;
            }

            //value rechts
            var columnValue = $('<div/>', {
                class: classname,
            }).appendTo(listItemWrapper);


            $('<p>', {
                text: displayText,
            }).appendTo(columnValue);

            $('<div class="listcontentclear"/>').appendTo(listItemWrapper);
        },

        createWrapperCheckBox: function(listelement, id) {
            var aCheck = $('<a/>', {
                id: id,
                style: 'width:8%; min-width: 50px;',
                class: 'checkBox'
            }).appendTo(listelement);

            aCheck.attr('data-icon', 'none');
            aCheck.attr('data-theme', 'a');
        }
    },

    //Creates a Table
    ListViewTableStyle: {
        listViewTable: null,
        init: function (container) {
            /* liste durchsuchen ausblenden bei ListViewTableSTyle */
            $(container).find('#search').css('display', 'none');

            var ListViewTable = $('<table />', {
                class: 'listViewTableStyle'
            }).appendTo(ListViewBuilderHelper.listView);

            var TheadTag = $('<thead />').appendTo(ListViewTable);

            var viewId = !!ActionHelper.CurrentView ? 'viewId_' + ActionHelper.CurrentView.options.view.id : null;
                var ListViewTableHeaderRow = $('<tr />', {
                'class': 'listViewTableStyleHeaderRow',
                'id': viewId
            }).appendTo(TheadTag);

            this.listViewTable = ListViewTable;
        },

        createListElement: function (id) {
            var li = $('<tr />', {
                id: id,
                class: 'list_item', 
            }).appendTo(this.listViewTable);

            return li;
        },

        createWrapperPosZeroElement: function (listelement, displaytext, customCssClass) {
        },

        createWrapperContent: function (listelement, lableText, displayText) {
            this.createHeaderTags(lableText);

            //Spalten Wert
            if (displayText == '') { displayText = '-';}

            var br = $('<td />', {
                text: displayText
            }).appendTo(listelement);
        },

        createHeaderTags: function (lableText) {
            //Falls Tabellen Spalte noch nicht vorhanden: hinzufügen
            var hr = $(this.listViewTable).find('tr.listViewTableStyleHeaderRow');
            if ($(hr).find('th[lable="' + lableText + '"]').length == 0) {
                var th = $('<th/>', {
                    lable: lableText,
                    id: 'th_' + lableText
                });

                if (lableText !== 'chkBox') {
                    $(th).html(lableText);
                }
                
                $(th).appendTo(hr);
            };
        },

        createWrapperCheckBox: function (listelement, id) {
            var td = $('<td/>', {
                style: 'width:3%; min-width: 10px;',
            }).appendTo(listelement);

            var fs = $('<fieldset/>', {}).appendTo(td);
            fs.attr('data-role', 'controlgroup');
        
            var lblstyle = 'style="width:3%; min-width: 10px; margin-rigth: 10px; margin-left: 0px;"';
            var chbx = '<input type="checkbox" name="' + id + '" id="' + id + '" class="checkBox" data-icon="none" data-theme="a">';
            chbx += '<label for="' + id + '" data-inline="true" ' + lblstyle +' />'
            chbx += '</input>';

            $(fs).append(chbx);
        },

        createWrapperCheckBoxBoso: function (listelement, id) {
            var hr = $(this.listViewTable).find('tr.listViewTableStyleHeaderRow');
            var headerCell = $(hr).find('th[lable="' + 'chkBox' + '"]');
            if (headerCell.length === 0) {
                var th = $('<th/>', {
                    lable: 'chkBox',
                }).appendTo(hr);
            };

            if (headerCell.is(':empty')) {
                this.createBosoWeightScaleButton().appendTo(headerCell);
            }

            var td = $('<td />', {
                style: 'width:3%; min-width: 10px',
            }).appendTo(listelement);
            
            var aCheck = $('<a />', {
                id: id,
                name: id,
                class: 'checkBox bosoCheckbox',
                'data-role': 'button',
                'data-icon': 'none',
                'data-iconpos': 'top',
                'data-theme': 'a',
                'data-mini': 'true',
                'data-corners': 'false',
                'data-shadow': 'false',
                'data-inline': 'true'
            });

            td.append(aCheck);
        },
        
        createBosoWeightScaleButton: function () {
            var visibility = !UserSettings.GetWeightScaleMode() || UserSettings.GetWeightScaleMode() === '0' ? 'hidden' : 'visible';
            var weightScaleButtonClass = !!Boso.weightScaleCommunicationActive ? 'bosoWeightButton_active' : 'bosoWeightButton_inactive';
            var btnBosoWeight = $('<button />', {
                'id': 'bosoWeightButton',
                'class': 'ui-btn ui-btn-inline ' + weightScaleButtonClass,
                'style': 'visibility: ' + visibility + ';'
            });

            btnBosoWeight.on('click', function () {
                Boso.toggleWeightScaleCommunication();
            });

            btnBosoWeight.on('focus', function () {
                btnBosoWeight.blur();
            });

            return btnBosoWeight;
        },

        createSelectAllCheckBox: function ()
        {
            //Falls Tabellen Spalte noch nicht vorhanden: hinzufügen
            var hr = $(this.listViewTable).find('tr.listViewTableStyleHeaderRow');
            if ($(hr).find('th[lable="' + "selectallchbx" + '"]').length == 0) {
                var th = $('<th/>', {
                    lable: 'selectallchbx',
                });
                $(th).appendTo(hr);


                var fs = $('<fieldset/>', {}).appendTo(th);
                fs.attr('data-role', 'controlgroup');
                        
                var chbx = $('<input />', {
                    type: 'button',
                    name: 'selectallchbx',
                    id: 'inputselectallchbx',
                    style: 'width: 50px;'
                }).appendTo(fs);
                $(chbx).attr('data-icon', "check");
                //$(chbx).attr('data-mini', "true");
                $(chbx).attr('data-inline', "true");

                var Interval = function () {
                    var parent = $(chbx).parent();
                    if (parent.length > 0) {
                        $(parent).css('width', '10px');
                    }
                    else {
                        window.setTimeout(Interval, 40);
                    };
                };
                window.setTimeout(Interval, 40);

                var hiddenselect = $('<input />', {
                    type: 'hidden',
                    val: 0,
                    id: 'hiddenselectall'
                }).appendTo(fs);

                $(chbx).click(function () {
                    if ($(hiddenselect).val() == 0) {
                        $(hiddenselect).val(1);
                        $('.ui-checkbox-off').removeClass('ui-checkbox-off').addClass('ui-checkbox-on').attr('data-icon', 'checkbox-on');
                        $('.ui-icon-checkbox-off').removeClass('ui-icon-checkbox-off').addClass('ui-icon-checkbox-on');
                    }
                    else {
                        $(hiddenselect).val(0);
                        $('.ui-checkbox-on').removeClass('ui-checkbox-on').addClass('ui-checkbox-off').attr('data-icon', 'checkbox-off');
                        $('.ui-icon-checkbox-on').removeClass('ui-icon-checkbox-on').addClass('ui-icon-checkbox-off');
                    }
                });
            };        
        }
    }
};