﻿/**
* Handled alle aktionen die in der App ausgeführt werden können mittels GenericActions  und verwaltet diverse Objekte die mit den Aktionen zusammenhängen
*
* @class actionHelper.js
*/
ActionHelper = {

    /**
    * Speichert den aktuellen View auf welchen navigiert wurde mit seinen Eigenschaften, um globalen zugriff auf den View zu haben.
    * 
    * @property CurrentView
    * @type {Object}
    */
    CurrentView: null,
    Models: [],
    ReturnField: null,
    ReturnID: null,
    ReturnValue: null,
    tmpModel: null,
    tmpModelArray: null,
    OldModels: new Array(),
    IsValid: true,
    NavFilter: null,
    ViewDeactivated: false,
    CopyValues: null,

    /**
    * returns: sorted datalist
    * Parameter:
    * data: modellist to sort 
    * view: OPTIONAL: view including attributes to sort. If not set, CurrentView is used.
    * attributes: OPTIONAL: attributes (JS) for sorting. If not set, the attributes of the current view are used. If set, the parameter property id and desc have no impact.
    * propertyID: OPTIONAL: used if no attribute is set
    * desc: OPTIONAL: used if no attribute is set
    */
    sortForView: function (data, view, attribute, propertyID, desc) {
        var attrs;
        if (ActionHelper.CurrentView.getSettings == undefined)
            return;
        var sortSettings = ActionHelper.CurrentView.getSettings().sort; //Sort Settings die der nutzer über die sortPopUp Methode definiert
        if (sortSettings.length == 0) // Altes Sort ausführen
        {
            if (view == undefined)
                view = ActionHelper.CurrentView.options.view;

            if (attribute == undefined && view.attributes.SortJs != undefined && view.attributes.SortJs.length > 0)
                attribute = view.attributes.SortJs;

            if (attribute == undefined) {
                if (propertyID == undefined && view.attributes.SortPropertyId != undefined && view.attributes.SortPropertyId.length > 0 && view.attributes.SortPropertyId != CONSTS.GUID_DEFAULT) {
                    attribute = new Array();
                    attribute.push('"' + view.attributes.SortPropertyId + '"');
                }
                else
                    attribute = propertyID;

                propertyID = undefined;

                if (desc == undefined && view.attributes.SortDesc != undefined)
                    desc = view.attributes.SortDesc;
            }
            else {
                propertyID = undefined;
                desc = undefined;
            }

            attrs = eval(attribute);

            if ($.isArray(attrs)) {
                for (var i = 1; i < attrs.length + 1; i++) {
                    var attribute = attrs[attrs.length - i];
                    var attrArry = attribute.split(',');
                    var sdesc = false;
                    if (desc == undefined) {
                        sdesc = ($.inArray('desc', attrArry) > -1);
                    }
                    else {
                        sdesc = desc
                    }
                    //desc = ($.inArray('desc', attrArry) > -1);
                    if (attrArry.length == 2 || (attrArry.length == 3 && $.inArray('desc', attrArry) > -1))
                        attribute = attrArry[0] + ',' + attrArry[1];

                    if (sdesc) {
                        data = _.sortBy(data, function (model) {
                            var sortVal = eval('GenericHelper.getCustomValue(model,' + attribute + ')');
                            return -sortVal;
                        });
                    } else {
                        data = _.sortBy(data, function (model) {
                            var sortVal = eval('GenericHelper.getCustomValue(model,' + attribute + ')');
                            return sortVal;
                        });
                    }
                }

            }
        }
        else //Neues Sort nach ausgeführter SortPopUpAction und Nutzerspezifischer Sortierung
        {
            attrs = [];
            _.each(sortSettings.reverse(), function (sortSetting) {

                if (sortSetting.sort == "none") { return; }

                var PropGenericColumnName = window.genericProperties.get(sortSetting.propId).attributes.GenericColumnName

                var LookupEntity = window.genericEntities.get(window.genericProperties.get(sortSetting.propId).attributes.LookupEntityId);
                var PropGenericColumnName2 = undefined;


                if (LookupEntity != undefined) {
                    PropGenericColumnName2 = window.genericProperties.get(LookupEntity.attributes.DisplayPropertyId).attributes.GenericColumnName;
                }

                var sortedlist = Array();

                var groups = _.groupBy(data, function (currentObject) {
                    return eval('currentObject.get(\'' + PropGenericColumnName + '\')');
                });

                data = new Array();
                groups = _.sortBy(groups, function (data, index) {
                    if (data.length < 1)
                        return -1;
                    var sortVal;
                    try {
                        sortVal = GenericHelper.getCustomValue(data[0], PropGenericColumnName, PropGenericColumnName2);
                    } catch (e) {

                    }
                    return sortVal;
                })

                if (sortSetting.sort == 'desc') {
                    groups = groups.reverse();

                }

                _.each(groups, function (group) {
                    _.each(group, function (item) {
                        data.push(item);
                    });
                });
            });
        }

        return data;
    },

    sort: function (attr, desc) {
        var sortedData = _.filter(window.genericData.models, function (model) {
            return model.attributes.EntityId == ActionHelper.CurrentView.options.view.attributes.EntityId;
        });
        if (attr == '' || attr == null || attr == undefined) {
            return sortedData;
        } else {
            var attrs = eval(attr);
            if ($.isArray(attrs)) {
                var sortedData = _.filter(window.genericData.models, function (model) {
                    return model.attributes.EntityId == ActionHelper.CurrentView.options.view.attributes.EntityId;
                });
                for (var i = 1; i < attrs.length + 1; i++) {
                    var attribute = attrs[attrs.length - i];
                    var attrArry = attribute.split(',');
                    if (attrArry.length == 3) {
                        if (attrArry[2] != undefined && attrArry[2] != 'desc') {
                            desc = false;
                        }
                        else {
                            desc = true;
                        }
                        attribute = attrArry[0] + ',' + attrArry[1];
                    }

                    if (desc) {
                        sortedData = _.sortBy(sortedData, function (model) {
                            var sortVal = eval('GenericHelper.getCustomValue(model,' + attribute + ')');
                            return -sortVal;
                        });
                    } else {
                        sortedData = _.sortBy(sortedData, function (model) {
                            var sortVal = eval('GenericHelper.getCustomValue(model,' + attribute + ')');
                            return sortVal;
                        });
                    }
                }
                return sortedData;
            } else {
                return sortedData;
            }
        }
    },

    isMassEdit: function () {
        return (ActionHelper.Models != null && ActionHelper.Models.length > 0);
    },

    registerEventHandler: function (viewAction, selector) {
        if (selector == undefined) {
            selector = viewAction.attributes.Selector;
        }
        var SelectableFieldCount = viewAction.attributes.SelectableFieldCount;
        var preCommands = ActionHelper.preparePreaction(viewAction);
        var Command = 'ActionHelper.' + viewAction.attributes.CommandName + ActionHelper.prepareParams(viewAction);
        var postCommands = ActionHelper.preparePostaction(viewAction);
        if (viewAction.attributes.Event == 'swipeleft' || viewAction.attributes.Event == 'swiperight') {
            if (navigator.notification) {
                Utils.Swipe.on(viewAction.attributes.Event, function () {
                    eval(preCommands);
                    eval(Command);
                    eval(postCommands);
                });
            } else {
                //BROWSER TESTING
                var event_ok = true;
                $(selector).on(viewAction.attributes.Event, function () {
                    if (event_ok == false) {
                        event.preventDefault();
                        return false;
                    } else {
                        event_ok = false;
                        setTimeout(function () {
                            event_ok = true;
                        }, 100);
                        eval(preCommands);
                        eval(Command);
                        eval(postCommands);
                    }
                });
            }
        } else {
            $(ActionHelper.CurrentView.el).undelegate(selector, viewAction.attributes.Event); //Entfernt alle Events eines Typs zum Selector
            $(ActionHelper.CurrentView.el).delegate(selector, viewAction.attributes.Event, function () {
                if (ActionHelper.CurrentView.Type == 'List') {
                    var selectedCount = 0;
                    if (ActionHelper.CurrentView.ListViewObj.params.ListViewTypeParam01 == 'tablestyle') {
                        selectedCount = $(ActionHelper.CurrentView.el).find('#listView .ui-checkbox-on').length;
                    } else {
                        selectedCount = $(ActionHelper.CurrentView.el).find('#listView .ui-icon-check').length;
                    }

                    if (SelectableFieldCount == '1' && selectedCount != 1) {

                        alert(Utils.getText('ELEMENT_AUSGEWAEHLT_GENAU_1'));
                        return;
                    } else if (SelectableFieldCount == '99' && selectedCount < 1) {
                        alert(Utils.getText('ELEMENT_AUSGEWAEHLT_MIN_1'));
                        return;
                    }
                }

                eval(preCommands);
                eval(Command);
                eval(postCommands);
            });
        }

    },

    findNavBar: function (view, type) {
        var navbar = $(ActionHelper.CurrentView.el).find('#' + type + 'Navbar');
        if (navbar.length == 0) {
            var footer = $('<div />', {
                id: "footer"
            }).appendTo($(ActionHelper.CurrentView.el));
            footer.attr('data-role', 'footer');
            footer.attr('data-position', 'fixed');
            footer.attr('data-tap-toggle', 'false');

            var navBarContainer = $('<div/>', {}).appendTo(footer);
            navBarContainer.attr('data-role', 'navbar');
            footer.attr('data-theme', 'c');

            navbar = $('<ul/>', {
                id: type + 'Navbar'
            }).appendTo(navBarContainer);
        }
        return navbar;
    },

    createMenuButton: function (view, type) {
        var root = ActionHelper.findNavBar(view, type);
        var menuButton = root.find('#menuButton');
        if (menuButton.length == 0) {
            var li = $('<li />', {});
            root.prepend(li);

            var button = $('<a />', {
                id: 'menuButton',
                text: Utils.getText('AKTIONEN')
            }).appendTo(li);

            button.attr('data-icon', 'bars');
            button.click(function () {
                ActionHelper.actionsButton();
            });
        }
    },

    actionsButton: function () {
        $(ActionHelper.CurrentView.el).children("#actionPanel").panel("toggle");
    },

    /**
     * Creates needed elements for actions of a given view
     */
    prepareAction: function (view, action) {
        var functionName = "ActionHelper.prepare_" + action.attributes.ActionType;
        var type = view.attributes.ViewType;
        if (action.attributes.ActionType != 'onload') {
            var visible = true;
            if (action.attributes.IsVisible != null && action.attributes.IsVisible != '') {
                visible = eval(action.attributes.IsVisible);
            }
            if (typeof eval(functionName) == 'function' && visible) {
                eval(functionName + "(view, action, type)");
            }
        }
    },

    /**
     * Prepares parameters as a string for the action function calls
     */
    prepareParams: function (viewAction, Models) {
        var params = "";
        var postCommands = ActionHelper.preparePostaction(viewAction);

        params += "(";
        params += "this";

        params += ",";
        if (viewAction.attributes.RedirectViewId != '') {
            params += "'" + viewAction.attributes.RedirectViewId + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.RedirectHistory != '') {
            params += viewAction.attributes.RedirectHistory;
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.Param_01 != '') {
            params += "'" + viewAction.attributes.Param_01 + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.Param_02 != '') {
            params += "'" + viewAction.attributes.Param_02 + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.Param_03 != '') {
            params += "'" + viewAction.attributes.Param_03 + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.Param_04 != '') {
            params += "'" + viewAction.attributes.Param_04 + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.Param_05 != '') {
            params += "'" + viewAction.attributes.Param_05 + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (viewAction.attributes.ConfirmMessageText != '') {
            params += "'" + viewAction.attributes.ConfirmMessageText + "'";
        } else {
            params += 'null';
        }

        params += ",";
        if (Models != null && Models != '') {
            params += "'" + Models + "'";
        } else {
            params += 'null';
        }

        params += ",";
        params += "function(){  eval(" + postCommands + "); }";
        params += ")";

        return params;
    },

    /**
     * Prepares all post actions for a action
     */
    preparePostaction: function (viewAction) {
        var actionHelper = ActionHelper;
        var Models;
        if (actionHelper.Models != null && actionHelper.Models.length > 0) {
            Models = '[';
            var count = 0;
            _.each(actionHelper.Models, function (id) {
                if (count != 0) Models += ",";
                Models += '"' + id + '"';
                count++;
            })
            Models += ']';
            count = null;
        } else {
            if (actionHelper.CurrentView.model != null) {
                Models = '["' + actionHelper.CurrentView.model.id + '"]';
            }
        }

        var commands = "";
        _.each(window.genericViewActions.models, function (postAction) {
            if (postAction.attributes.RefActionId == viewAction.attributes.ViewActionId && postAction.attributes.ActionType == 'postaction' && postAction.attributes.IsActive == true) {
                commands += 'ActionHelper.' + postAction.attributes.CommandName + ActionHelper.prepareParams(postAction, Models);
            }
        });

        return commands;
    },

    /**
     * Prepares all post actions for a action
     */
    preparePreaction: function (viewAction) {
        var commands = "";
        _.each(window.genericViewActions.models, function (preAction) {
            if (preAction.attributes.RefActionId === viewAction.attributes.ViewActionId && preAction.attributes.ActionType === 'preaction' && preAction.attributes.IsActive === true) {
                if (preAction.attributes.CommandName == 'confirmation') {
                    commands += 'confirm(\"' + preAction.attributes.Param_01 + '\");';
                } else {
                    commands += 'ActionHelper.' + preAction.attributes.CommandName + ActionHelper.prepareParams(preAction);
                }
            }
        });

        return commands;
    },

    /**
     * Creates action for listItem
     */
    prepare_itemaction: function (view, viewAction, type) {
        this.registerEventHandler(viewAction);
    },

    /**
     * Creates action for listItem
     */
    prepare_swipe: function (view, viewAction, type) {
        if (viewAction.attributes.Selector == 'this') {
            viewAction.attributes.Selector = 'body';
        }
        this.registerEventHandler(viewAction);
    },

    /**
    * Creates action for Reporting
    **/
    prepare_reportaction: function (view, viewAction, type) {

    },

    /**
     * Creates menubutton element for action
     */
    prepare_menubutton: function (view, viewAction, type) {
        var found = ActionHelper.createMenuButton(view, type);
        var root = $(ActionHelper.CurrentView.el).find('#' + type + 'Menubar');

        var li = $('<li/>', {}).appendTo(root);
        var button = $('<a/>', {
            id: viewAction.attributes.ViewActionId,
            text: viewAction.attributes.ActionName,
        }).appendTo(li);

        var selector = viewAction.attributes.Selector;

        if (selector != undefined && selector != '.list_item')
            button.attr('model', selector);

        if (selector == 'this') {
            selector = '#' + viewAction.attributes.ViewActionId;
        }

        if (selector == '.list_item') {
            selector = '#' + viewAction.attributes.ViewActionId;
        }

        if (viewAction.attributes.CommandName == 'lookupPropertySelect') {
            selector = "#" + viewAction.attributes.ViewActionId;
        }

        this.registerEventHandler(viewAction, selector);
    },

    /**
     * Creates navbutton element for action
     */
    prepare_navbutton: function (view, viewAction, type) {
        var root = ActionHelper.findNavBar(view, type);
        var li = $('<li/>', {}).appendTo(root);

        var button = $('<a/>', {
            id: viewAction.get('ViewActionId'),
            text: viewAction.get('ActionName'),
        }).appendTo(li);

        if (viewAction != undefined && viewAction.get('RedirectViewId') != undefined
            && (viewAction.get('RedirectViewId') === '66eebc1e-e64c-b907-ad5b-b59fcaa69f1a' || viewAction.get('RedirectViewId') === '80697c82-e71a-4bfd-990e-56f6f8e68262')
            && ActionHelper.CurrentView != undefined
            && ActionHelper.CurrentView.model != undefined
            && ActionHelper.CurrentView.model.id != undefined
            ) {

            var redView = GenericHelper.getViewByViewId(viewAction.get('RedirectViewId'))
            var refObjects = _.filter(window.genericData.models, function (data) {
                return (data.get('EntityId') === redView.get('EntityId') && data.get('IsActive') === true && data.get('Custom_005') === ActionHelper.CurrentView.model.id);
            });

            var refObjects = GenericHelper.filterGenericData(view, refObjects);
            var count = refObjects.length;
            if (count > 0) {
                button.addClass('bg_color_red');
                button.text(viewAction.get('ActionName') + ' (' + count + ')');
            }
        }

        var icon = viewAction.get('IconName');
        if(icon) {
            button.attr('data-icon', icon);
        } else {
            button.addClass('action_without_icon');
        }
        
        var selector = viewAction.get('Selector');
        if (selector === 'this' || selector === '.list_item') {
            selector = '#' + viewAction.get('ViewActionId');
        }

        this.registerEventHandler(viewAction, selector);
    },

    /**
     * Deletes the model of the current view
     */
    deleteItem: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var confirmMessage = Utils.getText('EINTRAG_LOESCHEN_BEST');
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            confirmMessage = confirmMessageText;
        }

        var model = ActionHelper.CurrentView.model;
        showConfirmMessage(confirmMessage, function (buttonIndex) {
            if (buttonIndex === 1) {
                var oldModel = jQuery.extend(true, {}, ActionHelper.CurrentView.model);
                ActionHelper.OldModels.push(oldModel);
                var dataRawElement = window.genericData.get(model.attributes.ObjectId);

                if (dataRawElement != null) {
                    dataRawElement.set("IsActive", false);
                    dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
                    ActionHelper.IsValid = true;
                    dataRawElement.saveItem();
                    window.genericData.add(dataRawElement);
                }
                if (ActionHelper.IsValid) {
                    ActionHelper.navigate(element, redirectViewId, redirectHistory);
                }
            }
        }, '', Utils.getText('OK_ABBRECHEN'));
    },

    /**
     * Deletes the all selected models of the current view
     */
    deleteSelectedItems: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var dataRawElement;
        var confirmMessage = Utils.getText('EINTRAEGE_MARKIERT_LOESCHEN_BEST');
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            confirmMessage = confirmMessageText;
        }
        showConfirmMessage(confirmMessage, function (buttonIndex) {
            if (buttonIndex !== 1) {
                return;
            }

            $(ActionHelper.CurrentView.el).find('#listView .checkBox').each(function () {
                if ($(this).hasClass("ui-icon-check") || $(this.parentNode.firstChild).hasClass("ui-checkbox-on")) {
                    dataRawElement = window.genericData.get(this.id);
                    var oldModel = jQuery.extend(true, {}, dataRawElement);
                    ActionHelper.OldModels.push(oldModel);
                    dataRawElement.set("IsActive", false);
                    dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;

                    /*Falls Attachment auch von Festplatte löschen*/
                    if (dataRawElement.attributes.EntityId === CONSTS.ATTACHEMENTS_ENTITY_ID) {
                        dataRawElement.CustomMax001 = null;
                        var filename = dataRawElement.attributes.Custom_006;
                        FileHelper.deleteFile(filename, "MF_DATA");
                    }

                    window.genericData.add(dataRawElement);
                    dataRawElement.saveItem();
                    window.genericData.add(dataRawElement);
                    if (ActionHelper.IsValid == true) {
                        //Eintrag aus DOM entfernen
                        var element = $(this.parentNode.firstChild);
                        var checked = element.hasClass("ui-checkbox-on")
                        if (checked) {
                            $(this).closest('tr').remove();
                        } else {
                            $(this.parentNode).remove();
                        }
                    }
                }
            });
            if (dataRawElement != null) {
                dataRawElement.syncWithServer();
            }
        }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
    },

    /**
     * Saves model of current view
     */
    saveItem: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var that = this;
        
        var save = function() {
            if (ActionHelper.CurrentView.model) {
                var model = window.genericData.get(ActionHelper.CurrentView.model.id);
                if (model && model.get('EntityId') && model.get('EntityId') === ActionHelper.CurrentView.model.get('EntityId')) {
                    if (ActionHelper.CurrentView.Type !== "Insert") {
                        ActionHelper.CurrentView.model = ActionHelper.setModelAttributes(ActionHelper.CurrentView.model);
                    }
                }

                if (ActionHelper.CurrentView.Type === "Insert") {
                    ActionHelper.CurrentView.model = ActionHelper.setModelAttributes(ActionHelper.CurrentView.model);
                }
            }

            if (ActionHelper.ViewDeactivated) {
                return;
            }

            if (!ActionHelper.Models || ActionHelper.Models.length === 0) {
                if (ActionHelper.CurrentView.model) {
                    that.saveCurrentModel(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models);
                    ActionHelper.CurrentView.options.modelId = ActionHelper.CurrentView.model.id;
                }

                return;
            }

            var doContinue = true;
            _.each(ActionHelper.Models, function (modelID) {
                if(!doContinue) {
                    return;
                }

                if (ActionHelper.CurrentView.Type == "Insert") {
                    var newModel = ActionHelper.setModelAttributes(null, modelID);
                    var refModel = window.genericData.get(modelID);

                    if (refModel) {
                        if (param_03) {
                            var refModelId = refModel.get(param_03);
                            ActionHelper.CurrentView.options.refModelId = refModelId;
                        } else {
                            ActionHelper.CurrentView.options.refModelId = refModel.id;
                        }
                    }

                    ActionHelper.CurrentView.model = newModel;
                    ActionHelper.CurrentView.model.PersistToLocalStorageImmediately = false;
                    doContinue = that.saveCurrentModel(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models);
                    ActionHelper.CurrentView.model.IsNew = false;
                } else {
                    ActionHelper.CurrentView.model = _.first(_.filter(window.genericData.models, function (model) {
                        return model.get('ObjectId') == modelID;
                    }));
                    ActionHelper.CurrentView.model.IsNew = false;
                    ActionHelper.CurrentView.model.PersistToLocalStorageImmediately = false;

                    doContinue = that.saveCurrentModel(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models);
                }
            });

            if (ActionHelper.Models.length > 0) {
                // workaround for the memory leak while saving to local storage in loop
                // this method call writes the backbone collection/model to the local storage after processing the loop
                window.persistGenericData();
            }
        }

        var afterSave = function() {
            if (!ActionHelper.IsValid) {
                return;
            }

            var dataRawElement = new window.GenericDataRawElement();
            dataRawElement.syncWithServer();
            dataRawElement = null;
            if (param_04 == 'true') {
                ActionHelper.tmpModel = undefined;
            }

            if (ActionHelper.tmpModelArray && ActionHelper.tmpModelArray.length > 0) {
                ActionHelper.doNavigate(element, ActionHelper.CurrentView.options.view.id, 0, param_01, param_02);
            } else {
                ActionHelper.doNavigate(element, redirectViewId, redirectHistory, param_01, param_02);
            }
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex === 1) {
                    save();
                }
                
                afterSave();
                return;
            }, '', Utils.getText('OK_ABBRECHEN'));

            return;
        }

        save();
        afterSave();
    },

    saveCurrentModel: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var success = true;

        var dataRawElement = ActionHelper.CurrentView.model;
        if (dataRawElement == undefined) {
            ActionHelper.CurrentView.model = _.find(window.genericData.models, function (model) {
                return model.attributes.DataId == ActionHelper.CurrentView.options.modelId;
            });

            dataRawElement = ActionHelper.CurrentView.model;
        }

        ActionHelper.OldModels.push(jQuery.extend(true, {}, ActionHelper.CurrentView.model));

        var refModelId = ActionHelper.CurrentView.options.refModelId;
        dataRawElement = ActionHelper.setModelAttributes(dataRawElement, refModelId);
        if (dataRawElement != null) {
            success = dataRawElement.saveItem();
            if (ActionHelper.IsValid) {
                if (dataRawElement.signatures != null && dataRawElement.signatures.length > 0) {

                    _.each(dataRawElement.signatures, function (signature) {
                        signature.attributes.Custom_009 = 'signature';
                        signature.saveItem();
                        window.genericData.add(signature);
                    });
                }
                window.genericData.add(dataRawElement);
            }
        } else {
            success = false;
        }
        
        return success;
    },

    sortListPopUp: function () {
        var popup = $("<div/>", {
            "id": "sortPopUp", //Achtung ID wird zu sortPopUp-popup nach aufruf von popup.popup()
            "data-role": "popup",
            "data-theme": "a",
            "data-overlay-theme": "a",
            "data-transition": "pop",
            "style": "overflow-y:scroll; width:70%"
        }).popup();

        popup.on("popupafterclose", function () {
            $(this).popup("destroy"); //removes popup from DOM
        });

        //create content div - makes a nice jQM page structure.
        var content = $("<div/>", {
            "data-role": "content",
        }).appendTo(popup);

        var BuildList = $.proxy(function () {
            //deep Copy firstListElem
            if (this.CurrentView.ListViewObj == undefined){
                return;
            }

            var firstListElem = jQuery.extend(true, {}, this.CurrentView.ListViewObj.ListElements[0]);
            var saveSortFunction;

            if (!Utils.isNull(firstListElem)) {

                //Get sortSettings sorted by hierarchy
                var settings = this.CurrentView.getSettings();
                var sortSettings = settings.sort;

                var sortJSON = [];
                //push Properties sorted by hierarchy to sortJSON, and remove them from firstListElem deep Copy
                var hierarchy = 0;
                for (hierarchy = 0; hierarchy < sortSettings.length; hierarchy++) {
                    var sortSetting = sortSettings[hierarchy];
                    var prop;
                    for (var i = 0; i < firstListElem.properties.length; i++) {
                        if (firstListElem.properties[i].id == sortSetting.propId) {
                            prop = firstListElem.properties[i];
                            sortJSON.push({ propId: prop.id, sort: sortSetting.sort, label: prop.label });
                            firstListElem.properties.splice(i, 1);
                        }
                    }
                }
                //Iterate over remaining properties of firstListElem deep Copy and push them to sortJSON
                _.each(firstListElem.properties, function (prop) {
                    sortJSON.push({ propId: prop.id, sort: "none", label: prop.label })
                });

                //Build List out of sortJSON    
                var myContent = $('<ul data-role="listview" data-inset="true"></ul>',
                    {

                    }
                    );
                _.each(sortJSON, function (sortElem) {

                    var li = $('<li>', {
                        "data-icon": "false",//"carat-d",
                        "sorting": sortElem.sort,
                    }).appendTo(myContent);

                    function getSortText(sortBy) {
                        if (sortBy == "desc") {
                            return "Absteigende Sortierung";
                        }
                        else if (sortBy == "asc") {
                            return 'Aufsteigende Sortierung';
                        }
                        else {
                            return "Keine Sortierung";
                        }
                    }

                    //List Item Content
                    var btn = $('<a/>', {
                        "style": "padding-top:0px;padding-bottom:0px"
                    }).appendTo(li);
                    var btnTitle = $('<h3/>', {
                        text: sortElem.label //+ '//' + sortElem.hierarchy
                    }).appendTo(btn);
                    var description = $('<p/>', {
                        text: getSortText(sortElem.sort),
                    }).appendTo(btn);

                    //Click Event Handler 
                    li.click(function () {
                        var sorting = $(this).attr("sorting")
                        if (sorting == "none") {
                            $(this).addClass("ui-icon-carat-l")
                            $(this).attr("sorting", "desc");
                            sortElem.sort = "desc";
                        }
                        else if (sorting == "desc") {
                            $(this).attr("data-icon", "carat-u");
                            $(this).attr("sorting", "asc");
                            sortElem.sort = "asc";
                        }
                        else {
                            $(this).attr("data-icon", "none");
                            $(this).attr("sorting", "none");
                            sortElem.sort = "none";
                        }

                        $(this).find('p').text(getSortText(sortElem.sort));
                        myContent.listview('refresh');
                    });

                });

                myContent.appendTo(content).listview();
                myContent.sortable();
                myContent.disableSelection();
                // Refresh list to the end of sort to have a correct display and change sortJSON-->
                myContent.bind("sortstart", function (event, ui) {
                    ui.item.startPos = ui.item.index();
                });

                myContent.bind("sortstop", function (event, ui) {
                    var oldIndex = ui.item.startPos;
                    var newIndex = ui.item.index();

                    var oldSortObj = jQuery.extend(true, {
                    }, sortJSON[oldIndex]);

                    if (oldIndex < newIndex) {
                        for (var i = oldIndex; i < newIndex; i++) {
                            sortJSON[i] = sortJSON[i + 1];
                        }
                    }
                    if (oldIndex > newIndex) {
                        for (var i = oldIndex; i > newIndex; i--) {
                            sortJSON[i] = sortJSON[i - 1];
                        }
                    }
                    sortJSON[newIndex] = oldSortObj;
                    myContent.listview('refresh');
                });

                saveSortFunction = function () {
                    settings.sort = sortJSON;
                    ActionHelper.CurrentView.saveSettings(settings);
                    ActionHelper.CurrentView.render();
                }

                //Create Buttons
                var buttonList = $('<div/>', {
                    'data-role': 'controlgroup',
                    'data-type': 'horizontal'
                }).appendTo(content);

                var btnSortReset = $("<a/>", {
                    "html": "Zurücksetzen",
                    "class": 'ui-btn ui-corner-all ui-icon-delete ui-btn-icon-left'
                }).on("click", function () {
                    sortJSON = [];
                    settings.sort = sortJSON;
                    ActionHelper.CurrentView.saveSettings(settings);
                    //Refresh List
                    popup.popup('close');
                    content.empty();
                    BuildList();
                }).buttonMarkup({
                    icon: "back"
                });

                btnSortReset.appendTo(buttonList);

                //create close element
                var btnSave = $("<a/>", {
                    "html": "   Anwenden",
                    "class": 'ui-btn ui-corner-all ui-icon-delete ui-btn-icon-left'
                }).on("click", function () {
                    //click event of close element
                    if ($.isFunction(saveSortFunction)) {
                        saveSortFunction();
                    };

                    $(this).closest("[data-role=popup]").popup("close");
                }).buttonMarkup({
                    icon: "check"
                });
                btnSave.appendTo(buttonList);
            }
            else {
                content.append("Es sind keine Daten zum sortieren vorhanden");

                //create close element
                var btnClose = $("<a/>", {
                    "data-role": "button",
                    "html": "Schließen",
                    "data-theme": "e"
                }).on("click", function () {
                    $(this).closest("[data-role=popup]").popup("close");
                }).buttonMarkup();

                content.append(btnSave);
            }
        }, this);

        BuildList();
        popup.popup('open');
    },

    setModelAttributes: function (dataRawElement, refModelId) {
        if (ActionHelper.CurrentView.options.view == null) {
            return;
        }
        var saveEmptyValues = !ActionHelper.CurrentView.options.view.attributes.MultiEditSaveOnlyEdits;
        var view = ActionHelper.CurrentView;
        if (dataRawElement != null && (view.options.view.attributes.EntityId != dataRawElement.attributes.EntityId)) {
            //ERROR Saving model from diffrent EntityId...
            if (ActionHelper.IsValid != false) {
                ActionHelper.IsValid = false;
                var newLine = ' <br/> ';
                var body = Utils.getText('GENERIC_DATA_FALSCHE_ENTITAET') + newLine + newLine;

                body += newLine;
                body += Utils.getText('BENUTZER') + ':' + newLine;
                body += Utils.getText('BENUTZER_ID') + ':' + window.currentUser.UserId + newLine;
                body += Utils.getText('MANDANT_ID') + ':' + window.currentUser.MandatorId + newLine;
                body += Utils.getText('ORG_EINHEIT_ID') + ':' + window.currentUser.OrgUnitId + newLine;

                body += newLine;
                body += Utils.getText('GERAETE_ID') + ':' + window.currentDevice.DeviceId + newLine;

                body += newLine;
                body += Utils.getText('OBJEKT') + newLine;
                _.each(dataRawElement.attributes, function (value, key) {
                    body += key + ': ' + value + newLine;
                });

                body += newLine;
                body += Utils.getText('VIEW') + newLine;
                _.each(view.options.view.attributes, function (value, key) {
                    body += key + ': ' + value + newLine;
                });

                body += newLine;
                body += 'ActionHelper.Models:' + newLine;
                _.each(ActionHelper.Models, function (value, key) {
                    body += key + ': ' + value + newLine;
                });

                body += newLine;
                body += 'ActionHelper.ReturnField: ' + ActionHelper.ReturnField + newLine;
                body += 'ActionHelper.ReturnID: ' + ActionHelper.ReturnID + newLine;
                body += 'ActionHelper.ReturnValue: ' + ActionHelper.ReturnValue + newLine;
                body += 'ActionHelper.NavFilter: ' + ActionHelper.NavFilter + newLine;
                body += 'ActionHelper.CopyValues: ' + ActionHelper.CopyValues + newLine;

                SyncController.sendMail(
                    'mfapp@mobile-function.com',
                    null,
                    null,
                    'Error: Model and view do not have the same EntityId',
                    body,
                    null,
                    null
                    );
                window.app.navigate('', { trigger: true, replace: false });

                alert(Utils.getText('FEHLER_GESENDET_SUPPORT'));
            }
            return null;
        } else {
            var signatures = [];
            if (saveEmptyValues == undefined)
                saveEmptyValues = true;

            if (dataRawElement == null || dataRawElement == new window.GenericDataRawElement()) {
                dataRawElement = new window.GenericDataRawElement();
                dataRawElement.attributes.EntityId = ActionHelper.CurrentView.options.view.attributes.EntityId;
                var itemId = window.generateGuid();
                dataRawElement.attributes.DataId = itemId;
                dataRawElement.attributes.ObjectId = itemId;
                dataRawElement.id = itemId;
                dataRawElement.attributes.UserId = window.currentUser.UserId;
                dataRawElement.attributes.MandatorId = window.currentUser.MandatorId;
                dataRawElement.attributes.OrgUnitId = window.currentUser.OrgUnitId;
                dataRawElement.attributes.IsActive = true;
                dataRawElement.attributes.EntryTime = moment().format(CONSTS.DATETIME_PERSIST_FORMAT);
                dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
                dataRawElement.IsNew = true;
            }

            var genericFields = _.filter(window.genericViewFields.models, function (field) {
                return field.attributes.ViewId == ActionHelper.CurrentView.options.view.id &&
                    field.attributes.IsActive == true &&
                    (field.attributes.AssociatedViewField == CONSTS.GUID_DEFAULT || field.attributes.AssociatedViewField == undefined)
            });

            var setPropertyVal = function (gcn, val) {
                if (!saveEmptyValues) {
                    if (!Utils.isNull(val)) {
                        dataRawElement.set(gcn, val);
                    }
                } else {
                    dataRawElement.set(gcn, val);
                }
            }

            _.each(genericFields, function (field) {
                var genericProperty = window.genericProperties.get(field.attributes.PropertyId);
                var gcn = genericProperty.attributes.GenericColumnName;
                if ($('#' + field.attributes.FieldId) != null) {
                    switch (genericProperty.attributes.DataType) {
                        case "decimal":
                            var prop_format = Utils.getNumberFormat(genericProperty.attributes.Precision, genericProperty.attributes.Scale);
                            if ($('#' + field.attributes.FieldId).val() != null) {
                                var numberString = $('#' + field.attributes.FieldId).val();
                                var numberStringUnifiyed = FormatHelper.getDecimalPersistantValue(numberString);
                                var numberFloat = parseFloat(numberStringUnifiyed);
                                if (isNaN(numberFloat) || numberFloat == null) {
                                    setPropertyVal(gcn, '');
                                } else {
                                    setPropertyVal(gcn, numberFloat);
                                }
                            } else {
                                if (saveEmptyValues)
                                    setPropertyVal(gcn, '');
                            }
                            break;
                        case "bit":
                            if ($('#' + field.attributes.FieldId).is(":checked")) {
                                setPropertyVal(gcn, 1);
                            } else {
                                setPropertyVal(gcn, 0);
                            }
                            break;
                        case "date":
                            var dateString = $('#' + field.attributes.FieldId).val();
                            if (dateString != '' && dateString != null && dateString != undefined) {
                                dateString = dateString.toString();
                                var dateValue = moment(dateString, FormatHelper.get_DATE_FORMAT()).format(CONSTS.DATE_PERSIST_FORMAT, 'de');
                                setPropertyVal(gcn, dateValue);
                            }
                            break;
                        case "datetime":
                            var dateString = $('#' + field.attributes.FieldId).val();
                            if (dateString != '' && dateString != null && dateString != undefined) {
                                dateString = dateString.toString();
                                var dateValue = moment(dateString, FormatHelper.get_DATETIME_FORMAT()).format(CONSTS.DATETIME_PERSIST_FORMAT, 'de');
                                setPropertyVal(gcn, dateValue);
                            }
                            break;
                        case "time":
                            var dateString = $('#' + field.attributes.FieldId).val();
                            if (dateString != '' && dateString != null && dateString != undefined) {
                                dateString = dateString.toString();
                                var dateValue = moment(dateString, FormatHelper.get_TIME_FORMAT()).format(CONSTS.TIME_PERSIST_FORMAT, 'de');
                                setPropertyVal(gcn, dateValue);
                            }
                            break;
                        case "decision":
                            var containsdecision = false;
                            if ($('#radioTrue' + field.attributes.FieldId).is(":checked")) {
                                setPropertyVal(gcn, '1');
                                containsdecision = true;
                            }

                            if ($('#radioFalse' + field.attributes.FieldId).is(":checked")) {
                                setPropertyVal(gcn, '0');
                                containsdecision = true;
                            }

                            if (!containsdecision) {
                                setPropertyVal(gcn, '');
                            }

                            break;
                        case "signature":
                            var sig = $('#' + field.attributes.FieldId);
                            var IsEmpty = sig.data("params").isEmpty;
                            var refId = dataRawElement.get(gcn);
                            var signature = window.genericData.get(refId);
                            var value = sig.attr('src');

                            if (sig.data("params").hasChanged) {
                                dataRawElement.attributes.hasChanged = true;
                                if (IsEmpty || !value) {
                                    //REMOVE EXISTING SIGNATURE 
                                    if (signature != null) {
                                        window.genericData.remove(signature);
                                        signature.destroy();
                                    }
                                    setPropertyVal(gcn, null);
                                } else {
                                    //SAVE SIGNATURE
                                    if (signature == null) {
                                        //CREATE NEW ATTACHMENTS-OBJEKT TO SAVE SIGNATURE
                                        signature = new window.GenericDataRawElement();
                                        signature.IsNew = true;
                                        var itemId = window.generateGuid();
                                        signature.id = itemId;

                                        signature.set({
                                            DataId: itemId,
                                            ObjectId: itemId,
                                            IsActive: true,
                                            SyncTime: CONSTS.DATE_DEFAULT,
                                            EntityId: CONSTS.ATTACHEMENTS_ENTITY_ID,
                                            UserId: window.currentUser.UserId,
                                            MandatorId: window.currentUser.MandatorId,
                                            OrgUnitId: window.currentUser.OrgUnitId
                                        });
                                        setPropertyVal(gcn, itemId);
                                    } else {
                                        signature.set({ SyncTime: CONSTS.DATE_DEFAULT });
                                        signature.IsNew = false;
                                    }
                                    var type = value.substring(11, 14);
                                    var data = value.substring(22, value.length);
                                    signature.set('Custom_001', type);
                                    signature.set('Custom_020', true);
                                    signature.set('Custom_004', dataRawElement.attributes.EntityId);
                                    signature.set('Custom_005', dataRawElement.id);
                                    signature.set('Custom_009', 'signature');
                                    if (window.navigator.notification) { // window.navigator.notification ist nur auf mobilen Geräten present
                                        FileHelper.saveFile(data, signature.get('DataId'), type, "MF_DATA", LocalFileSystem.PERSISTENT, false)
                                    } else {
                                        signature.set('CustomMax_001', data);
                                    }
                                    signatures.push(signature);
                                }
                            }
                            break;
                        case "preview":
                            break;
                        default:
                            var tmp = $('#' + field.attributes.FieldId).val();
                            if (tmp != undefined)
                                setPropertyVal(gcn, $('#' + field.attributes.FieldId).val());
                            break;
                    }
                }
                if (($('#' + field.attributes.FieldId).val() == '' || $('#' + field.attributes.FieldId).val() == null) &&
                    genericProperty.attributes.DataType != "signature" &&
                    genericProperty.attributes.DataType != "decision") {
                    setPropertyVal(gcn, null);
                }
            });

            dataRawElement.attributes.UserId = window.currentUser.UserId;
            dataRawElement.attributes.MandatorId = window.currentUser.MandatorId;
            dataRawElement.attributes.OrgUnitId = window.currentUser.OrgUnitId;

            //SET REF OBJ
            if (refModelId != undefined && refModelId != "undefined" && refModelId != "null") {
                refModel = _.find(window.genericData.models, function (data) {
                    return data.attributes.ObjectId == refModelId;
                });
                if (refModel) {
                    var genericProperty = _.find(window.genericProperties.models, function (property) {
                        return (property.attributes.EntityId == dataRawElement.attributes.EntityId && property.attributes.LookupEntityId == refModel.attributes.EntityId);
                    });

                    if (genericProperty) {
                        setPropertyVal(genericProperty.attributes.GenericColumnName, refModelId);
                    }
                }
            }


            dataRawElement.signatures = signatures;
            if (dataRawElement.attributes.hasChanged) {
                dataRawElement.attributes.EntryTime = moment().format(CONSTS.DATETIME_PERSIST_FORMAT);
                dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
            }

            return dataRawElement;
        }
    },

    lookupPropertySelect: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models, viewField) {
        var confirmed = true;

        if (param_01 == undefined) {
            param_01 = "true";
        }

        var select = function() {
            var target = $(element);
            var modelId = ActionHelper.CurrentView.options.modelId;
            var refModelId = ActionHelper.CurrentView.options.refModelId;
            var refNavId = ActionHelper.CurrentView.options.refNavId;
            var isRef = false;

            if (target.length > 0 || viewField != undefined) {
                if (target.data("params") != null) {
                    var modelId = target.data("params").param_01;
                    var refModelId = target.data("params").param_02;
                }
                else {
                    if (element != undefined)
                        var objectid = _.first(_.filter(element.attributes, function (attribute) {
                            return attribute.name == "model";
                        }));

                    if (objectid != undefined || viewField != undefined) {
                        if (ActionHelper.CurrentView.model != undefined && ActionHelper.CurrentView.options.view.attributes.ViewType != 'Insert') {
                            if (ActionHelper.Models == undefined) {
                                ActionHelper.Models = new Array();
                            }
                            if (ActionHelper.Models.indexOf(ActionHelper.CurrentView.model.id) < 0)
                                ActionHelper.Models.push(ActionHelper.CurrentView.model.id);
                        }
                        if (objectid != undefined) {
                            viewField = _.first(_.filter(window.genericViewFields.models, function (field) {
                                return field.attributes.FieldId == objectid.value.toLowerCase().replace('#', '') && field.attributes.IsActive == true;
                            }));
                        }
                        if (param_02 != undefined && param_02.length > 0 && viewField != null) {
                            var val = undefined;

                            if (param_02 == 'ObjectId') {
                                val = ActionHelper.CurrentView.model.get(param_02);
                            }
                            else {
                                var property = _.first(_.filter(window.genericProperties.models, function (genericProperty) {
                                    return genericProperty.attributes.PropertyId == viewField.attributes.PropertyId;
                                }));
                                ActionHelper.CurrentView.model.get(property.attributes.GenericColumnName)
                                val = GenericHelper.getCustomValue(ActionHelper.CurrentView.model, property.attributes.GenericColumnName, param_02);
                            }
                            ActionHelper.NavFilter = val;
                            localStorage.setItem(redirectViewId, ActionHelper.NavFilter);
                        }
                        else {
                            ActionHelper.NavFilter = '';
                            localStorage.setItem(redirectViewId, ActionHelper.NavFilter);
                        }
                        if (viewField == undefined) {
                            refNavId = undefined;
                            ActionHelper.ReturnField = objectid.value;
                        }
                        else {
                            if (param_01 == "true")
                                refNavId = viewField.attributes.PropertyId;
                            ActionHelper.ReturnField = viewField;
                        }

                        ActionHelper.ReturnID = refNavId;
                    }

                }
            }
            var isRef = false;
            if (param_01 != null && param_01 != "") {
                isRef = param_01;
            }
            var model = new GenericDataRawElement();

            if (ActionHelper.isMassUpdate()) {
                _.each(ActionHelper.Models, function (modlid) {
                    var modl = null;
                    if (ActionHelper.CurrentView.Type != 'Insert') {
                        modl = _.first(
                            _.filter(window.genericData.models, function (m) {
                                return m.attributes.ObjectId == modlid;
                            })
                        );
                    }

                    if (modl != null) {
                        for (attr in modl.attributes) {
                            model.set(attr, modl.attributes[attr]);
                        }
                        modl = ActionHelper.setModelAttributes(model);
                        ActionHelper.tmpModel = modl;
                    }
                    else {

                        for (attr in ActionHelper.CurrentView.model.attributes) {
                            model.set(attr, ActionHelper.CurrentView.model.attributes[attr]);
                        }
                        ActionHelper.tmpModel = ActionHelper.setModelAttributes(model);
                    }

                });
            }
            else {
                ActionHelper.tmpModel = ActionHelper.setModelAttributes();
            }
            var options = ActionHelper.CurrentView.options;
            if (refNavId == undefined)
                refNavId = "null";

            if (redirectViewId != null && redirectViewId != 'null' && redirectViewId != '' && redirectViewId != CONSTS.GUID_DEFAULT) {
                if (isRef) {
                    window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refNavId, { trigger: true });
                } else {
                    window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refModelId, { trigger: true });
                }
            } else {
                if (redirectHistory != "" && redirectHistory != null && redirectHistory != CONSTS.INTEGER_DEFAULT) {
                    if (redirectHistory != 'none') {
                        window.history.back(parseInt(redirectHistory));
                    }
                } else {
                    var view = ActionHelper.CurrentView.options.view;
                    var createViewString = 'new window.' + view.attributes.ViewType + 'View({ view: view, modelId: modelId, refModelId: refModelId });'
                    var page = jQuery.extend(true, {}, eval(createViewString));
                    var viewTypeId = '#' + view.attributes.ViewType;

                    $(viewTypeId).empty();
                    $(viewTypeId).append($(page.el));
                    page.render();
                    $.mobile.changePage(viewTypeId, { changeHash: false });
                }
            }
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }

                select();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }
        select();
    },

    lookupPropertySave: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var save = function() {
            var target = $(element);
            var modelId = ActionHelper.CurrentView.options.modelId;
            var refModelId = ActionHelper.CurrentView.options.refModelId;
            var refNavId = ActionHelper.CurrentView.options.refNavId;
            var isRef = false;

            if (target.length > 0) {
                if (target.data("params") != null) {
                    modelId = target.data("params").param_01;
                    refModelId = target.data("params").param_02;
                }

                var newModel
                if (ActionHelper.CurrentView.Type == 'Insert') {
                    var model = ActionHelper.setModelAttributes();
                    element.id = model.id;
                    model.saveItem();
                }
                if (window.genericData.get(element.id) == undefined) {

                    SyncController.searchDataByDataID(modelId, ActionHelper.CurrentView.options.view.id, ActionHelper.CurrentView.options.view.attributes.EntityId, function () {
                        return;
                    });
                    newModel = _.find(SyncController.TmpData, function (TmpData) {
                        return TmpData.attributes.DataId == modelId;
                    });
                    if (newModel != undefined) {
                        GenericHelper.addModel(newModel, false, false);
                    }
                    SyncController.TmpData = null;
                }

                if (ActionHelper.Models != undefined && ActionHelper.Models.length > 0) {

                    _.each(ActionHelper.Models, function (modelID) {
                        var genericProperty = window.genericProperties.get(ActionHelper.ReturnID);
                        if (genericProperty == undefined || genericProperty.attributes.LookupEntityId == undefined || genericProperty.attributes.LookupEntityId == "" || genericProperty.attributes.LookupEntityId == CONSTS.GUID_DEFAULT) {
                            if (param_02 != null && param_02 != "") {
                                ActionHelper.ReturnValue = window.genericData.get(element.id).get(param_02);
                            } else {
                                ActionHelper.ReturnValue = window.genericData.get(element.id).attributes.ObjectId;
                            }
                        }
                        else {
                            var luProperty = _.first(_.filter(window.genericProperties.models, function (genProperty) {
                                return genProperty.attributes.EntityId == window.genericData.get(element.id).attributes.EntityId
                                && genProperty.attributes.LookupEntityId == genericProperty.attributes.LookupEntityId;
                            }));

                            if (luProperty != undefined) {
                                var gcn = luProperty.attributes.GenericColumnName;
                                ActionHelper.ReturnValue = window.genericData.get(element.id).get(gcn);
                            }
                            else {
                                if (param_02 != null && param_02 != "") {
                                    ActionHelper.ReturnValue = window.genericData.get(element.id).get(param_02);
                                } else {
                                    ActionHelper.ReturnValue = window.genericData.get(element.id).attributes.ObjectId;
                                }
                            }
                        }
                    });
                }
                else {
                    if (param_02 != null && param_02 != "") {
                        ActionHelper.ReturnValue = window.genericData.get(element.id).get(param_02);
                    } else {
                        ActionHelper.ReturnValue = window.genericData.get(element.id).attributes.ObjectId;
                    }
                }
            }
            var isRef = false;
            if (param_01 != null && param_01 != "") {
                isRef = param_01;
            }

            if (refNavId == undefined)
                refNavId = "null";

            if (redirectViewId != null && redirectViewId != 'null' && redirectViewId != '' && redirectViewId != CONSTS.GUID_DEFAULT) {
                if (isRef) {
                    window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refNavId, { trigger: true });
                } else {
                    window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refModelId, { trigger: true });
                }
            } else {
                if (redirectHistory != "" && redirectHistory != null && redirectHistory != CONSTS.INTEGER_DEFAULT) {
                    if (redirectHistory != 'none') {
                        window.history.back(parseInt(redirectHistory));
                    }
                } else {

                    var view = ActionHelper.CurrentView.options.view;

                    var createViewString = 'new window.' + ActionHelper.CurrentView.options.view.attributes.ViewType + 'View({ view: view, modelId: modelId, refModelId: refModelId });'

                    var page = jQuery.extend(true, {}, eval(createViewString));

                    var viewTypeId = '#' + ActionHelper.CurrentView.options.view.attributes.ViewType;

                    $(viewTypeId).empty();
                    $(viewTypeId).append($(page.el));
                    page.render();
                    $.mobile.changePage(viewTypeId, { changeHash: false });
                }
            }
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {

            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }

                save();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }
        save();
    },

    awsomeSave: function (param, onSaveReady) {
        ActionHelper.IsValid = true;
        var ViewType = ActionHelper.CurrentView.options.view.get('ViewType');

        var saveExistingModels = function() 
        {
            //Check for Models to save
            //INSERT NEW MODEL FOR EVERY ActionHelper.Models AND ADD REFERENCE TO IT
            if (ViewType === 'Insert') {
                var doContinue = true;
                _.each(ActionHelper.Models, function (modelId) {
                    if (doContinue) {
                        var model = ActionHelper.setModelAttributes();
                        var refModel = window.genericData.get(modelId);

                        if (refModel != undefined) {
                            var luProperty = _.first(_.filter(window.genericProperties.models, function (genProperty) {
                                return genProperty.get('LookupEntityId') == refModel.get('EntityId') && genProperty.get('EntityId') === model.get('EntityId');
                            }));
                        }

                        if (luProperty != undefined) {
                            var gcn = luProperty.get('GenericColumnName');
                            model.set(gcn, modelId);
                        }

                        //Check if model has changed and need to be persisted
                        if (model.get('hasChanged')) {
                            doContinue = model.saveItem();

                            if (model.signatures.length > 0) {
                                _.each(model.signatures, function (signature) {
                                    signature.saveItem();
                                    window.genericData.add(signature);
                                });
                            }
                        }
                        //Remove model reference
                        model = null;
                        refModel = null;
                    }
                });
            } else {
                //SAVE ALL MODELS IN ActionHelper.Models
                var doContinue = true;
                _.each(ActionHelper.Models, function (modelId) {
                    if (doContinue) {
                        var model = window.genericData.get(modelId);
                        if (model != undefined && ActionHelper.CurrentView.options.view.get('EntityId') === model.get('EntityId')) {
                            var oldModel = jQuery.extend(true, {}, model);
                            ActionHelper.OldModels.push(oldModel);

                            model = ActionHelper.setModelAttributes(model, ActionHelper.CurrentView.options.refModelId);

                            //Check if model has changed and need to be persisted
                            if (model.get('hasChanged')) {
                                model.PersistToLocalStorageImmediately = false;
                                doContinue = model.saveItem();
                            }
                        }
                        //Remove model reference
                        model = null;
                    }
                });
                window.persistGenericData();
            }

            if (ActionHelper.IsValid) {
                ActionHelper.Models.length = 0;
                ActionHelper.Models = null;
            }
        }

        var saveNewModel = function() {
            var oldModel = jQuery.extend(true, {}, ActionHelper.CurrentView.model);
            ActionHelper.OldModels.push(oldModel);
            var model = ActionHelper.setModelAttributes(ActionHelper.CurrentView.model);
            model.id = model.get('ObjectId');
            model.saveItem();

            if (model.signatures.length > 0) {
                _.each(model.signatures, function (signature) {
                    signature.saveItem();
                    window.genericData.add(signature);
                });
            }          
        }

        var performSaving = function() {
            if (ActionHelper.Models != null && ActionHelper.Models.length > 0) {
                saveExistingModels();
                if (_.isFunction(onSaveReady)) {
                    onSaveReady();
                }
                return;
    
            } else if (ViewType == 'Insert') {
                //INSERT A SINGLE NEW MODEL
                saveNewModel();
                if (_.isFunction(onSaveReady)) {
                    onSaveReady();
                }
                return;
            }
        }

        //Switch case can replaced with if incase we dont need the other cases
        if (param == undefined || param != 'insert') {
            switch (ViewType) {
                case 'Insert':
                    showConfirmMessage(Utils.getText('VERLASSEN_OHNE_SPEICHERN_BEST'), function (buttonIndex) {
                        if (buttonIndex === 1) {
                            if (_.isFunction(onSaveReady)) {
                                onSaveReady();
                            }

                            return;
                        }

                        performSaving();
                        
                    }, '', Utils.getText('OK_ABBRECHEN'));
                    return;
                default:
                    performSaving();
                    return;
            }
        }
    },

    /**
     * Navigates to a genericView and Saves pending Models
     */
    navigate: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models, callback, url) {
        ActionHelper.IsValid = true;
        
        var onConfirmed = function() {
            var view = ActionHelper.CurrentView.options.view;
            var viewType = !!view ? view.get('ViewType') : undefined;
            
            var afterSave = function() {
                //if could not be saved --> edit.
                if (!ActionHelper.IsValid && ActionHelper.Models != undefined && ActionHelper.Models.length > 0 && redirectViewId == undefined) {
                    if (viewType === 'Insert') {
                        ActionHelper.doNavigate(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, callback, url);     
                        return; 
                    }

                    showConfirmMessage(Utils.getText('VERLASSEN_OHNE_SPEICHERN_BEST'), function (buttonIndex) {
                        if (buttonIndex === 1) {
                            ActionHelper.IsValid = true;
                            ActionHelper.Models.length = 0;
                            ActionHelper.Models = null;
                            ActionHelper.doNavigate(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, callback, url);   
                            return;   
                        }
                    }, '', Utils.getText('OK_ABBRECHEN'));
                    return;
                }

                ActionHelper.doNavigate(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, callback, url);
            }

            if (viewType === 'Edit' || viewType === 'Insert') {
                //NUR wenn false dann nicht machen --> somit default = true / undefined
                if (param_05 !== false && param_05 !== "false") {
                    ActionHelper.IsValid = true;
                    ActionHelper.awsomeSave(undefined, afterSave);
                }
                return;
            }
            ActionHelper.doNavigate(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, callback, url);              
        }

        if (!!confirmMessageText) {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex === 1) {
                    onConfirmed();
                }
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }
        
        onConfirmed();
    },

    /**
     * Navigates without saving
     */
    cancel: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models, callback, url) {
        ActionHelper.IsValid = true;
 
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    ActionHelper.doNavigate(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, callback, url);
                    return;
                }
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }
    },

    /**
     * Do Navigate
     */
    doNavigate: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, callback, url) {
        var target = $(element);
        var modelId = ActionHelper.CurrentView.options.modelId;
        var refModelId = ActionHelper.CurrentView.options.refModelId;
        var refNavId = ActionHelper.CurrentView.options.refNavId;
        var isRef = false;
        ActionHelper.ViewDeactivated = false;

        if (ActionHelper.IsValid) {
            var model = ActionHelper.CurrentView.model;
            var options = ActionHelper.CurrentView.options;
            if (refNavId == undefined)
                refNavId = "null";

            if (url != null) {
                window.app.navigate(url, { trigger: true, replace: false });
            } else {
                if (redirectViewId != null && ActionHelper.CurrentView != null && ActionHelper.CurrentView.options.view != null && redirectViewId == ActionHelper.CurrentView.options.view.attributes.ViewId) {
                    //REFRESH CURRENT VIEW

                    var view = ActionHelper.CurrentView.options.view;
                    var createViewString = 'new window.' + view.attributes.ViewType + 'View({ view: view, modelId: modelId, refModelId: refModelId });'
                    var page = jQuery.extend(true, {}, eval(createViewString));
                    var viewTypeId = '#' + view.attributes.ViewType;

                    $(viewTypeId).empty();
                    $(viewTypeId).append($(page.el));
                    page.render();
                    $.mobile.changePage(viewTypeId, { changeHash: false });
                } else {
                    if (target.length > 0) {
                        if (target.data("params") != null) {
                            var modelId = target.data("params").param_01;
                            var refModelId = target.data("params").param_02;
                        } else {
                            ActionHelper.Models = new Array();
                            $(ActionHelper.CurrentView.el).find('#listView .checkBox').each(function () {
                                if ($(this).hasClass("ui-icon-check")) {
                                    ActionHelper.Models.push(this.id);
                                }
                            });

                            if (param_01 == "true") {

                                var objectid = _.first(_.filter(element.attributes, function (attribute) {
                                    return attribute.name == "model";
                                }));

                                if (objectid === undefined && ActionHelper.Models.length === 1) {
                                    modelId = ActionHelper.Models[0];
                                }

                                if (objectid != undefined) {
                                    if (ActionHelper.CurrentView.model != undefined) {

                                        for (attr in ActionHelper.CurrentView.model.attributes) {
                                            model.set(attr, ActionHelper.CurrentView.model.attributes[attr]);
                                        }
                                        ActionHelper.tmpModel = ActionHelper.setModelAttributes(model);

                                        var genericFields = _.filter(window.genericViewFields.models, function (field) {
                                            return field.attributes.FieldId == objectid.value && field.attributes.IsActive == true;
                                        });

                                        if (!(objectid.value.indexOf('#') >= 0)) {
                                            var dropdown = $('#' + objectid.value);
                                            if (dropdown != undefined && dropdown.length == 1) {
                                                refNavId = genericFields[0].attributes.PropertyId;
                                                modelId = dropdown[0][dropdown[0].selectedIndex].value;
                                                if (modelId == undefined || modelId.length == 0)
                                                    return;
                                                ActionHelper.CurrentView.model = _.first(_.filter(window.genericData.models, function (model) {
                                                    return model.attributes.ObjectId == modelId;
                                                }));
                                                if (ActionHelper.CurrentView.model != undefined)
                                                    modelId = ActionHelper.CurrentView.model.attributes.DataId;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    var isRef = false;
                    if (param_01 != null && param_01 != "") {
                        isRef = param_01;
                    }
                    if (param_03 !== "true") {
                        ActionHelper.tmpModel = undefined;
                    }

                    var replacedNav = false;
                    if (param_02 != null && param_02 != "") {
                        replacedNav = param_02;
                    }

                    if (param_04 != null && param_04 != "") {
                        var saved = localStorage.getItem(redirectViewId);

                        var settings = Utils.isJSON(saved);
                        var filter = param_04.replace('##dataid##', ActionHelper.CurrentView.model.id)
                        if (settings == false) {
                            settings = {
                                customfilter: '',
                                filter: '',
                                sort: [],
                            }
                        }
                        settings.customfilter = filter;
                        settings.filter = '';

                        localStorage.setItem(redirectViewId, JSON.stringify(settings));

                    }

                    if (redirectViewId != null && redirectViewId != 'null' && redirectViewId != '' && redirectViewId != CONSTS.GUID_DEFAULT) {
                        if (isRef) {
                            if (replacedNav) {
                                window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refNavId, { trigger: true, replace: true });
                            } else {
                                window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refNavId, { trigger: true });
                            }

                        } else {
                            if (replacedNav) {
                                window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refModelId, { trigger: true, replace: true });
                                //window.location.replace(window.app.root + 'navigate/' + redirectViewId + '/' + modelId + '/' + refModelId);
                            } else {
                                window.app.navigate('navigate/' + redirectViewId + '/' + modelId + '/' + refModelId, { trigger: true });
                            }
                        }
                    } else {
                        if (redirectHistory != "" && redirectHistory != null && redirectHistory != CONSTS.INTEGER_DEFAULT) {
                            window.history.back(parseInt(redirectHistory));
                        }
                    }
                }
            }
        }
    },

    /**
     * Deactivate a data entry depending on a specific value
     */
    deactivate: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var doDeactivate = function() {
            var model = ActionHelper.CurrentView.model;
            var property = window.genericProperties.get(param_01);
            var lookupProperty = window.genericProperties.get(param_02);
            var value = param_03;

            var useRefModel = param_04;

            if (useRefModel) {
                model = _.first(_.filter(window.genericData.models, function (cModel) {
                    return cModel.attributes.ObjectId == ActionHelper.CurrentView.options.refModelId;
                }));
            }

            if (property != null && model != null) {
                var modelValue = model.get(property.attributes.GenericColumnName);
                if (lookupProperty != null) {
                    var lookupModel = _.first(_.filter(window.genericData.models, function (model) {
                        return lookupProperty.attributes.EntityId == model.attributes.EntityId && modelValue == model.attributes.ObjectId;
                    }));
                    if (lookupModel != null) {
                        var modelLookupValue = lookupModel.get(lookupProperty.attributes.GenericColumnName);
                        if (modelLookupValue == value) {
                            ActionHelper.ViewDeactivated = true;
                            ActionHelper.disableElements();
                        }
                    }
                } else {
                    if (modelValue == value) {
                        ActionHelper.ViewDeactivated = true;
                        ActionHelper.disableElements();
                    }
                }
            }
        }


        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {

            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }
                doDeactivate();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }

        doDeactivate();
    },

    /**
     * Disables all edit actions and view fields
     */
    disableElements: function () {
        $(ActionHelper.CurrentView.el).find('input').each(function () {
            $(this).attr('readonly', true);
            $(this).attr('disabled', true);
            $(this).addClass('class', 'readonly');
        });
        $(ActionHelper.CurrentView.el).find('select').each(function () {
            $(this).selectmenu('disable');
        });
        $(ActionHelper.CurrentView.el).find('textarea').each(function () {
            $(this).attr('readonly', true);
            $(this).attr('disabled', true);
            $(this).addClass('class', 'readonly')
        });
        $(ActionHelper.CurrentView.el).find('img').each(function () {
            $(this).unbind('click');
            $(this).addClass('signature-image-readonly');
        });
        $(ActionHelper.CurrentView.el).find('.mf-date-removebutton').each(function () {
            $(this).attr('disabled', true);
        });


        var viewActions = GenericHelper.getViewActions(ActionHelper.CurrentView.options.view);

        //Check Visibility
        _.each(viewActions, function (action) {
            var visible = eval(action.attributes.IsVisible);
            if (visible == false) {
                var selector = action.attributes.Selector;
                if (selector == 'this') {
                    selector = '#' + action.id;
                }
                var element = $(ActionHelper.CurrentView.el).find(selector);
                if (element.length > 0) {
                    switch (action.attributes.ActionType) {
                        case 'navbutton':
                            if ($(element[0].parentElement.parentElement).length == 1 && $(element[0].parentElement.parentElement)[0].childElementCount == 1) {
                                $(element[0].parentElement.parentElement).remove();
                            } else {
                                $(element[0].parentElement).remove();
                            }
                            break;
                        case 'menubutton':
                            $(element[0].parentElement).remove();
                            break;
                        default:
                    }
                }
            }
        });

        var editActions = _.filter(viewActions, function (action) {
            return action.get('CommandName') === 'navigate' ||
                action.get('CommandName') === 'saveItem' ||
                action.get('CommandName') === 'deleteItem' ||
                action.get('CommandName') === 'deleteSelectedItems' ||
                action.get('CommandName') === 'lookupPropertySelect';
        });

        _.each(editActions, function (action) {
            if (action.get('CommandName') === 'navigate' || action.get('CommandName') === 'saveItem') {
                var view = window.genericViews.get(action.attributes.RedirectViewId);
                if (view != null) {
                    if ((view.get('ViewType') === 'Edit' || view.get('ViewType') === 'Insert' || view.get('ViewType') === 'Import')) {
                        var element = $(ActionHelper.CurrentView.el).find(action.get('Selector'));
                        if (element.length == 1) {
                            element.addClass("ui-disabled").attr("aria-disabled", true);
                        }
                        if (element.length > 1) {
                            element.each(function () {
                                $(this).addClass("ui-disabled").attr("aria-disabled", true);
                            });
                        }
                    }
                } else {
                    var selector = action.get('Selector');
                    if (selector == 'this') {
                        selector = '#' + action.id;
                    }
                    var element = $(ActionHelper.CurrentView.el).find(selector);
                    if (element.length == 1) {
                        element.addClass("ui-disabled").attr("aria-disabled", true);
                    }
                    if (element.length > 1) {
                        element.each(function () {
                            $(this).addClass("ui-disabled").attr("aria-disabled", true);
                        });
                    }
                }

            } else {
                var element = $(action.get('Selector'));
                if (action.get('CommandName') === 'lookupPropertySelect') {
                    var element = $('#' + action.id);
                }
                if (element.length == 1) {
                    element.addClass("ui-disabled").attr("aria-disabled", true);
                }
                if (element.length > 1) {
                    element.each(function () {
                        $(this).addClass("ui-disabled").attr("aria-disabled", true);
                    });
                }
            }
        });
    },

    /**
     * Sets the selected model
     */
    setSelectedModel: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, postActions, preActions, confirmMessageText) {
        var that = this;

        var select = function() {
            if (preActions) {
                preActions();
            }

            var selection = $(ActionHelper.CurrentView.el).find('.ui-icon-check');
            if (selection.length > 1) {
                alert(Utils.getText('ELEMENTE_ZUVIELE_GEWAEHLT'));
            } else if (selection.length == 0) {
                alert(Utils.getText('ELEMENT_AUSGEWAEHLT_GENAU_1'));
            } else {
                var element = selection[0];
                var checkBox = $(element).closest('a');
                var id = checkBox[0].id;
                var dataRawElement = _.first(_.filter(window.genericData.models, function (model) {
                    return model.attributes.ObjectId == id;
                }));

                if (dataRawElement != null) {
                    ActionHelper.CurrentView.options.modelId = dataRawElement.attributes.DataId;
                    if (postActions) {
                        postActions();
                    }
                    that.navigate(element, redirectViewId, redirectHistory);
                } else {
                    alert(Utils.getText('OBJEKT NICHT GEFUNDEN'));
                }
            }
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }
                select();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }

        select();
    },

    reportAction: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        $('#loader_page').show();
        $.mobile.loading('show', {
            text: 'Report wird abgerufen',
            textVisible: true,
            theme: 'a',
        });
        var model = ActionHelper.CurrentView.model;
        var modelID;
        if (ActionHelper.CurrentView.Type == 'List') {
            $(ActionHelper.CurrentView.el).find('#listView .checkBox').each(function () {
                if ($(this).hasClass("ui-icon-check")) {
                    model = this.id;
                    modelID = this.id;
                }
            });

            model = _.first(_.filter(window.genericData.models, function (cModel) {
                return cModel.attributes.ObjectId == model;//ActionHelper.CurrentView.options.refModelId;
            }));
        }



        if (model == undefined) {
            model = _.first(_.filter(window.genericData.models, function (cModel) {
                return cModel.attributes.ObjectId == ActionHelper.Models[0];//ActionHelper.CurrentView.options.refModelId;
            }));
        }

        //if (model == undefined) {
        //    SyncController.searchDataByObjectID
        //        (modelID,
        //        ActionHelper.CurrentView.options.view.id,
        //        ActionHelper.CurrentView.options.view.attributes.EntityId);
        //}
        //model=_.first(SyncController.TmpData);
        var object;
        var entity;
        if (model != undefined) {
            object = model.attributes.ObjectId;
            entity = model.attributes.EntityId;
        }
        else {
            object = modelID;
            entity = ActionHelper.CurrentView.options.view.attributes.EntityId;
        }




        var Reports = _.first(
                        _.filter(window.genericData.models, function (rep) {
                            return rep.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_CONFIG && rep.attributes.DataId.toLowerCase() == param_02.toLowerCase() && rep.attributes.IsActive;
                        })
                        );
        var paramdic = {};

        if (Reports != undefined) {
            var Reportparameter =
            _.filter(window.genericData.models, function (repp) {
                return repp.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_PARAMS && repp.attributes.Custom_005 == Reports.attributes.ObjectId && repp.attributes.IsActive;
            });
            _.each(Reportparameter, function (param) {
                if (param.attributes.Custom_008 == 1) {
                    paramdic[param.attributes.Custom_002] = object;
                }
                else {
                    if (param.attributes.Custom_011 != undefined && param.attributes.Custom_002 != undefined)
                        paramdic[param.attributes.Custom_002] = $('#' + param.attributes.Custom_002).val();
                }

            });
            MFCustom.getReport(Reports.id, paramdic)
        }
    },

    /**
     * Creates a send Request "EmailVersand"-Object
     */
    sendRequest: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var continiue = true;
        var valid = true;
        var that = this;

        var request = function() {
            var model = ActionHelper.CurrentView.model;
            if (ActionHelper.Models == null || ActionHelper.Models.length <= 0 && model == null) {
    
                alert(Utils.getText('DATEN_KEINE'));
    
            } else {
                var model = ActionHelper.CurrentView.model;
                if (ActionHelper.Models.length <= 0) {
                    ActionHelper.Models.push(model.attributes.ObjectId);
                }
    
                _.each(ActionHelper.Models, function (modelId) {
                    if (!continiue)
                        return false;
                    var model = _.first(
                        _.filter(window.genericData.models, function (model) {
                            return model.attributes.ObjectId == modelId;
                        })
                    );
    
                    var from = null;
                    var to = null;
                    var cc = null;
                    var bcc = null;
                    var subject = null;
                    var body = null;
                    //TODO: get type from report view instead of setting it to 0:Email by default
                    var type = 0;
                    var reportType = null;
                    var object = null;
                    var entity = null;
    
                    from = window.currentUser.Email;
                    if (param_01 == '##CUSTOM##') {
                        var input = $(ActionHelper.CurrentView.el).find('#email_address');
                        to = input[0].value;
                    } else if (param_01 == '##ME##') {
                        to = window.currentUser.Email;
                    } else if (param_01 == '##EVAL##') {
                        to = eval(param_02);
                    } else if (param_01 == '##LOOKUP##') {
                        var property = window.genericProperties.get(param_02);
                        var lookUpProperty = window.genericProperties.get(param_03);
    
                        var lookUpId = model.get(property.attributes.GenericColumnName);
                        var lookUpModel = window.genericData.get(lookUpId);
    
                        if (lookUpModel == null) {
                            alert(Utils.getText('EMAIL_ADRESSE_NICHT_GEFUNDEN'));
                            valid = false;
                            return false;
                        } else {
                            var to = lookUpModel.get(lookUpProperty.attributes.GenericColumnName);
                        }
                    }
                    subject = 'Bericht';
    
                    if (to == undefined || to == null) {
                        alert(Utils.getText('EMAIL_ODER_FAX_EINGEBEN'));
                        continiue = false;
                        valid = false;
                        return false;
                    }
                    else {
                        if (to.length < 2) {
                            alert(Utils.getText('EMAIL_ODER_FAX_EINGEBEN'));
                            continiue = false;
                            valid = false;
                            return false;
                        }
                    }
    
                    var dataRawElement;
                    dataRawElement = new window.GenericDataRawElement();
                    var emailRequestId = CONSTS.EMAIL_REQUEST_ID;
                    var itemId = window.generateGuid();
                    dataRawElement.attributes.DataId = itemId;
                    dataRawElement.attributes.ObjectId = itemId;
                    dataRawElement.set({ 'id': itemId });
                    var status = 1;
                    dataRawElement.attributes.EntityId = emailRequestId;
    
                    dataRawElement.attributes.Custom_001 = from;
                    dataRawElement.attributes.Custom_002 = to;
                    dataRawElement.attributes.Custom_003 = cc;
                    dataRawElement.attributes.Custom_004 = bcc;
                    dataRawElement.attributes.Custom_005 = subject;
                    dataRawElement.attributes.Custom_006 = body;
                    dataRawElement.attributes.Custom_007 = type;
                    dataRawElement.attributes.Custom_008 = reportType;
                    dataRawElement.attributes.Custom_009 = object;
                    dataRawElement.attributes.Custom_010 = status;
                    dataRawElement.attributes.Custom_011 = entity;
                    dataRawElement.attributes.Custom_012 = param_01;
                    dataRawElement.attributes.Custom_013 = param_02;
    
                    if (ActionHelper.CurrentView != undefined && ActionHelper.CurrentView.options.view != undefined)
                        dataRawElement.attributes.Custom_018 = ActionHelper.CurrentView.options.view.get('Param01');
    
                    dataRawElement.attributes.UserId = window.currentUser.UserId;
                    dataRawElement.attributes.MandatorId = window.currentUser.MandatorId;
                    dataRawElement.attributes.OrgUnitId = window.currentUser.OrgUnitId;
                    dataRawElement.attributes.UserElementAuth = window.currentUser.UserElementAuth;
    
                    dataRawElement.attributes.IsActive = true;
                    dataRawElement.attributes.EntryTime = moment().toDate();
                    dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
                    dataRawElement.IsNew = true;
    
                    dataRawElement.attributes.EntityId = emailRequestId;
    
    
    
                    if (model != null) {
                        object = model.attributes.ObjectId;
                        entity = model.attributes.EntityId;
    
                        dataRawElement.attributes.Custom_009 = object;
                        dataRawElement.attributes.Custom_011 = entity;
    
                        var Reports = _.first(
                            _.filter(window.genericData.models, function (rep) {
                                return rep.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_CONFIG && rep.attributes.Custom_001 == entity && rep.attributes.IsActive && rep.attributes.DataId == dataRawElement.attributes.Custom_018;
                            })
                        );
    
                        if (Reports == undefined) {
                            var Reports = _.first(
                                _.filter(window.genericData.models, function (rep) {
                                    return rep.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_CONFIG && rep.attributes.Custom_001 == entity && rep.attributes.IsActive;
                                })
                            );
                        }
    
                        if (Reports != undefined) {
                            if (dataRawElement.attributes.Custom_018 == undefined || dataRawElement.attributes.Custom_018 == '')
                                dataRawElement.attributes.Custom_018 = Reports.attributes.ObjectId;
    
    
                            var Reportparameter =
                            _.filter(window.genericData.models, function (repp) {
                                return repp.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_PARAMS && repp.attributes.Custom_005 == Reports.attributes.ObjectId && repp.attributes.IsActive;
                            });
                            _.each(Reportparameter, function (param) {
                                if (param.attributes.Custom_008 == 1) {
                                    if (param.attributes.Custom_011 == undefined) {
                                        alert('Reportparameter nicht ausreichend konfiguriert: Custom_011 von Parameter ' + param.attributes.DataId);
                                    }
                                    else {
                                        dataRawElement.set(param.attributes.Custom_011, object);
                                    }
    
                                    if (param_04 != undefined && param_04 == 'true') {
                                        dataRawElement.set(param.attributes.Custom_011, ActionHelper.Models.toString().replace(/\,/g, '||'));
                                    }
                                }
                                else {
                                    if (param.attributes.Custom_011 != undefined && param.attributes.Custom_002 != undefined) {
                                        var paramValue = $('#' + param.attributes.Custom_002).val();
                                        if (param.attributes.Custom_003 == 'bit') {
                                            if ($('#' + param.attributes.Custom_002).is(":checked")) {
                                                paramValue = 'true';
                                            } else {
                                                paramValue = 'false';
                                            }
                                        }
                                        dataRawElement.set(param.attributes.Custom_011, paramValue);
                                    }
                                }
    
                            });
                            subject = Reports.attributes.Custom_003;
                        }
                        if (param_04 != undefined && param_04 == 'true') {
                            dataRawElement.attributes.Custom_009 = ActionHelper.Models.toString().replace(/\,/g, '||');;
                            continiue = false;
                        }
                    }
    
                    dataRawElement.saveItem();
                    window.genericData.add(dataRawElement);
                    if (param_05 != undefined && param_05 != '')
                        alert(param_05);
                    
                });
            }
            if (valid) {
                that.navigate(element, redirectViewId, redirectHistory);
            }
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                request();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));

            return;
        }

        request();
    },

    sendRequestMail: function (from, to, cc, bcc, subject, body, type, reportType, object, entity, param01, param02, param03, param04, param05, confirmMessageText, attachement, attachementName) {
        var request = function() {
            var dataRawElement;
            dataRawElement = new window.GenericDataRawElement();
            var emailRequestId = CONSTS.EMAIL_REQUEST_ID;
            var itemId = window.generateGuid();
            dataRawElement.attributes.DataId = itemId;
            dataRawElement.attributes.ObjectId = itemId;
            dataRawElement.set({ 'id': itemId });
            var status = 1;
    
            dataRawElement.attributes.EntityId = emailRequestId;
    
            dataRawElement.attributes.Custom_001 = from;
            dataRawElement.attributes.Custom_002 = to;
            dataRawElement.attributes.Custom_003 = cc;
            dataRawElement.attributes.Custom_004 = bcc;
            dataRawElement.attributes.Custom_005 = subject;
            dataRawElement.attributes.Custom_006 = body;
            dataRawElement.attributes.Custom_007 = type;
            dataRawElement.attributes.Custom_008 = reportType;
            dataRawElement.attributes.Custom_009 = object;
            dataRawElement.attributes.Custom_010 = status;
            dataRawElement.attributes.Custom_011 = entity;
            dataRawElement.attributes.Custom_012 = param01;
            dataRawElement.attributes.Custom_013 = param02;
            dataRawElement.attributes.Custom_018 = param03;
            dataRawElement.attributes.Custom_020 = param04;
            dataRawElement.attributes.Custom_021 = param05;
            dataRawElement.attributes.Custom_016 = attachementName;
            dataRawElement.attributes.CustomMax_001 = attachement;
    
            dataRawElement.attributes.UserId = window.currentUser.UserId;
            dataRawElement.attributes.MandatorId = window.currentUser.MandatorId;
            dataRawElement.attributes.OrgUnitId = window.currentUser.OrgUnitId;
            dataRawElement.attributes.UserElementAuth = window.currentUser.UserElementAuth;
    
            dataRawElement.attributes.IsActive = true;
            dataRawElement.attributes.EntryTime = moment().toDate();
            dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
            dataRawElement.saveItem();
            window.genericData.add(dataRawElement);
        }
        

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }

                request();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));

            return;
        }

        request();
    },

    /**
    * fastInsert function - directly creates an element and saves it
    */
    fastInsert: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var insert = function() {
            var view = window.genericViews.get(param_01);

            var newModel = new window.GenericDataRawElement();
            var itemId = window.generateGuid();
            newModel.attributes.DataId = itemId;
            newModel.attributes.ObjectId = itemId;
            newModel.id = itemId;
            newModel.set({ 'id': itemId });

            newModel.attributes.EntityId = view.attributes.EntityId;

            _.each(window.genericViewFields.models, function (field) {
                if (field.attributes.ViewId === view.attributes.ViewId && field.attributes.IsActive && $('#' + field.attributes.FieldId) != null) {
                    var genericProperty = window.genericProperties.get(field.attributes.PropertyId);
                    var gcn = genericProperty.attributes.GenericColumnName;
                    var value = DefaultValueHelper.getDefaultValue(field);
                    switch (genericProperty.attributes.DataType) {
                        case 'date':
                            value = moment(value.toString(), FormatHelper.get_DATE_FORMAT()).format(CONSTS.DATE_PERSIST_FORMAT);
                            break;
                        case 'datetime':
                            value = moment(value.toString(), FormatHelper.get_DATETIME_FORMAT()).format(CONSTS.DATETIME_PERSIST_FORMAT);
                            break;
                        case 'time':
                            value = moment(value.toString(), FormatHelper.get_TIME_FORMAT()).format(CONSTS.TIME_PERSIST_FORMAT);
                            break;
                        default:
                            break;
                    }
                    newModel.set(gcn, value);
                }
            });

            var customValues = [param_02, param_03, param_04, param_05];
            _.each(customValues, function (customValue) {
                if (customValue) {
                    var substr = customValue.split('||');
                    var gcn = substr[0];
                    var value = substr[1];

                    var gp = window.genericProperties.get(gcn);
                    if (gp !== undefined) {
                        gcn = gp.attributes.GenericColumnName;
                    }
                    newModel.set(gcn, value);
                }
            });

            newModel.attributes.UserId = window.currentUser.UserId;
            newModel.attributes.MandatorId = window.currentUser.MandatorId;
            newModel.attributes.OrgUnitId = window.currentUser.OrgUnitId;

            newModel.IsNew = true;
            newModel.attributes.IsActive = true;
            newModel.attributes.EntryTime = moment().toDate();
            newModel.attributes.SyncTime = CONSTS.DATE_DEFAULT;
            newModel.saveItem();
            window.genericData.add(newModel);

            newModel = null;

            this.navigate(element, redirectViewId, redirectHistory);
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
   
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }
                insert();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }
        insert();
    },

    /**
    * customAction function - calls the JS action from param_01
    */
    customAction: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }

                eval(param_01);
            }, '', Utils.getText('OK_ABBRECHEN'));

            return;
        }

        eval(param_01);
    },

    /**
     * Sets the global status of given number to given value
     */
    setGlobalStatus: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }
                localStorage.setItem(param_01, param_02);
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }
   
        localStorage.setItem(param_01, param_02);
    },

    /**
    * Dient zum Updaten eines oder mehrerer Objekte ohne die Ansicht zu verlassen mittels eines Buttons
    * Die Werte werden aus Param_01-05 ausgelesen.
    *
    * @method fastUpdate
    * @param {DOM Object} element - DOM Element auf welchem die Aktion ausgeführt bzw. getriggert wurde (bspw. NavButton).
    * @param {GUID} redirectViewId - ViewId des Views auf welchem nach der Aktion navigiert werden soll
    * @param {INT} redirectHistory - Zahlen Wert von 1-N der bestimmt wieviele Schritte nach der Aktion zurück navigiert werden soll
    * @param {STRING} param_01 - Momentan nicht verwendet
    * @param {STRING} param_02 - Nimmt einen String entgegen in der folgender Form: "GenericColumnName||Wert". Der Wert wird dann auf die Eigenschaft in "GenericCoulmnName" gespeichert.
    * @param {STRING} param_03 - Nimmt einen String entgegen in der folgender Form: "GenericColumnName||Wert". Der Wert wird dann auf die Eigenschaft in "GenericCoulmnName" gespeichert.
    * @param {STRING} param_04 - Nimmt einen String entgegen in der folgender Form: "GenericColumnName||Wert". Der Wert wird dann auf die Eigenschaft in "GenericCoulmnName" gespeichert.
    * @param {STRING} param_05 - Nimmt einen String entgegen in der folgender Form: "GenericColumnName||Wert". Der Wert wird dann auf die Eigenschaft in "GenericCoulmnName" gespeichert.
    * @param {STRING} confirmMessageText - Wenn dieser Parameter gesetzt ist wird vor dem Ausführen der Aktion eine Abfrage mit dem Text im Parameter gestartet und das Ergebnis bestimmt ob die Aktion ausgeführt wird oder nicht.
    * @param {STRING} Models - Als String übergebenes Array von Models (wird nur bei PostActions gesetzt)
    */
    fastUpdate: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var that = this;

        var update = function() {
            var checkAndUpdateCustomValue = function (modelId, customValues) {
                var dataRawElement = window.genericData.get(modelId);
                var oldModel = jQuery.extend(true, {}, dataRawElement);
                oldModel.IsNew = false;
                ActionHelper.OldModels.push(oldModel);

                if (ActionHelper.CurrentView.model != null) {
                    ActionHelper.setModelAttributes(dataRawElement, null);
                }
                _.each(customValues, function (customValue) {
                    if (dataRawElement && customValue) {
                        var substr = customValue.split('||');
                        var gcn = substr[0];
                        var value = substr[1];

                        var gp = window.genericProperties.get(gcn);
                        if (gp !== undefined) {
                            gcn = gp.attributes.GenericColumnName;
                        }
                        dataRawElement.set(gcn, value);
                    }
                });

                dataRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
                dataRawElement.saveItem();

                dataRawElement = null;
            };

            var customValues = [param_02, param_03, param_04, param_05];

            if (ActionHelper.CurrentView.model != null) {
                var model = window.genericData.get(ActionHelper.CurrentView.model.id);
                if (model != null) {
                    ActionHelper.CurrentView.model = model;
                }
                checkAndUpdateCustomValue(model.id, customValues);
            }
            else {
                if (Models != undefined) {
                    _.each($.parseJSON(Models), function (id) {
                        checkAndUpdateCustomValue(id, customValues);
                    });
                }
                else {
                    $(ActionHelper.CurrentView.el).find('#listView .checkBox').each(function () {
                        if ($(this).hasClass("ui-icon-check")) {
                            checkAndUpdateCustomValue(this.id, customValues);
                        }
                    });
                }
            }
        }

        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if(buttonIndex === 1) {
                    update();
                }
                afterUpdate();
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
            return;
        }

        var afterUpdate = function() {
            if (ActionHelper.IsValid) {
                that.navigate(element, redirectViewId, redirectHistory, null, null, null, null, "false");
            }
        }

        update();
        afterUpdate();
    },

    /**
     * dummy function
     */
    dummy: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var that = this;
        alert('dummy');
        that.navigate(element, redirectViewId, redirectHistory);
    },

    /**
    * Saves the location data of current location to current model
    * param_01: custom column where the LAT value of location is saved - e.g. Custom_001
    * param_02: custom column where the LONG value of location is saved - e.g. Custom_002
    */
    saveLocationData: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        if (ActionHelper.IsValid && GlobalSettings.LocationActive()) {
            var locationHelper = LocationHelper;
            locationHelper.getLocation(function (position, param_01, param_02, Models) {
                var LAT = position.coords.latitude;
                var LONG = position.coords.longitude;
                var modelsArray = $.parseJSON(Models);
                _.each(modelsArray, function (modelId) {
                    var model = window.genericData.get(modelId);
                    model.set(param_01, LAT);
                    model.set(param_02, LONG);
                    model.saveItem();
                    model = null;
                });
                currentModel = null;
                position = null;
            }, param_01, param_02, Models);
        }
    },

    /**
     * Copies Values to use in redirected InserView
     */
    copyModelValues: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        var confirmed = true;
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            confirmed = false;
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                confirmed = true;
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));
        }
        if (confirmed) {
            var that = this;
            var selectedModel;
            var attributes = eval(param_01);

            if (ActionHelper.CurrentView.Type == 'List') {
                var count = $(ActionHelper.CurrentView.el).find('#listView .ui-icon-check').length;

                if (count != 1) {
                    alert(Utils.getText('ELEMENT_AUSGEWAEHLT_GENAU_1'));
                    return;
                }
                $(ActionHelper.CurrentView.el).find('#listView .checkBox').each(function () {
                    if ($(this).hasClass("ui-icon-check")) {
                        var objectId = this.id;
                        selectedModel = _.first(_.filter(window.genericData.models, function (cModel) {
                            return cModel.attributes.ObjectId == objectId;
                        }));
                    }
                });
            } else {
                selectedModel = ActionHelper.CurrentView.model;
            }

            ActionHelper.CopyModel = selectedModel;
            ActionHelper.awsomeSave('insert');
            ActionHelper.tmpModel = undefined;
            if (ActionHelper.IsValid)
                that.navigate(element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, 'false');
        }
    },

    /**
    * Starts Synchronisation of genericData manually
    */
    syncData: function (element, redirectViewId, redirectHistory, param_01, param_02, param_03, param_04, param_05, confirmMessageText, Models) {
        if (!!confirmMessageText && confirmMessageText != 'null' && confirmMessageText != 'undefined') {
            confirmed = false;
            showConfirmMessage(confirmMessageText, function (buttonIndex) {
                if (buttonIndex !== 1) {
                    return;
                }

                SyncController.syncData(true, function () {
                    ActionHelper.navigate(element, redirectViewId, redirectHistory);
                });
            }, Utils.getText('SICHER_BEST'), Utils.getText('OK_ABBRECHEN'));

            return;
        }

        SyncController.syncData(true, function () {
            ActionHelper.navigate(element, redirectViewId, redirectHistory);
        });
    },

    /**
    * Global ONLOAD EVENT - searches for viewactions with view 00000000-0000-0000-0000-000000000001 and executes param_01 as JS Code
    */
    globalOnload: function () {
        _.each(window.genericViewActions.models, function (action) {
            if (action.attributes.ViewId === '00000000-0000-0000-0000-000000000001') {
                eval(action.attributes.Param_01);
            }
        });
    },

    /**
    * Global BEFORESAVE EVENT - executes all before save actions defined in custom/mfcustom.js
    */
    globalBeforeSave: function (model) {
        MFCustom.beforeSave(model);
    },

    /**
    * Global ONSAVE EVENT - executes all on save actions defined in custom/mfcustom.js
    */
    globalOnSave: function (model) {
        MFCustom.onSave(model);
    },

    /**
    * Global AFTER SYNC EVENT
    */
    globalAfterSync: function (model) {
        _.each(window.genericViewActions.models, function (action) {
            if (action.attributes.ViewId === '00000000-0000-0000-0000-000000000004') {
                eval(action.attributes.Param_01);
            }
        });
    },

    createStatusHistory: function (auftrag, status, techniker, erfassungsdatum, geändertVon, comment, auftragsNr, persistToLocalStorageImmediately) {
        var STATUSHISTORIE_ENTITY_ID = '9e178a8b-37bf-3f00-ee8b-013b16de3c76';
        var currentUser = window.currentUser;

        var newModel = new window.GenericDataRawElement();
        newModel.IsNew = true;
        var itemId = window.generateGuid();
        newModel.attributes.DataId = itemId;
        newModel.attributes.ObjectId = itemId;
        newModel.id = itemId;
        newModel.set({ 'id': itemId });

        newModel.attributes.EntityId = STATUSHISTORIE_ENTITY_ID;

        newModel.attributes.UserId = currentUser.UserId;
        newModel.attributes.MandatorId = currentUser.MandatorId;
        newModel.attributes.OrgUnitId = currentUser.OrgUnitId;
        if (persistToLocalStorageImmediately == false) {
            newModel.PersistToLocalStorageImmediately = persistToLocalStorageImmediately;
        }

        newModel.attributes.Custom_001 = auftrag;
        newModel.attributes.Custom_002 = status;
        newModel.attributes.Custom_003 = techniker;
        newModel.attributes.Custom_004 = erfassungsdatum;
        newModel.attributes.Custom_006 = geändertVon;
        newModel.attributes.Custom_007 = comment;
        newModel.attributes.Custom_009 = auftragsNr;

        newModel.attributes.IsActive = true;
        newModel.attributes.EntryTime = moment().toDate();
        newModel.attributes.SyncTime = CONSTS.DATE_DEFAULT;
        newModel.saveItem();
        window.genericData.add(newModel);
        SyncController.SyncQueue.push({
            Type: 'GenericData', Manually: false, Async: true, Callback: function () {
                ActionHelper.globalAfterSync();
            }
        });
        //newModel.syncWithServer();
        currentUser = null;
        newModel = null;
    },

    UpsertAutoComplete: function (group, value, IsOfflineVersion) {

        if (Utils.isNull(value)) {
            return;
        }

        var autocomplete_ENTITY_ID = 'eb57edf5-3d65-e3c9-d7f9-d68d2943f900';
        var currentUser = window.currentUser;

        var AlreadyExistent = _.filter(genericData.models, function (cModel) {
            return cModel.attributes.EntityId == autocomplete_ENTITY_ID
                        && cModel.attributes.Custom_001 == group
                        && cModel.attributes.Custom_002 == value;
        });

        if (AlreadyExistent.length > 0) {
            return;
        }

        var newModel = new window.GenericDataRawElement();
        newModel.IsNew = true;
        var itemId = window.generateGuid();
        newModel.attributes.DataId = itemId;
        newModel.attributes.ObjectId = itemId;
        newModel.id = itemId;
        newModel.set({ 'id': itemId });

        newModel.attributes.EntityId = autocomplete_ENTITY_ID;

        newModel.attributes.UserId = currentUser.UserId;
        newModel.attributes.MandatorId = currentUser.MandatorId;
        newModel.attributes.OrgUnitId = currentUser.OrgUnitId;

        newModel.attributes.Custom_001 = group;
        newModel.attributes.Custom_002 = value;

        newModel.attributes.IsActive = true;
        newModel.attributes.EntryTime = moment().toDate();
        newModel.saveItem();
        window.genericData.add(newModel);

        if (IsOfflineVersion == false) {
            SyncController.SyncQueue.push({
                Type: 'GenericData', Manually: false, Async: true, Callback: function () {
                    ActionHelper.globalAfterSync();
                }

            });
        }
        currentUser = null;
        newModel = null;
    },

    setSelectedModel: function (model) {
        GenericHelper.addModel(model);
    },

    addModel: function (model) {
        GenericHelper.addModel(model, false);
    },

    test: function () {
        var STATUS_UNTERBROCHEN = 'be843deb-dcd5-e311-80be-00155d36f21e';
        var STATUS_ABGELEHNT = 'bf843deb-dcd5-e311-80be-00155d36f21e';
        var value = $('#62eed9e2-edd1-e311-80bd-00155d36f21e').val();
        var field = $('#168f3a86-5d10-c361-08b3-274d419a9c4f');
        if (value == STATUS_ABGELEHNT || value == STATUS_UNTERBROCHEN) {
            field.closest('fieldset').hide();
        } else {
            field.closest('fieldset').show();
        }
    },
    isMassUpdate: function () {
        var ret = false;
        if (ActionHelper.Models != null && ActionHelper.Models.length > 0) {
            ret = true;
        }
        return ret;
    },

    sendDirectMail: function (to, cc, subject, body, fileContent, fileName, fileType) {
        var mandatorid = window.currentUser.MandatorId;
        var userid = window.currentUser.UserId;
        MailObject = {
            To: to,
            CC: cc,
            Subject: subject,
            Body: body,
            FileContent: fileContent,
            FileName: fileName,
            FileType: fileType,
            MandatorID: mandatorid,
            UserID: userid
        };

        $.ajax({
            url: window.location.origin + '/action/api/emails/SendEmail',
            data: JSON.stringify(MailObject),
            type: 'post',
            contentType: "application/json; charset=utf-8",
            timeout: CONSTS.TIMEOUT_SUPPORT_DATA,
            success: function (AjaxReturnObject) {
                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Erfolg', 'Ok');
                    }
                }
                else {
                    //Error
                }
            },
            error: function (response) {
                if (response.status == 500) {
                    alert(Utils.getText('ANFRAGE_NICHT_UEBERTRAGEN'));
                } else if (response.statusText != 'timeout') {
                    //nix tun
                }
                else {
                    alert(Utils.getText('TIME_OUT'));
                }
            }
        });
    },

    sendSupportData: function () {
        var dataList = [
          'Devices',
          'GenericData',
          'GenericEntities',
          'GenericProperties',
          'GenericValidation',
          'GenericViewActions',
          'GenericViewFields',
          'GenericViewFilters',
          'GenericViews',
          'UserRawElementEntries',
          'currentDevice',
          'currentUser',
          'customer',
          'deviceId',
          'moduleBundle'
        ];

        var fileContent = '';

        //ADD VERSION NUMBER DUMMY VERSIONNUMBER = 1 AND HAS TO BE SET MANUALLY
        fileContent += 'OfflineConfigVersion,1';

        fileContent += '\n';

        for (var i = 0; i < dataList.length; i++) {
            var item = dataList[i];
            var json = localStorage.getItem(item);
            if (json == undefined || json == 'undefined' || json == '') {
                json = null;
            }

            //create CSV
            fileContent += item + ',';
            fileContent += json;

            if (i < dataList.length - 1) {
                fileContent += '\n';
            }

        }

        var subject = Utils.getText('SUPPORTANFRAGE') + window.currentUser.Email;
        var fileName = 'localStorageJSON.csv';
        var fileType = 'csv';
        var body = Utils.getText('ANGEHAENGTE_DATEN_FINDEN');
        this.sendDirectMail('mfapp@mobile-function.com', null, subject, body, fileContent, fileName, fileType);
    }
};