﻿/**
* Erweiterung zur besseren verwendung von Arrays in JavaScript
*
* @class array.js
*/
Array.prototype.remove = function () {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};

Array.prototype.removeValue = function (name, value) {
    var count = 0;
    //Entfernt alle bis auf 2! Einträge aus dem Array
    var array = $.map(this, function (v, i) {
        if (v[name] == value)
            count++;
        if (v[name] == value && (count == 1 || count > 2)) {
            return null;
        }
        else {
            return v;
        }
        //return v[name] === value ? null : v;
    });
    this.length = 0; //clear original array
    this.push.apply(this, array); //push all elements except the one we want to delete
};

Array.prototype.removeRange = function (from, to) {
    var rest = this.slice((to || from) + 1 || this.length);
    this.length = from < 0 ? this.length + from : from;
    return this.push.apply(this, rest);
};


Array.prototype.findByValue = function (name, value) {
    var count = 0;
    var result = new Array();
    for (var i = 0; i < this.length; i++) {
        var v = this[i];
        if (v[name] == value) {
            result.push(v);
        }
    }
    return result;
};

Array.prototype.removeElementByValue = function (name, value) {
    var count = 0;
    var result = new Array();
    for (var i = 0; i < this.length; i++) {
        var v = this[i];
        if (v[name] != value) {
            result.push(v);
        }
    }
    this.length = 0; //clear original array
    this.push.apply(this, result); //push all elements except the one we want to delete
};

Array.prototype.max = function (precision) {
    var val = Math.max.apply(Math, this);

    if (precision != undefined) {
        val = val.toFixed(precision);
    }

    return val.toString().indexOf('Infinity') > -1 ? '-' : val;
};

Array.prototype.min = function (precision) {
    var val = Math.min.apply(Math, this);

    if (precision != undefined) {
        val = val.toFixed(precision);
    }

    return val.toString().indexOf('Infinity') > -1 ? '-' : val;
};

Array.prototype.average = function () {
    var sum = 0, j = 0;
    for (var i = 0; i < this.length, isFinite(this[i]) ; i++) {
        sum += parseFloat(this[i]); ++j;
    }
    return j ? sum / j : '-';
};