﻿/**
* Implementiert zusätzliche Methoden um die Standardfunktionalität von Backbone zu erweitern
*
* @class backboneHelper.js
*/
var Store = function (name) {
    this.name = name;
    this.data = {};
    if (window.deviceready) {
        var store = window.localStorage.getItem(this.name);
        this.data = !store ? {} : JSON.parse(store);
    }
};

_.extend(Store.prototype, {
    save: function (persistToLocalStorageImmediately) {

        if (persistToLocalStorageImmediately != false) {
            // workaround for the memory leak while saving to local storage in loop
            // do nothing if PersistToLocalStorageImmediately = false
            var myData;
            if (this.name === "GenericData") {
                myData = JSON.stringify(window.genericData.models);
            }
            else {
                myData = JSON.stringify(this.data);
            }
            window.localStorage.setItem(this.name, myData);
            myData = null;
        }
    }, create: function (model) {
        if (!model.id) {
            if (model.attributes.DataId != undefined) {
                model.id = model.attributes.DataId;
                model.attributes = model.attributes.DataId;
            } else {
                model.id = model.attributes.id = window.generateGuid();
            }
        };
        var persistToLocalStorageImmediately = model.PersistToLocalStorageImmediately;
        model.PersistToLocalStorageImmediately = true;
        this.data[model.id] = model;
        this.save(persistToLocalStorageImmediately);
        return model;
    }, update: function (model) {

        //if (!model.id) {
        //    if (model.attributes.DataId != undefined) {
        //        model.id = model.attributes.DataId;
        //        model.attributes = model.attributes.DataId;
        //    }
        //    else {
        //        model.id = model.attributes.id = window.generateGuid()
        //    }

        //};

        var persistToLocalStorageImmediately = model.PersistToLocalStorageImmediately;
        model.PersistToLocalStorageImmediately = true;
        this.data[model.id] = model;
        this.save(persistToLocalStorageImmediately);
        return this.data[model.id];
    }, find: function (model) {
        return this.data[model.id];
    }, findAll: function () {
        return _.values(this.data);
    }, destroy: function (model) {
        var persistToLocalStorageImmediately = model.PersistToLocalStorageImmediately;
        model.PersistToLocalStorageImmediately = true;
        if (window.navigator.notification && model.get('EntityId') === CONSTS.ATTACHEMENTS_ENTITY_ID) {
            FileHelper.deleteFile(model.id);
        }
        delete this.data[model.id];
        this.save(persistToLocalStorageImmediately);
        return model;
    },
    //persistToStorage: function () {
    //    var myData = JSON.stringify(this.data);
    //    window.localStorage.setItem(this.name, myData);
    //    myData = null;
    //}
});
Backbone.sync = function (method, model, options) {

    var resp;
    var store =  model.localStorage || model.collection.localStorage;

    if (options.data) {
        // properly formats data for back-end to parse
        options.data = JSON.stringify(options.data);
    }

    switch (method) {
        case "read":
            resp = model.id ? store.find(model) : store.findAll();
            break;
        case "create":
            resp = store.create(model);
            break;
        case "update":
            resp = store.update(model);
            break;
        case "delete":
            resp = store.destroy(model);
            break;
    }

    if (resp) {
        options.success(resp);
    } else {
        options.error("Eintrag nicht gefunden");
    }
    //if (method == "read" && model.id == null) {
    //    store.loadDataFromServer();
    //}

    // start auto-sync with server => moved to model collection event listener
    //if (typeof model.toBeSynchronized === 'function' && model.toBeSynchronized()) { // avoid endless loop!!!
    //    //setTimeout(SyncController.synchronize(), 0);
    //    // model.trigger("saved");
    //}
};