﻿/**
* Definiert diverse Konstanten welche global in der Web Applikation verwendet werden können
*
* @class BluetoothHelper.js
*/
var CONSTS = {
    APP_VERSION: '3.8.2',
    IS_CACHED: true, // used to determine, whether files are already cached on device

    INDEXEDDB_VERSION: 2,
    DB_NAME: "MFAPP_DB",
    STORE_NAME: window.location.hostname,

    // keep default values in sync with website
    GUID_DEFAULT: '00000000-0000-0000-0000-000000000000',
    INTEGER_DEFAULT: -99,
    DATE_DEFAULT: moment('0001-01-01').toDate(),

    FLOAT_FORMAT_DEFAULT: "###0.00",

    ENCRYPTION_KEY: '3279ebb8b9734f44ac8f8e031c682713',
    ENCRYPTION_IV: '1355f0997a43400786586df740dca759',

    JSCONSOLE_URL: 'http://jsconsole.com/remote.js?',

    MODULE_ID: 'c42e3f3c-fa27-4130-ac53-e406938c8cac',

    EMAIL_REQUEST_ID: '1bc28e66-4663-4837-b177-5339891493c8',

    //DATE_FORMAT: 'DD.MM.YYYY',
    //DATETIME_FORMAT: 'DD.MM.YYYY HH:mm:ss',  
    //TIME_FORMAT: 'HH:mm:ss',
    //SHORT_TIME_FORMAT:'HH:mm',
    DATE_PERSIST_FORMAT: 'YYYY-MM-DD',
    DATETIME_PERSIST_FORMAT: 'YYYY-MM-DD HH:mm:ss',
    TIME_PERSIST_FORMAT: 'HH:mm:ss',
    //DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',

    FILETYPE_PNG: 'png',
    FILETYPE_JPG: 'jpg',
    FILETYPE_PDF: 'pdf',
    FILE_CHOOSER_ACCEPTS: 'image/png, image/jpg, image/jpeg, application/pdf',
    FILE_OPENER_TYPES: { png: 'image/png', jpg: 'image/jpeg', jpeg: 'image/jpeg', pdf: 'application/pdf', json: 'application/json' },

    POSSIBLE_LANGUAGES: new Array('de','en','fr','it','es', 'sv', 'da', 'no', 'fi', 'hu', 'cs', 'sk', 'pl', 'sl', 'hr', 'sr'),


    TIMEOUT_SUPPORT_DATA: 10 * 120000,  // 10 min
    TIMEOUT_GDATA: 2*120000,  // 120 seconds
    TIMEOUT_CONFIG: 2*60000,  // 60 seconds
    TIMEOUT_SEARCH: 20000,  // 2 seconds


    LISTVIEW_FIELDSIZE: 18, /* Die höhe eines ViewFields in einem ListenElement in ListViews. Wird für LazyLoading benötigt */

    GENERIC_ENTITY_ID_ENTITIES: '11111111-1111-1111-1111-111111111125',
    GENERIC_ENTITY_ID_PROPERTIES: '11111111-1111-1111-1111-111111111126',
    GENERIC_ENTITY_ID_VALIDATION: '11111111-1111-1111-1111-111111111131',
    GENERIC_ENTITY_ID_VIEW_ACTIONS: '11111111-1111-1111-1111-111111111129',
    GENERIC_ENTITY_ID_VIEW_FIELDS: '11111111-1111-1111-1111-111111111128',
    GENERIC_ENTITY_ID_VIEW_FILTERS: '11111111-1111-1111-1111-111111111130',
    GENERIC_ENTITY_ID_VIEWS: '11111111-1111-1111-1111-111111111127',
    GENERIC_ENTITY_ID_REPORT_CONFIG: '11111111-1111-1111-1111-111111111133',
    GENERIC_ENTITY_ID_REPORT_PARAMS: '11111111-1111-1111-1111-111111111135',

    ATTACHEMENTS_ENTITY_ID: '17f795ed-907b-0568-0cb1-e793873c224d',
};

var ConstValueHandler = {
    getConstValue: function (constant) {
        constantValue = '';
        switch (switch_on) {
            case '##ME##':
                constantValue = window.currentUser.UserId;
                break;
            default:
        }
        return constantValue;
    }
};

// TODO: Alle ähnlichen Anwendungsfälle (Fahrtart, Status, RecordTypes, etc.) als "Enum" auslagern => In sync mit Leitstand
var RETURN_TYPE = {
    SUCCESS: 0,
    INFO: 1,
    WARNING: 2,
    ERROR: 3,
    EMPTY: CONSTS.INTEGER_DEFAULT
};

var TRAVEL_TYPE = {
    PRIVATE : 0,
    OFFICIAL : 1,
    WAYHOME : 2,
    EMPTY: CONSTS.INTEGER_DEFAULT
};

var SALUTATION = {
    MISTER: 0,
    MISSES: 1,
    EMPTY: CONSTS.INTEGER_DEFAULT
};

var RECORD_STATUS = {
    ACTIVE: 0,
    INACTIVE: 1,
    CANCELED: 2,
    EMPTY: CONSTS.INTEGER_DEFAULT
};

var RECORDING_TYPE = {
    START: 0, // Kommen
    END: 1, // Gehen
    EMPTY: CONSTS.INTEGER_DEFAULT
};

var RECEIPT_TYPE = {
    MISCELLANEOUS: 0,
    ACCOMMODATION: 1,
    REFUEL: 2,
    CAR_EXPENSES: 3,
    CONSUMABLES: 4,
    TELECOMMUNICATIONS: 5,
    EMPTY: CONSTS.INTEGER_DEFAULT
};
