var FormatPattern = {
    en: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D mm/dd/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D mm/dd/yyyy HH:mm:ss',
            }
        }
    },

    de: {
        numberFormat: {
            ',': ".",
            '.': ",",
        },
        Calendar: {
            '/': ".",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"],
                namesAbbr: ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"],
                namesShort: ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"]
            },
            months: {
                names: ['Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'],
                namesShort: ['Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'],
            },

            patterns: {
                DATE_FORMAT: 'DD.MM.YYYY',
                DATE_DISPLAY_FORMAT: 'D dd.mm.yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd.mm.yyyy HH:mm:ss',
                DATETIME_FORMAT: 'DD.MM.YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'DD.MM.YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'ddmmy',
            }
        }
    },

    it: {
        numberFormat: {
            ',': ".",
            '.': ",",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 1,
            days: {
                names: ["domenica", "lunedì", "martedì", "mercoledì", "giovedì", "venerdì", "sabato"],
                namesAbbr: ["dom", "lun", "mar", "mer", "gio", "ven", "sab"],
                namesShort: ["do", "lu", "ma", "me", "gi", "ve", "sa"]
            },
            months: {
                names: ["gennaio", "febbraio", "marzo", "aprile", "maggio", "giugno", "luglio", "agosto", "settembre", "ottobre", "novembre", "dicembre", ""],
                namesAbbr: ["gen", "feb", "mar", "apr", "mag", "giu", "lug", "ago", "set", "ott", "nov", "dic", ""]
            },

            patterns: {
                DATE_FORMAT: 'DD/MM/YYYY',
                DATETIME_FORMAT: 'DD/MM/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'DD/MM/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD/MM/YYYY',
                SCROLLER_DATEORDER: 'ddmmy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    fr: {
        numberFormat: {
            ',': " ",
            '.': ",",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 1,
            days: {
                names: ["dimanche", "lundi", "mardi", "mercredi", "jeudi", "vendredi", "samedi"],
                namesAbbr: ["dim.", "lun.", "mar.", "mer.", "jeu.", "ven.", "sam."],
                namesShort: ["di", "lu", "ma", "me", "je", "ve", "sa"]
            },
            months: {
                names: ["janvier", "février", "mars", "avril", "mai", "juin", "juillet", "août", "septembre", "octobre", "novembre", "décembre", ""],
                namesAbbr: ["janv.", "févr.", "mars", "avr.", "mai", "juin", "juil.", "août", "sept.", "oct.", "nov.", "déc.", ""]
            },

            patterns: {
                DATE_FORMAT: 'DD/MM/YYYY',
                DATETIME_FORMAT: 'DD/MM/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'DD/MM/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD/MM/YYYY',
                SCROLLER_DATEORDER: 'ddmmy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    es: {
        numberFormat: {
            ',': ".",
            '.': ",",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 1,
            days: {
                names: ["domingo", "lunes", "martes", "miércoles", "jueves", "viernes", "sábado"],
                namesAbbr: ["dom", "lun", "mar", "mié", "jue", "vie", "sáb"],
                namesShort: ["do", "lu", "ma", "mi", "ju", "vi", "sá"]
            },
            months: {
                names: ["enero", "febrero", "marzo", "abril", "mayo", "junio", "julio", "agosto", "septiembre", "octubre", "noviembre", "diciembre", ""],
                namesAbbr: ["ene", "feb", "mar", "abr", "may", "jun", "jul", "ago", "sep", "oct", "nov", "dic", ""]
            },

            patterns: {
                DATE_FORMAT: 'DD/MM/YYYY',
                DATETIME_FORMAT: 'DD/MM/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'DD/MM/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD/MM/YYYY',
                SCROLLER_DATEORDER: 'ddmmy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    sv: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    da: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    no: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    fi: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    hu: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    cs: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    sk: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    pl: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    sl: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    hr: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },

    sr: {
        numberFormat: {
            ',': ",",
            '.': ".",
        },
        Calendar: {
            '/': "/",
            ':': ":",
            firstDay: 0,
            days: {
                names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
            },
            months: {
                names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                namesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
            },

            patterns: {
                DATE_FORMAT: 'MM/DD/YYYY',
                DATETIME_FORMAT: 'MM/DD/YYYY HH:mm:ss',
                SHORT_DATETIME_FORMAT: 'MM/DD/YYYY HH:mm',
                TIME_FORMAT: 'HH:mm:ss',
                SHORT_TIME_FORMAT: 'HH:mm',
                DATETIME_BOSOGRAPH_FORMAT: 'DD.MM.YYYY',
                SCROLLER_DATEORDER: 'mmddy',
                DATE_DISPLAY_FORMAT: 'D dd/mm/yyyy',
                DATETIME_DISPLAY_FORMAT: 'D dd/mm/yyyy HH:mm:ss',
            }
        }
    },
}


FormatHelper = {
    getFormatPattern: function () {
        var de = 'de';
        //var lang = window.currentUser ? window.currentUser.LanguageCode : de;
        var lang = window.languageShort ? window.languageShort : de;
        return FormatPattern[lang];
    },

    getCalendar: function () {
        return FormatHelper.getFormatPattern().Calendar;
    },

    getPattern: function (PatternName) {
        return FormatHelper.getCalendar().patterns[PatternName];
    },

    get_DATETIME_FORMAT: function () {
        return FormatHelper.getPattern('DATETIME_FORMAT');
    },
    get_SHORT_DATETIME_FORMAT: function () {
        return FormatHelper.getPattern('SHORT_DATETIME_FORMAT');
    },

    get_DATE_FORMAT: function () {
        return FormatHelper.getPattern('DATE_FORMAT');
    },
    get_TIME_FORMAT: function () {
        return FormatHelper.getPattern('TIME_FORMAT');
    },
    get_SHORT_TIME_FORMAT: function () {
        return FormatHelper.getPattern('SHORT_TIME_FORMAT');
    },
    get_SCROLLER_DATEORDER: function () {
        return FormatHelper.getPattern('SCROLLER_DATEORDER');
    },

    get_DATE_DISPLAY_FORMAT: function () {
        return FormatHelper.getPattern('DATE_DISPLAY_FORMAT');
    },
    get_DATETIME_DISPLAY_FORMAT: function () {
        return FormatHelper.getPattern('DATETIME_DISPLAY_FORMAT');
    },

    get_MONTH_NAMES: function () {
        return FormatHelper.getCalendar().months.names;
    },
    get_MONTH_NAMES_SHORT: function () {
        return FormatHelper.getCalendar().months.namesShort;
    },
    get_DAY_NAMES: function () {
        return FormatHelper.getCalendar().days.names;
    },
    get_DAY_NAMES_SHORT: function () {
        return FormatHelper.getCalendar().days.namesShort;
    },

    getDezimalSeperator: function () {
        return FormatHelper.getFormatPattern().numberFormat['.'];
    },
    getLondNumberSeperator: function () {
        return FormatHelper.getFormatPattern().numberFormat[','];
    },
    getDecimalString: function (value) {
        return value.toString().replace('.', FormatHelper.getDezimalSeperator());
    },
    getDecimalPersistantValue: function (value) {
        return value.toString().replace(FormatHelper.getDezimalSeperator(), '.');
    },
}
