/**
* Get the proper dataSecurityText
*
* @class DataSecurityHelper.js
*/
DataSecurityHelper = {
    getDsText: function(lang) {      
        var fallbackLanguage = 'en'
        var language = !!lang ? lang.toLowerCase() : fallbackLanguage;

        var deHtml = ''
        // deHtml += '<h3><strong>Datenschutzerkl&auml;rung zur boso App</strong></h3>'
        // deHtml += '<p>&nbsp;</p>'
        deHtml += '<p><strong>Zugriffsrechte der boso App und Zwecke der Zugriffsrechte</strong></p>'
        deHtml += '<p>Die App ben&ouml;tigt den Zugriff auf Ihre Foto/Medien/Dateien. Die App liest keine Dateien aus, sondern ben&ouml;tigt das Recht, Messdaten auf dem Ger&auml;t zu speichern, z.B. im PDF-Format.</p>'
        deHtml += '<p>Die App ben&ouml;tigt Zugriff auf Ihre Bluetooth-Verbindung, um eine Verbindung zu Ihrem Messger&auml;t herzustellen.</p>'
        deHtml += '<p>Die App ben&ouml;tigt Zugriff auf Ihren Standort. Dies verlangt nicht die boso App selbst, sondern ist eine Vorbedingung zur Verwendung der Bluetooth-Verbindung.</p>'
        deHtml += '<p><strong>Speicherdauer</strong></p>'
        deHtml += '<p>Die Daten des Messger&auml;ts, die von der App ausgelesen werden, k&ouml;nnen vom Nutzer auf dem Ger&auml;t gespeichert werden. Der Nutzer kann diese Daten jederzeit l&ouml;schen und er bestimmt somit selbst, wie lange die Daten gespeichert werden.</p>'
        deHtml += '<p><strong>&Uuml;bertragung der Daten an Dritte</strong></p>'
        deHtml += '<p>Eine &Uuml;bertragung an Dritte durch die App findet nicht statt. Eine m&ouml;gliche &Uuml;bertragung an Dritte wird allein vom Nutzer veranlasst. Z.B. wenn der Nutzer die ausgelesenen Messwerte in Form einer PDF per E-Mail verschicken m&ouml;chte.</p>'
        deHtml += '<p>Eine Ausnahme hiervon kann entstehen, wenn der Nutzer die Dienstleistungen der Firma medmobile GmbH, Alszeile 103, 1170 Wien, E-Mail: office@medmobile.at (im Folgenden: Medmobile) nutzt. Der Nutzer hat dann die M&ouml;glichkeit, die Einstellungen der App so anzupassen, dass eine &Uuml;bertragung der Messwarte in verschl&uuml;sselter und anonymisierter Form an die Server der Firma Medmobile erm&ouml;glicht wird. Diese Einstellungen k&ouml;nnen ausschlie&szlig;lich vom Nutzer selbst vorgenommen werden in Abstimmungen mit der Firma Medmobile. Die boso App nimmt keine Einstellungs&auml;nderung automatisch vor. Wenn Daten an Medmobile &uuml;bertragen werden, dann sind dies folgende: Seriennummer des Messger&auml;tes sowie die Messdaten des Messvorgangs. Sollte die verschl&uuml;sselte &Uuml;bertragung kompromittiert werden von Dritten, so ist eine Zuordnung von Messdaten zu einer Person nicht m&ouml;glich. Die Zuordnung der Seriennummer des Messger&auml;tes zu einer Person, also einem Kunden von Medmobile, findet auf den Systemen von Medmobile statt. Die Firma Medmobile ist auch im datenschutzrechtlichen Sinne f&uuml;r diese Verarbeitungen allein verantwortlich. Dies gilt f&uuml;r die Rechtsgrundlage und Zwecke der Verarbeitung und insbesondre hinsichtlich dem L&ouml;schen, Sperren und dem Berichtigen der Daten, die von Medmobile verarbeitet werden sowie dem generellen Widerspruch zur Datenverarbeitung durch Medmobile.</p>'
        deHtml += '<p>Es findet sonst kein weiterer Datenaustausch zwischen der Bosch + Sohn GmbH u. Co. KG, der boso App und Medmobile statt. Der Nutzer kann jederzeit die &Uuml;bertragung von Daten an Medmobile unterbinden, in dem er seine Einstellungen entsprechend anpasst.</p>'
        deHtml += '<p><strong>&nbsp;</strong></p>'
        deHtml += '<p><strong>Auswertung des Nutzungsverhaltens</strong></p>'
        deHtml += '<p>Es findet keine Auswertung des Nutzungsverhaltens statt. Der Nutzer hat jederzeit die M&ouml;glichkeit die App selbst zu l&ouml;schen. Ebenso hat er die M&ouml;glichkeit, die von der App erhoben Daten zu l&ouml;schen oder anderweitig zu verarbeiten.</p>'
        deHtml += '<p><strong>Kontaktdaten</strong></p>'
        deHtml += '<p>Wenn Sie Fragen zum Thema Datenschutz haben, die nicht durch diese Datenschutzerkl&auml;rung beantwortet werden, stehen Ihnen folgende Kontaktm&ouml;glichkeiten offen:</p>'
        deHtml += '<p>&nbsp;</p>'
        deHtml += '<p>Bosch + Sohn GmbH u. Co. KG <br> Bahnhofstr. 64</p>'
        deHtml += '<p>DE-72417 Jungingen</p>'
        deHtml += '<p>datenschutz@boso.de</p>'


        var enHtml = ''
        enHtml += '<p><strong>Access Permission of the boso App and Purpose of Access Permission</strong></p>'
        enHtml += '<p>The app requires access to your photos/media/files. The app does not read the files but rather needs permission to store measurement data on your device, e.g. in the form of PDFs.</p>'
        enHtml += '<p>The app requires access to your Bluetooth connection in order to establish a connection to your measuring device.</p>'
        enHtml += '<p>The app requires access to your location. This is not a requirement of the boso app itself but a prerequisite for using the Bluetooth connection.</p>'
        enHtml += '<p>&nbsp;</p>'
        enHtml += '<p><strong>Duration of Storage</strong></p>'
        enHtml += '<p>The data of the measuring device that can be read by the app can be stored on the device by the user. The user can delete this data at any time and can therefore decide independently, for how long the data will be stored.</p>'
        enHtml += '<p>&nbsp;</p>'
        enHtml += '<p><strong>Transmission of Data to Third Parties</strong></p>'
        enHtml += '<p>The app does not transmit data to third parties. A potential transmission to third parties can only be initiated by the user, e.g. if the user wants to share measurement data as a PDF via e-mail.</p>'
        enHtml += '<p>An exception thereof can occur if the user uses services of medmobile GmbH, Alszeile 103, 1170 Wien, e-mail: <a href="mailto:office@medmobile.at">office@medmobile.at</a> (&ldquo;Medmobile&rdquo; in the following). The user has the option of adapting the app&rsquo;s settings to enable transmission of encrypted and anonymised measurement data to the servers of Medmobile. These settings can only be made by the user him-/herself in agreement with Medmobile.</p>'
        enHtml += '<p>The boso app does not automatically change any settings. If data is transmitted to Medmobile, it consists of the following: the measuring device&rsquo;s serial number as well as measurement data of the measuring process. If the encrypted transmission is compromised by third parties, assignment of measurement data to a person is not possible. The assignment of the measuring device&rsquo;s serial number to a person &ndash; a customer of Medmobile &ndash; takes place on the systems of Medmobile. The company Medmobile is also the sole responsible party for data protection matters regarding this processing of data. This applies to the legal base and purpose of processing and especially in respect of deletion, blockage and correction of data that is processed by Medmobile, as well as general objection to data processing by Medmobile.</p>'
        enHtml += '<p>There is no further exchange of data between Bosch + Sohn GmbH &amp; Co. KG, the boso app and Medmobile. The user can prevent transmission of data to Medmobile at any time by adapting his/her settings accordingly.</p>'
        enHtml += '<p>&nbsp;</p>'
        enHtml += '<p><strong>Analysis of Usage Behaviour</strong></p>'
        enHtml += '<p>There will be no analysis of usage behaviour. The user is free to delete the app at any time. Likewise, he/she has the ability to delete the data collected by the app or further process it.</p>'
        enHtml += '<p>&nbsp;</p>'
        enHtml += '<p><strong>Contact Data</strong></p>'
        enHtml += '<p>If there are any questions regarding data protection that could not be answered in this privacy policy, feel free to contact us:</p>'
        enHtml += '<p>Bosch + Sohn GmbH u. Co. KG <br> Bahnhofstr. 64 </p>'
        enHtml += '<p>DE-72417 Jungingen</p>'
        enHtml += '<p>datenschutz@boso.de</p>'

        switch (language) {
            case 'de': return deHtml;
            case 'en': return enHtml;
            default: return enHtml;
        }
    },
};