﻿/**
* Sucht zu einem übergebenen Wert einen Standard Wert (Default Wert) und gibt diesen zurück
*
* @class DefaultValueHelper.js
*/
DefaultValueHelper = {

    DEFAULTS: [
        '##ME##',
        '##DATE_TIME_NOW##',
        '##DATE_NOW##',
        '##TIME_NOW##',
        '##DATE_TIME_NOW_ID##',
        '##MYEMAIL##',
        '##PARENT##'
    ],

    getDefaultValue: function (field) {
        defaultValue = field.attributes.DefaultValue;

        if (defaultValue != '') {
            for (var i = 0; i < DefaultValueHelper.DEFAULTS.length; i++) {
                //CONTAINS defaultValue: DEFAULTS[i]?
                if (defaultValue.indexOf(DefaultValueHelper.DEFAULTS[i]) > -1) {
                    var constantVal = DefaultValueHelper.getConstantValue(DefaultValueHelper.DEFAULTS[i], defaultValue, field);

                    var customStart = defaultValue.indexOf('Custom_');
                    if (customStart > -1) {
                        var replaceValue = DefaultValueHelper.DEFAULTS[i] + '.' + defaultValue.substr(customStart, customStart + 10);
                        defaultValue = defaultValue.replace(replaceValue, constantVal);
                        return defaultValue;
                    } else {
                        defaultValue = defaultValue.replace(DefaultValueHelper.DEFAULTS[i], constantVal);
                        return defaultValue;
                    }
                }
                else if (defaultValue.indexOf("##CUSTOM_CODE!!") > -1) {
                    var func = defaultValue.replace("##CUSTOM_CODE!!", "").replace("!!##", "");


                    defaultValue = eval(func);;
                    return defaultValue;
                }
            }
        }
        return defaultValue;
    },

    getConstantValue: function (constantValue, completeValue, field) {
        switch (constantValue) {
            case '##PARENT##':
                var parentId = ActionHelper.CurrentView.options.refModelId;
                if (parentId != null && parentId != '') {
                    return parentId
                }
                return null;
                break;
            case '##ME##':
                if (field != null) {
                    var customStart = -1;
                    if (completeValue != null) {
                        customStart = completeValue.indexOf('Custom_');
                    }
                    var gcn = null;
                    var entityData = null;
                    var defaultData = null;
                    var property = window.genericProperties.get(field.attributes.DefaultValueLookupPropertyId);
                    if (property != null) {
                        entityData = _.filter(window.genericData.models, function (data) {
                            return data.attributes.EntityId == property.attributes.EntityId;
                        });
                        defaultData = _.first(_.filter(entityData, function (data) {
                            var attr = data.get(property.attributes.GenericColumnName);
                            return attr == window.currentUser.UserId;
                        }));
                    }

                    if (customStart > -1) {
                        gcn = completeValue.substr(customStart, customStart + 10);
                        if (defaultData != null) {
                            if (gcn != null && gcn != '') {
                                constantValue = defaultData.get(gcn);
                            } else {
                                constantValue = defaultData.attributes.ObjectId;
                            }
                        }
                    } else {
                        if (defaultData != null) {
                            constantValue = defaultData.attributes.ObjectId;
                        } else {
                            constantValue = window.currentUser.UserId;
                        }
                    }
                } else {
                    constantValue = window.currentUser.UserId;
                }
                break;
            case '##MYEMAIL##':
                constantValue = window.currentUser.Email;
                break;
            case '##DATE_TIME_NOW##':
                var dateString = moment().toDate().toString();
                var dateValue = moment(dateString).format(CONSTS.DATETIME_PERSIST_FORMAT, 'de');
                dateValue = moment(dateValue, CONSTS.DATETIME_PERSIST_FORMAT).format(FormatHelper.get_DATETIME_FORMAT(), 'de');
                constantValue = dateValue;
                break;
            case '##DATE_NOW##':
                var dateString = moment().toDate().toString();
                var dateValue = moment(dateString).format(CONSTS.DATE_PERSIST_FORMAT, 'de');
                dateValue = moment(dateValue, CONSTS.DATE_PERSIST_FORMAT).format(FormatHelper.get_DATE_FORMAT(), 'de');
                constantValue = dateValue;
                break;
            case '##TIME_NOW##':
                var dateString = moment().toDate().toString();
                var dateValue = moment(dateString).format(CONSTS.TIME_PERSIST_FORMAT, 'de');
                dateValue = moment(dateValue, CONSTS.TIME_PERSIST_FORMAT).format(FormatHelper.get_TIME_FORMAT(), 'de');
                constantValue = dateValue;
                break;
            case '##DATE_TIME_NOW_ID##':
                var date = new Date();
                var d = date.getDate();
                var mm = date.getMonth() + 1;
                var y = date.getFullYear();
                var h = date.getHours();
                var m = date.getMinutes();
                var s = date.getSeconds();
                var isoDate = '' + y + (mm <= 9 ? '0' + mm : mm) + (d <= 9 ? '0' + d : d) + (h <= 9 ? '0' + h : h) + (m <= 9 ? '0' + m : m) + (s <= 9 ? '0' + s : s);

                constantValue = isoDate;
                break;
            case '##DATE_FIRST_OF_CURRENT_MONTH##':
                constantValue = moment().startOf('month').format(FormatHelper.get_DATE_FORMAT());
                break;
            case '##DATE_END_OF_CURRENT_MONTH##':
                constantValue = moment().endOf('month').format(FormatHelper.get_DATE_FORMAT());
                break;
            case '##DATE_FIRST_OF_CURRENT_WEEK##':
                constantValue = moment().startOf('week').format(FormatHelper.get_DATE_FORMAT());
                break;
            default:

        }
        return constantValue;
    }

};