﻿/**
* Macht Generic GlobalSettings in der App verfügbar Einträge dieser Entität können hier ausgewertet werden
*
* @class GlobalSettings.js
*/
GlobalSettings = {
    MainColor: function () {
        var ret = "";
        if (window.genericData != null) {
            var mainColor = _.filter(window.genericData.models, function (data) {
                return data.get('EntityId') == "c5423f2b-134b-2e08-ae69-419edf7ffa6a";
            });

            if (Utils.isNull(mainColor))
                return;

            if (Utils.isNull(mainColor[0]))
                return;

            if (Utils.isNull(mainColor[0].attributes))
                return;

            if (Utils.isNull(mainColor[0].attributes.Custom_009))
                return;


            ret = mainColor[0].attributes.Custom_009;
        }

        console.log(" MainColor:  " + ret);
        return ret;
    },

    IsBoso: function () {
        var mandator = null;
        if (currentUser && currentUser.MandatorId) {
            var BOSO_MANDATOR_ID = '479ecc34-aae8-48fd-9d10-4aeb08361913';
            
            if (currentUser.MandatorId === BOSO_MANDATOR_ID) {
                mandator = BOSO_MANDATOR_ID;
            }
        }

        return currentUser == null || currentUser.MandatorId == null || mandator == BOSO_MANDATOR_ID;
    },

    MandatorName: function () {
        var ret = "";
        if (window.genericData != null) {
            var MandatorName = _.filter(window.genericData.models, function (data) {
                return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" && data.attributes.Custom_002 == "1";
            });

            if (MandatorName != null && MandatorName != undefined) {
                ret = MandatorName[0].attributes.Custom_001;
            }
        }
        return ret;
    },

    GlobalSettings: function () {
        var ret = undefined;
        if (window.genericData != null) {
            ret = _.first(_.filter(window.genericData.models, function (data) {
                return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" && data.attributes.Custom_002 == "1";
            }));
        }
        return ret;
    },
    getExternalDocumentName: function () {
        var ret = undefined;
        var settings = this.GlobalSettings();
        if (settings != undefined && settings.get('Custom_013') != undefined && settings.get('Custom_013').length > 0)
            ret = settings.get('Custom_013');
        return ret;
    },
    getExternalDocumentURL: function () {
        var ret = undefined;
        var settings = this.GlobalSettings();
        if (settings != undefined && settings.get('Custom_012') != undefined && settings.get('Custom_012').length > 0)
            ret = settings.get('Custom_012');
        return ret;
    },
    getAutomatischeLeistungsberechnung: function () {
        var ret = undefined;
        var settings = this.GlobalSettings();
        if (settings != undefined && settings.get('Custom_014') != undefined && settings.get('Custom_014').length > 0)
            ret = settings.get('Custom_014');
        return ret;
    },
    SyncDeaktivated: function () {
        if (window.genericData != null) {
            var SyncDeaktivated = _.filter(window.genericData.models, function (data) {
                return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" && data.attributes.Custom_005 == "1";
            });

            if (SyncDeaktivated != null && SyncDeaktivated != undefined) {
                if (SyncDeaktivated[0] != undefined) {
                    if (SyncDeaktivated[0].attributes.Custom_005 == true) return true;
                }
            }
        }
        return false;
    },

    LocationActive: function () {
        if (window.genericData != null) {
            var locationActive = _.filter(window.genericData.models, function (data) {
                return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" && data.attributes.Custom_002 == "1";
            });

            if (locationActive != null && locationActive != undefined) {
                if (locationActive[0] != undefined) {
                    if (locationActive[0].attributes.Custom_008 == true) return true;
                }
            }
        }
        return false;
    },


    ZoomFaktor: function () {
        var ret = "";
        if (window.devicePlatform != "BROWSER") {


            if (window.genericData != null) {
                var zoomFaktor = _.filter(window.genericData.models, function (data) {
                    return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" && data.attributes.Custom_002 == "1";
                });

                if (zoomFaktor != null && zoomFaktor != undefined) {
                    if (zoomFaktor[0] != undefined) {
                        ret = zoomFaktor[0].attributes.Custom_003;
                    }
                }
            }
        }

        console.log(" Zoom  " + ret);
        return ret;
    },

    CustomIcon: function () {
        var brandBasePath = "images/brands/";
        var ret = "mf-brand.png";
        if (window.genericData != null) {
            var customIcon = _.filter(window.genericData.models, function (data) {
                return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" &&
                    (data.attributes.Custom_006 != "" && data.attributes.Custom_006 != null && data.attributes.Custom_006 != undefined);
            });

            if (customIcon != null && customIcon != undefined && customIcon.length > 0) {
                ret = customIcon[0].attributes.Custom_006;
            }
        }
        return brandBasePath + ret;
    },

    DisableDeleteButtonsAtConfig: function () {
        var ret = false;
        try {
            if (window.genericData != null && window.genericData.models != null) {
                var btn = _.filter(window.genericData.models, function (data) {
                    return data.attributes.EntityId == "c5423f2b-134b-2e08-ae69-419edf7ffa6a" && data.attributes.Custom_002 == "1";
                });

                if (btn != null && btn != undefined) {
                    ret = btn[0].attributes.Custom_004;
                }
            }

        } catch (e) {
        }
        return ret;
    }
};

UserSettings = {
    HasUserSettings: function () {
        var settingsType_Special = '2';
        var ENTITYID_BASE_UserSettings = 'ba914f10-0dbe-5905-4700-7528c0edd6fd';

        var userSettings = _.filter(window.genericData.models, function (model) {
            var settingsType = model.get('Custom_002');
            return model.get('EntityId') === ENTITYID_BASE_UserSettings && settingsType === settingsType_Special;
        });

        return userSettings.length > 0;
    },

    GetOnlyLastValue: function () {
        var BOSO_SETTING_OBJECT_ID = '1ec29fec-1a8c-4a5c-88c9-c99f5559c58f';
        var setting = window.genericData.get(BOSO_SETTING_OBJECT_ID);

        if(!!setting && setting.get('Custom_003') === '0') {
            return true
        } else {
            return false;
        }
    },

    GetDayNightIntervall: function () {
        var BOSO_SETTING_OBJECT_ID = '1ec29fec-1a8c-4a5c-88c9-c99f5559c58f';
        var setting = window.genericData.get(BOSO_SETTING_OBJECT_ID);
        var Intervall = null;
        if (setting != null && setting != undefined) {
            Intervall = new Object();
            Intervall.Start = setting.attributes.Custom_004;
            Intervall.End = setting.attributes.Custom_005;
        }
        return Intervall;
    },

    GetWeightScaleMode: function () {
        var BOSO_SETTING_OBJECT_ID = '1ec29fec-1a8c-4a5c-88c9-c99f5559c58f';
        var setting = !!window && !!window.genericData ? window.genericData.get(BOSO_SETTING_OBJECT_ID) : null;
        var weightScaleMode = !!setting ? setting.get('Custom_006') : null;

        return weightScaleMode;
    }
};