﻿/**
* Hilfs Methode um in der App GUID´s zu generieren
*
* @class guidBuilder.js
*/
//window.generateGuid = function () {
//    var s4 = function () {
//        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
//    };
//    return (s4() + s4() + "-" + s4() + "-" + s4() + "-" + s4() + "-" + s4() + s4() + s4());
//};

window.generateGuid = function () {
    var random = function (list, times) {
        if (times > 0) {
            return list[Math.random() * list.length | 0] + random(list, times - 1);
        } else {
            return '';
        }
    }
    var reducedDevID = function () {
        if (window.currentDevice) {
            var reduced = '';
            var devID = window.currentDevice.DeviceId.split('-').join('');
            var tmp = 0;
            _.each(devID, function (char, i) {
                if ((i + 1) % 4 == 0) {
                    reduced += signs[tmp % 16];
                    tmp = 0;
                }
                tmp += char.charCodeAt(0);
            });
            return reduced;
        } else {
            return random(signs, 8);
        }
    }

    var signs = '0123456789abcdef';

    var devID = reducedDevID();
    var now = new Date().getTime().toString(16).substr(0, 12);

    // xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx
    // x - zufallig
    // y - 8, 9, a oder b
    var guid = random(signs, 4);
    guid += devID.substr(0, 4) + '-' + devID.substr(4);
    guid += '-4' + random(signs, 3);
    guid += '-' + random('89ab', 1) + random(signs, 3);
    guid += '-' + random(signs, 12 - now.length) + now;
    
    return guid;
};



