﻿/**
* Hilfsmethoden zur leichteren Verwendung der von Phonegap zur Verfügung gestellten Methoden
*
* @class momentHelper.js
*/
//Damit die App im Browser (Chrome) und als PhoneGapApp läuft
function showMessage(message, callback, title, buttonName) {
    title = title || Utils.getText('MELDUNG');
    buttonName = buttonName || 'OK';

    if (typeof callback !== 'function') {
        callback = function () { };
    }

    if (window.devicePlatform != "BROWSER") {
        navigator.notification.alert(
            message,    // message
            callback,   // callback
            title,      // title
            buttonName  // buttonName
        );
    } else {
        oldAlert(message);
        if (callback)
            callback();
    }
};

function showConfirmMessage(message, confirmCallback, title, buttonLabels) {
    var buttons = [];
    if (buttonLabels) {
        _.each(buttonLabels.split(','), function(label) {
            buttons.push(label.trim());
        });
    }

    navigator.notification.confirm(message, function(result) {
        if (_.isFunction(confirmCallback)) {
            confirmCallback(result);
        }
    }, title, buttons);
};

oldConfirm = window.confirm;
window.confirm = function (message, title, buttonLabels) {

    if (title == undefined) {
        title = "";
    }
    if (buttonLabels == undefined) {
        buttonLabels = "Ok, Abrechen";
    }

    return showConfirmMessage(message, function(ret) { return ret;}, title, buttonLabels);
};

oldAlert = window.alert;
window.alert = function (message) {
    showMessage(message, false, Utils.getText('MELDUNG'), "Ok");
}




String.prototype.bool = function () {
    return (/^true$/i).test(this);
};
function openUrl(url, openInNewTab) {


    if (navigator != null && navigator.app != null) {

        navigator.app.loadUrl(url, { openExternal: openInNewTab });
    }
    else {

        if (openInNewTab) {
            window.open(
                       url,
                       '_system'); // <- This is what makes it open in a new window.
        }
        else {
            window.open(
                       url);
        }


    }

};
