﻿/**
* In dieser Datei stehen allgemeine Hilfe-methoden Beispielsweise um das Hinzufügen von Parameter zu HTML Elementen einfacher zu gestalten
*
* @class Utils.js
*/
Utils = {
    /*
    * calculates the workingtime.
    */
    calculateDuration: function (fieldVon, fieldBis, outputField) {
        var view = ActionHelper.CurrentView;
        var von = '';
        var bis = '';
        var workingHours;

        if (Utils.isNull(fieldVon) || Utils.isNull(fieldBis)) {
            return;
        }

        // read values from fields
        von = $('#' + fieldVon).val();
        bis = $('#' + fieldBis).val();

        if (Utils.isNull(von) || Utils.isNull(bis)) {
            return;
        }

        // get minutes from hours
        function getMinutes(time) {
            var splittedTime = time.split(':');
            var hours = splittedTime[0];
            var minutes = splittedTime[1];

            var totalMinutes = hours * 60 + parseInt(minutes);
            return totalMinutes;
        }

        von = getMinutes(von);
        bis = getMinutes(bis);

        // if from is after to add 24 hours
        if (bis < von) {
            bis = bis + 24 * 60;
        }


        // calculate working hours
        var workingMinutes = bis - von;
        workingHours = workingMinutes / 60;
        workingHours = workingHours.toString().replace(/\./g, ',');

        // if the outputField ist specified write the calculated value to this field,
        // otehrwise just return the value.
        if (!Utils.isNull(outputField)) {
            var hoursField = $('#' + outputField);
            hoursField.val(workingHours);
        }
        else {
            return workingHours;
        }
    },

    //rounds a number to a specified number of decimals
    round: function (number, decimals) {
        if(!number) {
            return null;
        }

        number = number.toString();
        number = number.replace(',','.');
        return Math.round(number * Math.pow(10, decimals)) / Math.pow(10, decimals);
    },

    ceil: function (number, decimals) {
        function decimalAdjust (type, value, exp) {
            // If the exp is undefined or zero...
            if (typeof exp === 'undefined' || +exp === 0) {
                return Math[type](value);
            }
            value = +value;
            exp = +exp;
            // If the value is not a number or the exp is not an integer...
            if (isNaN(value) || !(typeof exp === 'number' && exp % 1 === 0)) {
                return NaN;
            }
            // Shift
            value = value.toString().split('e');
            value = Math[type](+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp)));
            // Shift back
            value = value.toString().split('e');
            return +(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp));
        }

        var exp = -1 * decimals;
        return decimalAdjust('ceil', number, exp);
    },

    floor: function (number, decimals) {
        function decimalAdjust (type, value, exp) {
            // If the exp is undefined or zero...
            if (typeof exp === 'undefined' || +exp === 0) {
                return Math[type](value);
            }
            value = +value;
            exp = +exp;
            // If the value is not a number or the exp is not an integer...
            if (isNaN(value) || !(typeof exp === 'number' && exp % 1 === 0)) {
                return NaN;
            }
            // Shift
            value = value.toString().split('e');
            value = Math[type](+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp)));
            // Shift back
            value = value.toString().split('e');
            return +(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp));
        }

        var exp = -1 * decimals;
        return decimalAdjust('floor', number, exp);
    },

    hexToBinary: function (hexString, invert) {
        var pad = "0000"
        var binaryString = "";

        for (var i = 0; i < hexString.length; i++) {
            var hexToBinaryStr = parseInt(hexString[i], 16).toString(2)
            binaryString += pad.substring(0, pad.length - hexToBinaryStr.length) + hexToBinaryStr
        }
        if (invert == true) {
            binaryString = binaryString.split("").reverse().join("");
        }
        return binaryString;
    },

    addParams: function (el, param_01, param_02, param_03, param_04, param_05) {
        var paramJSON = '{ "param_01": "' + param_01 + '", '
                        + '"param_02": "' + param_02 + '", '
                        + '"param_03": "' + param_03 + '", '
                        + '"param_04": "' + param_04 + '", '
                        + '"param_05": "' + param_05 + '" }'
        el.attr("data-params", paramJSON);
    },

    getNumberFormat: function (precision, scale) {
        var prop_format = "";

        for (var i = 1; i < precision; i++) {
            prop_format += "#"
        }

        prop_format += "0."

        for (var i = 1; i <= scale; i++) {
            prop_format += "0"
        }

        return prop_format;
    },

    initializeHacks: function () {
        this.initializeUintArrayHack();
        this.initializeBtoaAtobHack();
    },
    initializeBtoaAtobHack: function () {
        if (!window.btoa) window.btoa = base64.encode;
        if (!window.atob) window.atob = base64.decode;
    },
    initializeUintArrayHack: function () {
        //Utils.ConsoleLog('UintArray hack for IE initialized...')
        try {
            var a = new Uint8Array(1);
            //Utils.ConsoleLog('... no hack required!')
            return; //no need
        } catch (e) { }

        function subarray(start, end) {
            return this.slice(start, end);
        }

        function set_(array, offset) {
            if (arguments.length < 2) offset = 0;
            for (var i = 0, n = array.length; i < n; ++i, ++offset)
                this[offset] = array[i] & 0xFF;
        }

        // we need typed arrays
        function TypedArray(arg1) {
            var result;
            if (typeof arg1 === "number") {
                result = new Array(arg1);
                for (var i = 0; i < arg1; ++i)
                    result[i] = 0;
            } else
                result = arg1.slice(0);
            result.subarray = subarray;
            result.buffer = result;
            result.byteLength = result.length;
            result.set = set_;
            if (typeof arg1 === "object" && arg1.buffer)
                result.buffer = arg1.buffer;

            return result;
        }

        window.Uint8Array = TypedArray;
        window.Uint32Array = TypedArray;
        window.Int32Array = TypedArray;
    },

    fromStringToByteArray: function (str) {
        var bytes = [];
        if (str) {
            for (var i = 0; i < str.length; ++i) {
                bytes.push(str.charCodeAt(i));
            }
        }
        return bytes;
    },

    fromByteArrayToBase64: function (bytes) {
        var str = String.fromCharCode.apply(null, bytes);
        str = btoa(str); //.replace(/.{76}(?=.)/g, '$&\n');
        //Utils.ConsoleLog('base64 string:' + str);
        return str;
    },

    //fromByteArrayToBase64: function (bytes) {
    //    var str = null;

    //    if (bytes) {
    //        var str = '';
    //        var byteArray = new Uint8Array(bytes);
    //        var len = byteArray.byteLength;
    //        for (var i = 0; i < len; i++) {
    //            str += String.fromCharCode(byteArray[i]);
    //        }
    //    }
    //    //Utils.ConsoleLog(str);
    //    return str;
    //},

    fromBase64ToByteArray: function (base64Str) {
        var str = null;
        if (base64Str) {
            str = base64.decode(base64Str);
            //str = atob(base64Str);
        }
        return Utils.fromStringToByteArray(str);
    },

    qualifyURL: function (url) {
        var a = document.createElement('a');
        a.href = url;
        return a.href;
    },
    SendMailWithCsv: function (models, fileName, title, body) {
        var csvContent = Utils.ConvertModelsToCSV(JSON.stringify(models), models[0].csvExportColumns(), models[0].csvIdValueMapping());
        // no content available
        if (!csvContent || csvContent == '') {
            //Utils.ConsoleLog('no file content to persist');
            return;
        }
        if (!window.localStorage.getItem("exportEmail")) {
            window.localStorage.setItem("exportEmail", "");
            if (window.currentUser) {
                var usrObj = new window.UserRawElement(window.currentUser);
                if (usrObj.attributes.Email) {
                    window.localStorage.setItem("exportEmail", usrObj.attributes.Email);
                }
            }
        }
        $('<div>').simpledialog2({
            mode: 'button',
            headerText: 'Home', //email export
            headerClose: true,
            buttonPrompt: 'Zurück',
            buttonInput: true,
            buttonInputDefault: window.localStorage.getItem("exportEmail"),
            buttons: {
                'OK': {
                    click: function () {
                        var value = $.mobile.sdLastInput;
                        if (value != "") {
                            window.localStorage.setItem("exportEmail", value);
                        }
                        value = window.localStorage.getItem("exportEmail");
                        if (value == "") return;
                        SyncController.sendMail(value, "", "", title, body, fileName, csvContent);
                    }
                },
            }
        });
    },

    /* Check if String is JSON, returns false or the parsed JSON object */
    isJSON: function (jsonString) {
        try {
            var o = JSON.parse(jsonString);

            // Handle non-exception-throwing cases:
            // Neither JSON.parse(false) or JSON.parse(1234) throw errors, hence the type-checking,
            // but... JSON.parse(null) returns 'null', and typeof null === "object", 
            // so we must check for that, too.
            if (o && typeof o === "object" && o !== null) {
                return o;
            }
        }
        catch (e) { }

        return false;
    },

    isNull: function (value) {
        if (value == null || value == 'null' || value == 'undefined' || value == '-99') {
            return true;
        };

        if (typeof (value) == 'string') {
            if (value.length == 0) { return true; }
        }

        return false;
    },

    ConsoleLog: function (obj) {
        if (1 == 1) {
            console.log(obj);
        }
    },

    Swipe: {
        xDown: null,
        yDown: null,
        callbackLeft: null,
        callbackRight: null,
        initialized: null,

        on: function (type, callback) {
            if (type == 'swipeleft') Utils.Swipe.callbackLeft = callback;
            if (type == 'swiperight') Utils.Swipe.callbackRight = callback;
            if (Utils.Swipe.initialized != true) {
                Utils.Swipe.init();
            }
        },

        init: function () {
            document.addEventListener('touchstart', Utils.Swipe.handleTouchStart, false);
            document.addEventListener('touchmove', Utils.Swipe.handleTouchMove, false);
            Utils.Swipe.xDown = null;
            Utils.Swipe.yDown = null;
            Utils.Swipe.initialized = true;
        },

        handleTouchStart: function (evt) {
            Utils.Swipe.xDown = evt.touches[0].clientX;
            Utils.Swipe.yDown = evt.touches[0].clientY;
        },

        handleTouchMove: function (evt) {
            if (!Utils.Swipe.xDown || !Utils.Swipe.yDown) {
                return;
            }

            var xUp = evt.touches[0].clientX;
            var yUp = evt.touches[0].clientY;

            var xDiff = Utils.Swipe.xDown - xUp;
            var yDiff = Utils.Swipe.yDown - yUp;

            if (Math.abs(xDiff) > Math.abs(yDiff)) {
                if (xDiff > 0) {
                    if (!Utils.isNull(Utils.Swipe.callbackLeft)) {
                        Utils.Swipe.callbackLeft();
                    }
                } else {
                    if (!Utils.isNull(Utils.Swipe.callbackRight)) {
                        Utils.Swipe.callbackRight();
                    }
                }
            }
            /* reset values */
            Utils.Swipe.xDown = null;
            Utils.Swipe.yDown = null;
        },

        reset: function () {
            document.removeEventListener('touchstart', Utils.Swipe.handleTouchStart);
            document.removeEventListener('touchmove', Utils.Swipe.handleTouchMove);
            Utils.Swipe.initialized = false;
            if (!navigator.notification) {
                //BROWSER
                $('body').unbind('swipeleft');
                $('body').unbind('swiperight');
            }
        },       
    },

    /**
    * Liefert die übersetzte Texte.
    *   Standartmäßig wird die Sprache aus window.currentUser.LanguageCode gelesen. Fallback ist 'de'.
    *
    * @method getText
    * @param {STRING} key - Schlüssel, mit dem nach zu übersetzendem Text gesucht wird.
    */
    getText: function (key) {
        var de = 'en';
        //var lang = window.currentUser ? window.currentUser.LanguageCode : de;
        var lang = window.languageShort ? window.languageShort : de;

        if (lang && i18n[lang] && i18n[lang][key]) {
            return i18n[lang][key];
        } else if (lang !== de && i18n[de] && i18n[de][key]) {
            return i18n[de][key];

        } else {
            return '"' + key + '" text for "' + lang + '" not found';
        }
    },


    /*
    Holt Sich das ensprechende Betriebssystem
    */
    getOS: function()  {
        if (navigator.userAgent.toLowerCase().match(/android/)) {
            return "android";
        } else if (navigator.userAgent.toLowerCase().match(/iphone/) || navigator.userAgent.toLowerCase().match(/ipad/)) {
            return "ios";
        } else if (navigator.userAgent.toLowerCase().match(/windows phone/)) {
            return "wp";
        }
    },
    
    // Erstellt einen eindeutig identifizierbaren Timeout
    ExplicitTimeout: function (fn, time, label) {
        this.id = null;
        this.cleared = true;

        this.clear = function () {
            console.log('TimeoutCleared: ', label, this.cleared)
            if (!this.cleared) {
                this.cleared = true;
                clearTimeout(this.id)
            }
        }

        this.restart = function () {
            this.clear();
            console.log('TEST: RESET ExplicitTimeout', label, time);
            if (_.isFunction(fn)) {
                this.id = setTimeout(fn, time);
                this.cleared = false;
            }
        }
    },

    getDB: function (success) {
        if (!window.indexedDB) {
		    alert("IndexedDB not supported");
        } else {
	        var request = window.indexedDB.open(CONSTS.DB_NAME, CONSTS.INDEXEDDB_VERSION);

	        request.onsuccess = function (event) {
	            console.log("success " + JSON.stringify(event));
	            if (_.isFunction(success)) {
                    success(this.result)
	            }
            };
	
	        request.onupgradeneeded = function (event) {
	            var db = this.result;
	            if (!db.objectStoreNames.contains(CONSTS.STORE_NAME)) {
	                store = db.createObjectStore(CONSTS.STORE_NAME);
	            }
	        };

            request.onerror = function(event) {
                alert("error "+JSON.stringify(event));
            };
	    }
    },

    Saveing:false,

    writeToDB: function (key, value, callback) {
        if (!Utils.Saveing) {
            Utils.Saveing = true;
            function write(db) {
                if (db) {
                    var trx = db.transaction([CONSTS.STORE_NAME], 'readwrite');
                    var store = trx.objectStore(CONSTS.STORE_NAME);
                    var request = store.put(value, key);

                    request.onsuccess = function (event) {
                        Utils.Saveing = false;
                        console.log('Eintrag ' + event.target.result + ' gespeichert');
                        if (_.isFunction(callback)) {
                            callback();
                        }
                    };

                    request.onerror = function (event) {
                        Utils.Saveing = false;
                        console.log('Fehler beim Schreiben in indexedDB: ' + JSON.stringify(event, null, 4));
                    };
                }
            }

            Utils.getDB(write);
        }
    },

    readFromDB: function (key, callback) {
        function read(db) {
            if (db) {
                var trx = db.transaction([CONSTS.STORE_NAME], 'readonly');
                var store = trx.objectStore(CONSTS.STORE_NAME);
                var request = store.get(key);

                request.onsuccess = function (event) {
                    if (_.isFunction(callback)) {
                        callback(request.result)
                    }
                };

                request.onerror = function (event) {
                    console.log('Fehler beim Schreiben in indexedDB: ' + JSON.stringify(event, null, 4));
                };
            }
        }

        Utils.getDB(read);
    },

    clearDB: function (callback) {
        window.indexedDB.deleteDatabase(CONSTS.DB_NAME);
    },

    generateStringHashCode: function(text) {
        var hash = 0;
        if (!text) return hash;
        for (i = 0; i < text.length; i++) {
            char = text.charCodeAt(i);
            hash = ((hash<<5)-hash)+char;
            hash = hash & hash; // Convert to 32bit integer
        }
        return hash;
    },

    generateStringHashCodeForFile: function(filename, callback) {
        $.get(filename, function(data) {
            var hashCode = Utils.generateStringHashCode(data);
            if (_.isFunction(callback)) {
                callback(hashCode);
            }
       });
    }
};