﻿/**
* Backbone Model für die Entität Devices
*
* @class DeviceRawElement.js
*/
function generateModelDeviceRawElement() {
    window.DeviceRawElement = Backbone.Model.extend({
        defaults: {
            DeviceId: CONSTS.GUID_DEFAULT,
            UserId: CONSTS.GUID_DEFAULT,
            ActivationDate: null,
            PhoneId: null,
            DevicePlatform: null,
            AppVersion: null,
            IsActive: null,

            /*
            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
            */

            UserElementAuth: {
                MandatorId: CONSTS.GUID_DEFAULT,
                OrgUnitId: CONSTS.GUID_DEFAULT,
                UserId: CONSTS.GUID_DEFAULT,
                PhoneId: null,
                LanguageCode: null
            }
        },
        localStorage: new Store("Devices"),
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.DevicesId;
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.Devices = Backbone.Collection.extend({
        model: window.DevicesRawElement,
        localStorage: new Store("Devices")
    });

    window.initDeviceData = function () {
        window.devices = new window.Devices();
        window.devices.fetch({ async: false });
    };
}