﻿/**
* Backbone Model für die Entität Feedback
*
* @class FeedbackRawElement.js
*/
function generateModelFeedbackRawElement() {
    window.FeedbackRawElement = Backbone.Model.extend({
        defaults: {
            FeedbackId: CONSTS.GUID_DEFAULT,
            SyncTime: CONSTS.DATE_DEFAULT,
            Company: null,
            CountryCode: null,
            Email: null,
            Fax: null,
            FeedbackSubject: null,
            FeedbackText: null,
            FeedbackTime: CONSTS.DATE_DEFAULT,
            Firstname: null,
            IsNewsletterEnabled: false,
            LanguageCode: null,
            Lastname: null,
            LiveId: null,
            Phone: null,
            PhoneId: null,
            UserId: CONSTS.GUID_DEFAULT,
            SysInf: null
        },
        localStorage: new Store("Feedbacks"),
        initialize: function () {
            this.bind("saved", this.syncWithServer, this);
        },
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.sendFeedback(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.FeedbackId;
            if (attributes.FeedbackTime) {
                attributes.FeedbackTime = moment(attributes.FeedbackTime).toDate();
            }
            if (attributes.SyncTime) {
                attributes.SyncTime = moment(attributes.SyncTime).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        },
    });

    window.Feedbacks = Backbone.Collection.extend({
        model: window.FeedbackRawElement,
        localStorage: new Store("Feedbacks")
    });

    window.initFeedbacksData = function () {
        window.feedbacks = new window.Feedbacks();
        window.feedbacks.fetch({ async: false });

        window.feedbacks.bind("add", function (obj) {
            obj.trigger("saved");
        });
    };
}