﻿/**
* Backbone Model für die Entität GenericEntity
*
* @class GenericEntityRawElement.js
*/
function generateModelGenericEntityRawElement() {
    window.GenericEntityRawElement = Backbone.Model.extend({
        defaults: {
            EntityId: CONSTS.GUID_DEFAULT,
            EntityName: null,
            ModuleId: CONSTS.GUID_DEFAULT,
            AttachmentsAllowed: false,
            IconCode: null,
            DisplayPropertyId: CONSTS.GUID_DEFAULT,
            SortPropertyId: CONSTS.GUID_DEFAULT,
            IsSystemEntity: false,
            EntityOrgId: CONSTS.GUID_DEFAULT,
            IsActive: false,
            IsMobileEntity: false,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        PersistToLocalStorageImmediately: true,
        localStorage: new Store("GenericEntities"),
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericEntities(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.EntityId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericEntities = Backbone.Collection.extend({
        model: window.GenericEntityRawElement,
        localStorage: new Store("GenericEntities")
    });

    window.persistGenericEntitiesData = function () {
        //var store = window.genericEntities.localStorage;

        //var obj = new window.GenericEntityRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;

        var myData = JSON.stringify(window.genericEntities.models);
        window.localStorage.setItem(window.genericEntities.localStorage.name, myData);
        myData = null;
    };

    window.initGenericEntitiesData = function () {
        window.genericEntities = new window.GenericEntities();
        window.genericEntities.fetch({ async: false });
    };
}