﻿/**
* Backbone Model für die Entität GenericProperty
*
* @class GenericPropertyRawElement.js
*/
function generateModelGenericPropertyRawElement() {
    window.GenericPropertyRawElement = Backbone.Model.extend({
        defaults: {
            PropertyId: CONSTS.GUID_DEFAULT,
            EntityId: CONSTS.GUID_DEFAULT,
            PropertyName: null,
            PropertyNameReport: null,
            DataType: null,
            Size: CONSTS.INTEGER_DEFAULT,
            Precision: CONSTS.INTEGER_DEFAULT,
            Scale: CONSTS.INTEGER_DEFAULT,
            LookupEntityId: CONSTS.GUID_DEFAULT,
            IsIndexed: false,
            GenericColumnName: null,
            AutoCompleteGroup: null,
            IsActive: false,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        localStorage: new Store("GenericProperties"),
        PersistToLocalStorageImmediately: true,
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericProperties(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.PropertyId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericProperties = Backbone.Collection.extend({
        model: window.GenericPropertyRawElement,
        localStorage: new Store("GenericProperties")
    });

    window.persistGenericPropertiesData = function () {
        //var store = window.genericProperties.localStorage;

        //var obj = new window.GenericPropertyRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;

        var myData = JSON.stringify(window.genericProperties.models);
        window.localStorage.setItem(window.genericProperties.localStorage.name, myData);
        myData = null;
    };

    window.initGenericPropertiesData = function () {
        window.genericProperties = new window.GenericProperties();
        window.genericProperties.fetch({ async: false });
    };
}