﻿/**
* Backbone Model für die Entität GenericValidation
*
* @class GenericValidationRawElement.js
*/
function generateModelGenericValidationRawElement() {
    window.GenericValidationRawElement = Backbone.Model.extend({
        defaults: {
            ValidationId: CONSTS.GUID_DEFAULT,
            ViewId: CONSTS.GUID_DEFAULT,
            ValidationType: null,
	        Value_01: null,
	        Value_02: null,
	        Value_03: null,
	        Value_04: null,
	        Value_05: null,
	        Value_06: null,
	        Comment: null,
            IsActive: false,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        localStorage: new Store("GenericValidation"),
        PersistToLocalStorageImmediately: true,
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericValidation(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.ValidationId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericValidation = Backbone.Collection.extend({
        model: window.GenericValidationRawElement,
        localStorage: new Store("GenericValidation")
    });

    window.persistGenericValidationsData = function () {
        //var store = window.genericValidation.localStorage;
        //var obj = new window.GenericValidationRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;

        var myData = JSON.stringify(window.genericValidation.models);
        window.localStorage.setItem(window.genericValidation.localStorage.name, myData);
        myData = null;
    };

    window.initGenericValidationData = function () {
        window.genericValidation = new window.GenericValidation();
        window.genericValidation.fetch({ async: false });
    };
}