﻿/**
* Backbone Model für die Entität GenericViewAction
*
* @class GenericViewActionRawElement.js
*/
function generateModelGenericViewActionRawElement() {
    window.GenericViewActionRawElement = Backbone.Model.extend({
        defaults: {
            ViewActionId: CONSTS.GUID_DEFAULT,
            ViewId: CONSTS.GUID_DEFAULT,
            ActionName: null,
            IconName: null,
            ActionType: null,
            MinRigthLevelId: null,
            CommandName: null,
            Event: null,
            Selector: null,
            SortPosition: CONSTS.INT_DEFAULT,
            RedirectViewId: null,
            RedirectHistory: null,
            Param_01: null,
            Param_02: null,
            Param_03: null,
            Param_04: null,
            Param_05: null,
            RefActionId: null,
            IsVisible: null,
            IsActive: false,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        localStorage: new Store("GenericViewActions"),
        PersistToLocalStorageImmediately: true,
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericViewActions(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.ViewActionId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericViewActions = Backbone.Collection.extend({
        model: window.GenericViewActionRawElement,
        localStorage: new Store("GenericViewActions")
    });

    window.persistGenericViewActionsData = function () {
        //var store = window.genericViewActions.localStorage;
     
        //var obj = new window.GenericViewActionRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;

        var myData = JSON.stringify(window.genericViewActions.models);
        window.localStorage.setItem(window.genericViewActions.localStorage.name, myData);
        myData = null;
    };


    window.initGenericViewActionsData = function () {
        window.genericViewActions = new window.GenericViewActions();
        window.genericViewActions.fetch({ async: false });
    };
}