﻿/**
* Backbone Model für die Entität GenericViewAction
*
* @class GenericViewFieldRawElement.js
*/
function generateModelGenericViewFieldRawElement() {
    window.GenericViewFieldRawElement = Backbone.Model.extend({
        defaults: {
            FieldId: CONSTS.GUID_DEFAULT,
            ViewId: CONSTS.GUID_DEFAULT,
            PropertyId: CONSTS.GUID_DEFAULT,
            SortPosition: null,
            IsReadonly: false,
            DefaultValue: null,
            DefaultValueLookupPropertyId: CONSTS.GUID_DEFAULT,
            IsLogicalKey: false,
            IsActive: false,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        localStorage: new Store("GenericViewFields"),
        PersistToLocalStorageImmediately: true,
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericViewFields(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.FieldId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericViewFields = Backbone.Collection.extend({
        model: window.GenericViewFieldRawElement,
        localStorage: new Store("GenericViewFields")
    });

    window.persistGenericViewFieldsData = function () {    

        //var store = window.genericViewFields.localStorage;

        //var obj = new window.GenericViewFieldRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;

        var myData = JSON.stringify(window.genericViewFields.models);
        window.localStorage.setItem(window.genericViewFields.localStorage.name, myData);
        myData = null;
    };

    window.initGenericViewFieldsData = function () {
        window.genericViewFields = new window.GenericViewFields();
        window.genericViewFields.fetch({ async: false });
    };
}