﻿/**
* Backbone Model für die Entität GenericViewFilter
*
* @class GenericViewFilterRawElement.js
*/
function generateModelGenericViewFilterRawElement() {
    window.GenericViewFilterRawElement = Backbone.Model.extend({
        defaults: {
            FilterId: CONSTS.GUID_DEFAULT,
            ViewId: CONSTS.GUID_DEFAULT,
            PropertyId: CONSTS.GUID_DEFAULT,
            SortPosition: 0,
            IsNegated: false,
            Operator: null,
            DefaultValue: null,
            IsVisible: false,
            IsReadonly: false,
            IsActive: false,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        localStorage: new Store("GenericViewFilters"),
        PersistToLocalStorageImmediately: true,
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericViewFilters(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.FilterId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericViewFilters = Backbone.Collection.extend({
        model: window.GenericViewFilterRawElement,
        localStorage: new Store("GenericViewFilters")
    });

    window.persistGenericViewFiltersData = function () {
        //var store = window.genericViewFilters.localStorage;
        //var obj = new window.GenericViewFilterRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;

        var myData = JSON.stringify(window.genericViewFilters.models);
        window.localStorage.setItem(window.genericViewFilters.localStorage.name, myData);
        myData = null;
    };

    window.initGenericViewFiltersData = function () {
        window.genericViewFilters = new window.GenericViewFilters();
        window.genericViewFilters.fetch({ async: false });
    };
}