﻿/**
* Backbone Model für die Entität GenericViewRawElement
*
* @class GenericViewRawElement.js
*/
function generateModelGenericViewRawElement() {
    window.GenericViewRawElement = Backbone.Model.extend({
        defaults: {
            ViewId: CONSTS.GUID_DEFAULT,
            EntityId: CONSTS.GUID_DEFAULT,
            ViewName: null,
            ViewType: null,
            IsTopLevel: false,
            IsMobile: false,
            IconCode: null,
            IsDefault: false,
            IsActive: false,
            Param01: null,

            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
        },
        localStorage: new Store("GenericViews"),
        PersistToLocalStorageImmediately: true,
        syncWithServer: function () {
            if (this.toBeSynchronized()) {
                //SyncController.synchronize();
                SyncController.synchronizeGenericViews(true);
            }
        },
        toBeSynchronized: function () {
            return (this.attributes.SyncTime == null || this.attributes.SyncTime.getTime() === CONSTS.DATE_DEFAULT.getTime());
        },
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.ViewId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.GenericViews = Backbone.Collection.extend({
        model: window.GenericViewRawElement,
        localStorage: new Store("GenericViews")
    });

   

    window.persistGenericViewsData = function () {
        //var store = window.genericViews.localStorage;

        //var obj = new window.GenericViewRawElement();
        //var myData = JSON.stringify(obj.localStorage.data);
        //window.localStorage.setItem(store.name, myData);
        //myData = null;
        //obj = null;
    	
        var myData = JSON.stringify(window.genericViews.models);
      
//        ///TEST TEST TEST
//        var test = myData;
//        var find = '},';
//        var re = new RegExp(find, 'g');
//        test = test.replace(re, '},\n\n');
//        alert(test);
//        ///TEST-ENDE TEST-ENDE TEST-ENDE 
        
        window.localStorage.setItem(window.genericViews.localStorage.name, myData);
        myData = null;
    };


    window.initGenericViewsData = function () {
        window.genericViews = new window.GenericViews();
        window.genericViews.fetch({ async: false });
    };
}