﻿/**
* Backbone Model für die Entität News
*
* @class NewsRawElement.js
*/
function generateModelNewsRawElement() {
    window.NewsRawElement = Backbone.Model.extend({
        defaults: {
            NewsId: CONSTS.GUID_DEFAULT,
            CreatedBy: CONSTS.GUID_DEFAULT,
            CreatedDate: CONSTS.DATE_DEFAULT,
            ModifiedBy: CONSTS.GUID_DEFAULT,
            ModifiedDate: CONSTS.DATE_DEFAULT,
            TriggerStamp: CONSTS.DATE_DEFAULT,
            EndDate: CONSTS.DATE_DEFAULT,
            HyperlinkTarget: null,
            HyperlinkText: null,
            HyperlinkUrl: null,
            LanguageCode: null,
            NewsSubject: null,
            NewsText: null,
            ShowForAnonymous: false,
            ShowForMembers: false,
            ShowInMobileApp: false,
            ShowInWebsite: false,
            StartDate: CONSTS.DATE_DEFAULT
        },
        localStorage: new Store("News"),
        set: function (attributes, options) {
            if (!this.id) this.id = attributes.NewsId;
            if (attributes.CreatedDate) {
                attributes.CreatedDate = moment(attributes.CreatedDate).toDate();
            }
            if (attributes.ModifiedDate) {
                attributes.ModifiedDate = moment(attributes.ModifiedDate).toDate();
            }
            if (attributes.TriggerStamp) {
                attributes.TriggerStamp = moment(attributes.TriggerStamp).toDate();
            }
            if (attributes.EndDate) {
                attributes.EndDate = moment(attributes.EndDate).toDate();
            }
            if (attributes.StartDate) {
                attributes.StartDate = moment(attributes.StartDate).toDate();
            }
            Backbone.Model.prototype.set.call(this, attributes, options);
        },

        toJSON: function () {
            var json = Backbone.Model.prototype.toJSON.call(this);
            return _.extend(json);
        }
    });

    window.News = Backbone.Collection.extend({
        model: window.NewsRawElement,
        localStorage: new Store("News")
    });

    window.initNewsData = function () {
        window.news = new window.News();
        window.news.fetch({ async: false });
    };
}