﻿/**
* Spezielle Infos View für den Kunden BOSO
*
* @class BosoInfosView.js
*/
window.BosoInfosView = Backbone.View.extend({
    render: function (eventName) {
        var that = this;
        ActionHelper.CurrentView = this;
        require(["lib/text!js/view/html/BosoInfosView.html"], function (template, template2) {
            $(that.el).html(_.template(template)());
            $('#BosoInfosView').trigger('create');
            that.replaceLanguageStrings($(that.el));

            $('#lnkDatenschutz').text(Utils.getText('DATENSCHUTZ'));
        });
        return this;
    },

    replaceLanguageStrings: function (htmlTemplate) {
        var version = Boso.VERSION;
        var checksum = '19285370';
        var datum = '2020-06-18';
        datum = moment(datum, CONSTS.DATE_PERSIST_FORMAT).format(FormatHelper.get_DATE_FORMAT());
        	
        htmlTemplate.find('#bosoVersionId').html(Utils.getText('VERSION') + ': ' + version + ' - ' + datum);
        htmlTemplate.find('#bosoCrc32').html(Utils.getText('CHECKSUMME') + ': ' + checksum);

        var language = !!window.languageShort ? window.languageShort.toLowerCase() : fallbackLanguage;
        var shortManualLink = 'https://www.boso.de/fileadmin/medien/download/Kurzanleitung-medicus-system_DE.pdf';
        if (language !== 'de') {
            shortManualLink = 'https://www.boso.de/fileadmin/medien/download/Shortmanual-medicus-system_GB.pdf';
        }

        htmlTemplate.find('#lnkKurzanleitung')
        .html(Utils.getText('KURZANLEITUNG'))
        .attr('onclick', 'window.open(\'' + shortManualLink + '\', \'_system\')')
        
        htmlTemplate.find('#lnkDatenschutz').html(Utils.getText('DATENSCHUTZ'));
    },
});