﻿/**
* Implementiert eine Ansicht um bestimmte Einstellungen, wie das aktivieren und deaktiveiren der Synchronisation, vorzunehmen
*
* @class ConfigurationFormView.js
*/
window.ConfigurationFormView = Backbone.View.extend({

    events: {
        "click .basicButton": "basicButton",
        //"click #activate": "activate",
        "click .personalButton": "personalButton",
        "change #SynchronizeData": "synchronizeDataSlider",
        "click #syncData": "syncData",
        "click #syncConfiguration": "syncConfiguration",
        "click #dataRetention": "dataRetention",
        "click #getAllData": "getAllData",
        "click #deleteAllData": "deleteAllData",
        "click #updateCacheManifest": "updateCacheManifest",
        //"click #register_btn": "register"

    },


    updateCacheManifest: function () {
        var appCache = window.applicationCache;
        var status;
        switch (appCache.status) {
            case appCache.UNCACHED: // UNCACHED == 0
                status = 'UNCACHED';
                break;
            case appCache.IDLE: // IDLE == 1
                status = 'IDLE';
                break;
            case appCache.CHECKING: // CHECKING == 2
                status = 'CHECKING';
                break;
            case appCache.DOWNLOADING: // DOWNLOADING == 3
                status = 'DOWNLOADING';
                break;
            case appCache.UPDATEREADY:  // UPDATEREADY == 4
                status = 'UPDATEREADY';
                break;
            case appCache.OBSOLETE: // OBSOLETE == 5
                status = 'OBSOLETE';
                break;
            default:
                status = 'UKNOWN CACHE STATUS';
                break;
        };


        alert(status);

        if (appCache.status != window.applicationCache.UNCACHED) {
            appCache.update(); // Attempt to update the user's cache.
        }
        //if (appCache.status == window.applicationCache.UPDATEREADY) {
        //    appCache.swapCache();  // The fetch was successful, swap in the new cache.
        //}

    },

    basicButton: function () {
        $('.basicView').show();
        $('.personalView').hide();
    },

    personalButton: function () {
        $('.basicView').hide();
        $('.personalView').show();
    },

    synchronizeDataSlider: function (event) {
        if ($(event.target).val() == 'on') {
            window.localStorage.setItem('synchronizeData', true);
            setTimeout(SyncController.synchronize(), 0);
        } else {
            window.localStorage.setItem('synchronizeData', false);
        }
    },

    syncData: function () {
        setTimeout(SyncController.syncData(true), 0);
    },

    syncConfiguration: function () {
        setTimeout(SyncController.syncConfiguration(true), 0);
    },

    dataRetention: function () {
        SyncController.dataRetention();
    },

    deleteAllData: function () {
        $('#loader_page').show();
        $.mobile.loading('show', {
            text: 'Lösche Daten',
            textVisible: true,
            theme: 'a',
        });
        //SyncController.deleteData();
        SyncController.resetApp();
    },

    getAllData: function () {
        $('#loader_page').show();
        $.mobile.loading('show', {
            text: 'Setze Daten zurück',
            textVisible: true,
            theme: 'a',
        });
        SyncController.resetDeviceEntities();
    },

    register: function () {
        if (localStorage.getItem("moduleBundle") != null && localStorage.getItem("moduleBundle") != '') {
            window.open(
              'https://mfapp.mobile-function.com/Webapp/index.html#register/bundle/' + localStorage.getItem("moduleBundle"),
              '_blank' // <- This is what makes it open in a new window.
            );
        } else {
            window.open(
                'https://mfapp.mobile-function.com/Webapp/index.html#register',
                '_blank' // <- This is what makes it open in a new window.
            );
        }
    },

    activate: function () {
        $('#loader_page').show();
        $.mobile.loading('show', {
            text: 'Aktiviere Gerät',
            textVisible: true,
            theme: 'a',
        });

        var email = $('#Login_Email').val();
        var password = $('#Login_Password').val();

        SyncController.validateDeviceInitial(email, password);
    },

    render: function () {
        var that = this;
        ActionHelper.CurrentView = this;

        require(["lib/text!js/view/html/ConfigurationFormView.html"], function (template) {
            var html = $(_.template(template)());

            $('#title').text('Einstellungen');

            if (window.currentDevice.StatusId == 2) {
                html.find('#tabBar').hide();
                html.find('#configForm').hide();
            }

            if (GlobalSettings.DisableDeleteButtonsAtConfig() == true) {//Nur Lödi. 
                var n = html.find('#configForm #deleteAllData');

                if (n != undefined && n.length > 0)
                    ($(html.find('#configForm #syncDataSlider')[0])).remove();

                if (n != undefined && n.length > 0)
                    if (window.location.hostname != undefined && window.location.hostname.indexOf("localhost") != 0)
                        ($(html.find('#configForm #deleteAllData')[0])).remove();

                var n = html.find('#configForm #dataRetention');
                if (n != undefined && n.length > 0)
                    ($(html.find('#configForm #dataRetention')[0])).remove();

                var n = html.find('#configForm #getAllData');
                if (n != undefined && n.length > 0)
                    ($(html.find('#configForm #getAllData')[0])).remove();

            }

            if (window.userRawElementEntries.length != 0) {
                html.find('#salutation').val(window.currentUser.SalutationId);
                html.find('#Firstname').val(window.currentUser.Firstname);
                html.find('#Lastname').val(window.currentUser.Lastname);
                html.find('#EMail').val(window.currentUser.Email);
                html.find('#Activationkey').val(window.currentUser.ActivationKey);
                html.find('#RetentionOrderManagement').val(window.currentUser.RetentionOrderManagement);
                html.find('#RetentionOrderManagement').attr('readonly', true);
                html.find('#RetentionLogbook').val(window.currentUser.RetentionLogbook);
                html.find('#RetentionLogbook').attr('readonly', true);
                html.find('#RetentionTimeRecordings').val(window.currentUser.RetentionTimeRecordings);
                html.find('#RetentionTimeRecordings').attr('readonly', true);
                html.find('#RetentionReceipts').val(window.currentUser.RetentionReceipts);
                html.find('#RetentionReceipts').attr('readonly', true);
                if (window.localStorage.getItem('synchronizeData') && window.localStorage.getItem('synchronizeData').bool() == true) {
                    html.find('#SynchronizeData').val('on');
                }
            }


            $(that.el).html(html);
            that.delegateEvents();
            $(that.el).find('#homeButton').attr('src', GlobalSettings.CustomIcon());
            $('#ConfigurationFormView').trigger('create');
        });

        return this;
    }
});