﻿/**
* Implementiert eine Ansicht zum Anzeigen von Infos über die App - auf welchem System es läuft, auif welcher Platform es läuft, welche version es ist usw….
*
* @class InfosView.js
*/
window.InfosView = Backbone.View.extend({
    events: {
        "click #aboutButton": "aboutButton",
        //"click #updateButton": "updateButton",
        //"click #newsButton": "newsButton",
        "click #feedbackButton": "feedbackButton",
        "click #sendFeedbackButton": "sendFeedbackButton",
        "click #sendDataBtn": "sendDataBtn",
        //"click .device": "deviceClicked",
    },

    MailBaseUrl: 'https://mfapp.mobile-function.com',

    replaceLanguageStrings: function (htmlTemplate) {
        htmlTemplate.find('#feedbackButton').html(Utils.getText('FEEDBACK'));
        htmlTemplate.find('#aboutButton').html(Utils.getText('UEBER'));

        //Feedback Formular
        htmlTemplate.find('label[for="FeedbackSubject"]').html(Utils.getText('THEMA'));
        htmlTemplate.find('label[for="FeedbackText"]').html(Utils.getText('NACHRICHT'));
        htmlTemplate.find('label[for="Firstname"]').html(Utils.getText('VORNAME'));
        htmlTemplate.find('label[for="Lastname"]').html(Utils.getText('NACHNAME'));
        htmlTemplate.find('label[for="Company"]').html(Utils.getText('FIRMA'));
        htmlTemplate.find('label[for="Phone"]').html(Utils.getText('HANDYNUMMER'));
        htmlTemplate.find('label[for="FeedbackEmail"]').html(Utils.getText('EMAIL'));

        htmlTemplate.find('input[name="Firstname"]').attr('placeholder', Utils.getText('VORNAME'));
        htmlTemplate.find('input[name="Lastname"]').attr('placeholder', Utils.getText('NACHNAME'));
        htmlTemplate.find('input[name="Company"]').attr('placeholder', Utils.getText('FIRMA'));
        htmlTemplate.find('input[name="Phone"]').attr('placeholder', Utils.getText('HANDYNUMMER'));

        htmlTemplate.find('#sendFeedbackButton').html(Utils.getText('FEEDBACK_SENDEN'));
        htmlTemplate.find('#sendDataBtn ').attr('value', Utils.getText('DATEN_SENDEN_SUPPORT'));
    },

    deviceClicked: function (el) {
        var address = $(el.currentTarget).text();
        console.log('INFO: device Clicked ' + address);
        localStorage.setItem('bt-device', address);
        $('#selectedDevice').text(address);
    },
    //23434100-1fe4-1eff-80cb-00ff78297d8b
    //23434101-1fe4-1eff-80cb-00ff78297d8b

    aboutButton: function () {
        $(this.el).find("#aboutContent").show();
        //$(this.el).find("#newsContent").hide();
        $(this.el).find("#feedbackContent").hide();
    },

    getSystemInformation: function() {
        var systemInformation = new Object();

        //devicePlatform
        if (window.devicePlatform === 'BROWSER') {
            systemInformation.Platform = window.devicePlatform + ' ' + window.deviceId;
        }
        else {
            systemInformation.Platform = window.devicePlatform + ' ' + window.osVersion + ' ' + window.deviceId;
        }

        // system
        var system = window.location.hostname;
        if (window.location.hostname != null) {

            if (window.location.hostname.indexOf("localhost") != -1) {
                system = "localhost";
            } else if (window.location.hostname.indexOf("mfappentw") != -1) {
                system = "Entwicklung";
            }
            else if (window.location.hostname.indexOf("mfapptest") != -1) {
                system = "Test";
            }
            else if (window.location.hostname.indexOf("mfapp") != -1) {
                system = "Produktion";
            }
        }
        systemInformation.System = system;

        // devicePlatform
        if (window.devicePlatform === 'BROWSER') {
            systemInformation.Device = window.browserVersion;
        }
        else {
            systemInformation.Device = window.deviceModel;
        }
        
        systemInformation.AppVersion = CONSTS.APP_VERSION;
        systemInformation.Language = window.language;

        return systemInformation;
    },

    sendDataBtn: function () {
        $('#sendDataBtn').attr('disabled', true);

        var dataList = [
          'Devices',
          'GenericData',
          'GenericEntities',
          'GenericProperties',
          'GenericValidation',
          'GenericViewActions',
          'GenericViewFields',
          'GenericViewFilters',
          'GenericViews',
          'UserRawElementEntries',
          'currentDevice',
          'currentUser',
          'customer',
          'deviceId',
          'moduleBundle'
        ];

//        dataList = dataList.concat(gdList).concat(dataList2);

        var systemInformation = this.getSystemInformation();
        var systemInformationMsg = 'Systeminformationen: <br />';
        systemInformationMsg += 'Version: ' + systemInformation.AppVersion + '<br />';
        systemInformationMsg += 'Platform: ' + systemInformation.Platform + '<br />';
        systemInformationMsg += 'System: ' + systemInformation.System + '<br />';
        systemInformationMsg += 'Device: ' + systemInformation.Device + '<br />';
        systemInformationMsg += 'Language: ' + systemInformation.Language + '<br />';
        //systemInformationMsg += '##deploydate##';

        var body = 'Daten siehe Anhang <br /><br />';
        body += systemInformationMsg;

        var fileName = 'localStorageJSON';
        var fileType = 'json';
        var fileContent = '';

        //ADD VERSION NUMBER DUMMY VERSIONNUMBER = 1 AND HAS TO BE SET MANUALLY
        fileContent += 'OfflineConfigVersion,1';

        fileContent += '\n';

        for (var i = 0; i < dataList.length; i++) {
            var item = dataList[i];
            var json = localStorage.getItem(item);
            if (json == undefined || json == 'undefined' || json == '') {
                json = null;
            }

            //create CSV
            fileContent += item + ',';
            fileContent += json;

            if (i < dataList.length - 1) {
                fileContent += '\n';
            }

        }

        var subject = "Supportanfrage: " + window.currentUser.Email;
        this.sendMail('anton.terre@mobile-function.com', subject, body, fileName, fileType, fileContent);   

        ActionHelper.sendRequestMail(window.currentUser.Email, 'mfapp@mobile-function.com', null, null, subject, "Find data attached", null, null, null, null, null, null, null, null, null, 'Sollen Ihre Daten übertragen werden? \nDies kann einige Zeit in Anspruch nehmen. \nSie können währenddessen weiterarbeiten, lassen Sie die App aber geöffnet..', body, 'localStorageJSON.csv')
    },

    sendMail: function (to, subject, body, filename, fileType, fileContent) {
        self = this;
        alert('Ihre Daten werden nun übertragen. Dies kann einige Zeit in Anspruch nehmen. \nSie können währenddessen weiterarbeiten, lassen Sie die App aber geöffnet..');

        MailObject = {
            To: to,
            CC: '',
            Subject: subject,
            Body: body,
            FileName: filename,
            FileType: fileType,
            FileContent: fileContent
        };

        var baseUrl = self.MailBaseUrl;
        $.ajax({
            url: baseUrl + '/action/api/emails/SendEmail',
            data: JSON.stringify(MailObject),
            type: 'post',
            contentType: "application/json; charset=utf-8",
            timeout: CONSTS.TIMEOUT_SUPPORT_DATA,
            success: function (AjaxReturnObject) {
                if (AjaxReturnObject.ReturnType === RETURN_TYPE.SUCCESS || AjaxReturnObject.ReturnType === RETURN_TYPE.INFO || AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {

                    alert('Coming soon...', null, 'Coming soon...', 'Coming soon...');

                    // show warning, if occured
                    if (AjaxReturnObject.ReturnType === RETURN_TYPE.WARNING) {
                        alert(AjaxReturnObject.ReturnMsg, null, 'Erfolg', 'Ok');
                    }
                }
                else {
                    alert('Ihre Daten wurden erfogleich an den Support übermittelt!');
                    $('#sendDataBtn').removeAttr('disabled');
                }
            },
            error: function (response) {
                if (response.status == 500) {
                    alert('Leider konnte Ihre Anfrage nicht übertragen werden. Bitte nehmen Sie erneut Kontakt mit dem Support auf!');
                    $('#sendDataBtn').removeAttr('disabled');
                } else if (response.statusText != 'timeout') {
                    //nix tun
                }
                else {
                    alert('Time Out: Bitte überprüfen Sie ihre Internetverbindung.');
                    $('#sendDataBtn').removeAttr('disabled');
                }
            }
        });
    },


    /*newsButton: function () {
        $(this.el).find("#aboutContent").hide();
        //$(this.el).find("#newsContent").show();
        $(this.el).find("#feedbackContent").hide();
    },*/
    feedbackButton: function () {
        $(this.el).find("#aboutContent").hide();
        //$(this.el).find("#newsContent").hide();
        $(this.el).find("#feedbackContent").show();
    },


    sendFeedbackButton: function () {
        if (!this.checkValues()) {
            return;
        }
        var itemId = window.generateGuid();
        var feedbackRawElement = new window.FeedbackRawElement();
        feedbackRawElement.attributes.FeedbackTime = moment().toDate();
        feedbackRawElement.attributes.IsNewsletterEnabled = false;

        if (window.currentUser.ActivationDate != CONSTS.DATE_DEFAULT) {
            feedbackRawElement.attributes.Fax = window.currentUser.Fax;
            feedbackRawElement.attributes.CountryCode = window.currentUser.CountryCode;
            feedbackRawElement.attributes.LanguageCode = window.currentUser.LanguageCode;
        }

        feedbackRawElement.attributes.FeedbackSubject = $("#FeedbackSubject").val();
        feedbackRawElement.attributes.FeedbackText = $("#FeedbackText").val();
        feedbackRawElement.attributes.Firstname = $("#Firstname").val();
        feedbackRawElement.attributes.Lastname = $("#Lastname").val();
        feedbackRawElement.attributes.Company = $("#Company").val();
        feedbackRawElement.attributes.Phone = $("#Phone").val();
        feedbackRawElement.attributes.Email = $("#FeedbackEmail").val();
        feedbackRawElement.attributes.SyncTime = CONSTS.DATE_DEFAULT;
        feedbackRawElement.attributes.SysInf = this.getSystemInformation();
        feedbackRawElement.set({ 'id': itemId });
        feedbackRawElement.save();
        window.feedbacks.add(feedbackRawElement);
        //setTimeout(SyncController.sendFeedback(true), 0);
        $("#FeedbackSubject").val("");
        $("#FeedbackText").val("");
        $("#Firstname").val("");
        $("#Lastname").val("");
        $("#Company").val("");
        $("#Phone").val("");
        $("#FeedbackEmail").val("");

        if (window.currentUser) {
            $('#Firstname').val(window.currentUser.Firstname);
            $('#Lastname').val(window.currentUser.Lastname);
            $('#Company').val(window.currentUser.Company);
            $('#Phone').val(window.currentUser.Phone);
            $('#FeedbackEmail').val(window.currentUser.Email);
        }

        //1155: Feedback wurde gesendet.
        alert('Feedback wurde gesendet');
    },
    render: function (eventName) {
        var that = this;
        ActionHelper.CurrentView = this;

        require(["lib/text!js/view/html/InfosView.html"], function (template, template2) {
            $(that.el).html(_.template(template)());
            $(that.el).find('#homeButton').attr('src', GlobalSettings.CustomIcon());
            //Doppelpunkte den Labels hinzufügen
            $(that.el).find('label').each(function () {
                $(this).append(':');
            });

            that.replaceLanguageStrings($(that.el));

            $(that.el).find('#versionId').html('Version: ' + CONSTS.APP_VERSION);
            if (navigator != null && typeof device != "undefined") {
                $(that.el).find('#homepageId').click(function () {
                    window.InAppBrowserOpen = window.open("https://www.mobile-function.com", '_blank', 'location=yes');
                    return false; // cancel hyperlink default action => stay in current view
                });
                //$(that.el).find('#homepageId').attr('href', '#');
            }

            if (window.devicePlatform === 'BROWSER') {
                $(that.el).find('#platform').html("Platform: " + window.devicePlatform + ' ' + window.deviceId);
            }
            else {
                $(that.el).find('#platform').html("Platform: " + window.devicePlatform + ' ' + window.osVersion + ' ' + window.deviceId);
            }

            var system = window.location.hostname;
            if (window.location.hostname != null) {

                if (window.location.hostname.indexOf("localhost") != -1) {
                    system = "localhost";
                } else if (window.location.hostname.indexOf("mfappentw") != -1) {
                    system = "Entwicklung";
                }
                else if (window.location.hostname.indexOf("mfapptest") != -1) {
                    system = "Test";
                }
                else if (window.location.hostname.indexOf("mfapp") != -1) {
                    system = "Produktion";
                }
            }

            if (window.devicePlatform === 'BROWSER') {
                $(that.el).find('#deviceModel').html("Device: " + window.browserVersion);
            }
            else {
                $(that.el).find('#deviceModel').html("Device: " + window.deviceModel);
            }

            $(that.el).find('#system').html("System: " + system);
            $(that.el).find('#deviceLanguage').html("Language: " + window.language);

            if (window.currentUser.StatusId == RECORD_STATUS.ACTIVE) {
                $(that.el).find('#Firstname').val(window.currentUser.Firstname);
                $(that.el).find('#Lastname').val(window.currentUser.Lastname);
                $(that.el).find('#Company').val(window.currentUser.Company);
                $(that.el).find('#Phone').val(window.currentUser.Phone);
                $(that.el).find('#FeedbackEmail').val(window.currentUser.Email);
            }

            that.setPflichtfelderLabel($(that.el));
            $('#InfosView').trigger('create');
        });
        return this;
    },
    setPflichtfelderLabel: function (html) {
        html.find('label').each(function () {
            $(this).text($(this).text().replace(' *', ''));
        });
        //Pflichfelder
        html.find('label[for="FeedbackSubject"]').append(" *");
        html.find('label[for="FeedbackText"]').append(" *");
        html.find('label[for="FeedbackEmail"]').append(" *");
    },
    checkValues: function () {
        var retValue = true;

        if ($('#FeedbackSubject').val() == "") {
            //1156: Kein Thema angegeben!/ No Subject Specified!
            alert('Kein Thema angegeben!');
            retValue = false;
        }
        if ($('#FeedbackText').val() == "") {
            //1157: Keine Nachricht angegeben!/ No Message Specified!
            alert('Keine Nachricht angegeben!');
            retValue = false;
        }
        if ($('#FeedbackEmail').val() == "") {
            //1157: Keine E-Mail Adresse angegeben!/ No E-Mail Adress Specified!
            alert('Keine E-Mail Adresse angegeben!');
            retValue = false;
        }
        return retValue;
    },
});