﻿/**
* Generischer View zum Erzeugen eines Detailformulares
*
* @class DetailView.js
*/
window.DetailView = Backbone.View.extend({
    events: {
    },

    buildView: function (that) {
        var genericView = that.options.view;
        var fieldContainer = $(that.el).find('#detailViewFieldContainer');

        // if (genericView.attributes.ViewName != null || genericView.attributes.ViewName != '') {
        //     $('#title').text(genericView.attributes.ViewName);
        // }

        var genericFieldsSorted = GenericHelper.getViewFields(genericView);

        //GENERIC FIELDS
        var OnChangeActions = [];
        _.each(genericFieldsSorted, function (field) {
            var genericProperty = window.genericProperties.get(field.attributes.PropertyId);

            ViewBuilder.createField(that, field, ActionHelper.CurrentView.Type);
            if (field.attributes.OnChangeJS != null && field.attributes.OnChangeJS != '') {
                OnChangeActions.push(field.attributes.OnChangeJS);
            }
        }, this);
        _.each(OnChangeActions, function (action) {
            eval(action);
        });
        OnChangeActions.length = 0;
        OnChangeActions = null;

        //GENERIC ACTIONS
        var viewActions = GenericHelper.getViewActions(genericView);

        _.each(viewActions, function (viewAction) {
            ActionHelper.prepareAction(genericView, viewAction);
        });

        //ONLOAD ACTIONS
        var onloadActions = _.filter(viewActions, function (action) {
            return action.attributes.ActionType == 'onload';
        });

        _.each(onloadActions, function (onloadAction) {
            var Command = 'ActionHelper.' + onloadAction.attributes.CommandName + ActionHelper.prepareParams(onloadAction);
            eval(Command);
        });

    },

    render: function (eventName) {
        var that = this;
        ActionHelper.CurrentView = this;
        ActionHelper.CurrentView.Type = this.options.view.attributes.ViewType;

        if (this.options.view.attributes.Param01 != "online") {
            if (this.options.modelId != "null") {
                this.model = window.genericData.get(this.options.modelId);
            }
            if (this.options.refModelId != "null") {
                this.refModel = _.first(_.filter(window.genericData.models, function (model) {
                    return model.attributes.ObjectId == that.options.refModelId;
                }));
            }
            if (this.model != undefined) {
                this.options.refNavId = this.model.attributes.ObjectId;
            }          
        }
        else {
            if (this.options.modelId != "null") {
                SyncController.searchDataByDataID(this.options.modelId, ActionHelper.CurrentView.options.view.id, ActionHelper.CurrentView.options.view.attributes.EntityId, function () {
                    return;
                    //SyncController.searchDone()
                });
                //SyncController.TmpData[0].attributes.DataId
                var newModel = _.first(_.filter(SyncController.TmpData, function (TmpData) {
                    return TmpData.attributes.DataId == that.options.modelId;
                }));

                if (newModel != undefined) {
                    this.model = newModel;
                    this.options.refNavId = this.model.attributes.ObjectId;
                }

            }
        }

        require(["lib/text!js/view/generic/html/DetailView.html"], function (template) {
            $(that.el).html(_.template(template)());

            $(that.el).find('#homeButton').attr('src', GlobalSettings.CustomIcon());

            that.buildView(that);

            $('#Detail').trigger('create');
            bodyMinHeightFix($('#DetailView'));
            ActionHelper.globalOnload();
        });

        this.delegateEvents();
        return this;
    },
});