﻿/**
* Generischer View zum Erzeugen eines Bearbeitungsformulares
*
* @class EditView.js
*/
window.EditView = Backbone.View.extend({
    events: {
    },

    buildView: function (that) {

        if (ActionHelper.tmpModel != undefined && ActionHelper.tmpModel.attributes.EntityId == this.options.view.attributes.EntityId) {
            that.model = that.model = ActionHelper.tmpModel;
            ActionHelper.CurrentView.model = ActionHelper.tmpModel;
            ActionHelper.CurrentView.options.modelId = ActionHelper.CurrentView.model.attributes.DataId;
            ActionHelper.tmpModel = undefined;
        }

        var genericView = that.options.view;
        var genericFieldsSorted = GenericHelper.getViewFields(genericView);

        //GENERIC FIELDS
        var OnChangeActions = [];
        _.each(genericFieldsSorted, function (field) {
            ViewBuilder.createField(that, field, that.Type);
            if (field.attributes.OnChangeJS != null && field.attributes.OnChangeJS != '') {
                OnChangeActions.push(field.attributes.OnChangeJS);
            }
        }, this);
        _.each(OnChangeActions, function (action) {
            eval(action);
        });
        OnChangeActions.length = 0;
        OnChangeActions = null;

        //GENERIC ACTIONS
        var viewActions = GenericHelper.getViewActions(genericView);

        _.each(viewActions, function (viewAction) {
            ActionHelper.prepareAction(genericView, viewAction);
        });

        //ONLOAD ACTIONS
        var onloadActions = _.filter(viewActions, function (action) {
            return action.attributes.ActionType == 'onload';
        });

        _.each(onloadActions, function (onloadAction) {
            var Command = 'ActionHelper.' + onloadAction.attributes.CommandName + ActionHelper.prepareParams(onloadAction);
            eval(Command);
        });
        
    },

    render: function (eventName) {
        var that = this;
        ActionHelper.CurrentView = this;
        ActionHelper.CurrentView.Type = this.options.view.attributes.ViewType;
        if (this.options.modelId != "null") {
            this.model = window.genericData.get(this.options.modelId);
                
            ActionHelper.Models = []
            ActionHelper.Models.length = 0;
            ActionHelper.Models.push(this.options.modelId);
        }
        if (this.model!=undefined)
            this.options.refNavId = this.model.attributes.ObjectId;
        require(["lib/text!js/view/generic/html/EditView.html"], function (template) {
            $(that.el).html(_.template(template)());

            $(that.el).find('#homeButton').attr('src', GlobalSettings.CustomIcon());

            that.buildView(that);
            $('#Edit').trigger('create');
            ActionHelper.globalOnload();
        });

        this.delegateEvents();
        return this;
    },
});