﻿/**
* Generischer View zum Erzeugen eines Einfügeformulares
*
* @class InsertView.js
*/
window.InsertView = Backbone.View.extend({
    events: {
    },

    buildView: function (that) {
        var viewId = $(that.el).find('#insertViewId');
        var fieldContainer = $(that.el).find('#insertViewFieldContainer');

        //var genericView = GenericHelper.getView(that.model.attributes.EntityId, ActionHelper.CurrentView.Type);
        var genericView = that.options.view;
        if (genericView.attributes.ViewName != null || genericView.attributes.ViewName != '') {
            $('#title').text(genericView.attributes.ViewName);
        }

        viewId.text = genericView.attributes.ViewId;

        var genericFieldsSorted = GenericHelper.getViewFields(genericView);

        //GENERIC FIELDS
        var OnChangeActions = [];
        _.each(genericFieldsSorted, function (field) {
            var genericProperty = window.genericProperties.get(field.attributes.PropertyId);

            ViewBuilder.createField(that, field, ActionHelper.CurrentView.Type);
            if (field.attributes.OnChangeJS != null && field.attributes.OnChangeJS != '') {
                OnChangeActions.push(field.attributes.OnChangeJS);
            }
        }, this);
        _.each(OnChangeActions, function (action) {
            eval(action);
        });
        OnChangeActions.length = 0;
        OnChangeActions = null;
        //GENERIC ACTIONS
        var viewActions = GenericHelper.getViewActions(genericView);

        _.each(viewActions, function (viewAction) {
            ActionHelper.prepareAction(genericView, viewAction);
        });

        //ONLOAD ACTIONS
        var onloadActions = _.filter(viewActions, function (action) {
            return action.attributes.ActionType == 'onload';
        });

        _.each(onloadActions, function (onloadAction) {
            var Command = 'ActionHelper.' + onloadAction.attributes.CommandName + ActionHelper.prepareParams(onloadAction);
            eval(Command);
        });

        //if (ActionHelper.tmpModelArray != undefined && ActionHelper.tmpModelArray.length > 0) Loedige.onChangeLeistungAnlegen();
    },

    render: function (eventName) {
        var that = this;
        ActionHelper.CurrentView = this;
        ActionHelper.CurrentView.model = null;
        ActionHelper.CurrentView.Type = this.options.view.attributes.ViewType;

        if (ActionHelper.tmpModelArray != undefined && ActionHelper.tmpModelArray.length > 0)
            ActionHelper.tmpModel = ActionHelper.tmpModelArray.shift();
        else
        if (ActionHelper.tmpModelArray != undefined && ActionHelper.tmpModelArray.length == 0)
            ActionHelper.tmpModel = undefined;


        if (ActionHelper.tmpModel != undefined && ActionHelper.tmpModel.attributes.EntityId == this.options.view.attributes.EntityId) {
            that.model = ActionHelper.tmpModel;
            that.options.modelId = that.model.attributes.ObjectId;
        } else {
            var itemId = window.generateGuid();
            //create dummy model
            that.model = new window.GenericDataRawElement();
            that.model.attributes.EntityId = ActionHelper.CurrentView.options.view.attributes.EntityId;
            var itemId = window.generateGuid();
            that.model.attributes.DataId = itemId;
            that.model.attributes.ObjectId = itemId;
            that.model.set({ 'id': itemId });
            that.model.id = itemId;
            that.model.attributes.UserId = window.currentUser.UserId;
            that.model.attributes.MandatorId = window.currentUser.MandatorId;
            that.model.attributes.OrgUnitId = window.currentUser.OrgUnitId;
            that.model.attributes.IsActive = true;
            that.model.attributes.EntryTime = moment().toDate();
            that.model.attributes.SyncTime = CONSTS.DATE_DEFAULT;
            that.model.IsNew = true;
        }
        if (ActionHelper.CopyModel != null) {
            ActionHelper.Models.length = 0;

            var genericFieldsSorted = GenericHelper.getViewFields(that.options.view);
            _.each(genericFieldsSorted, function (field) {
                if (field.attributes.TakeOverOnCopy) {
                    var gcn = window.genericProperties.get(field.attributes.PropertyId).attributes.GenericColumnName;
                    that.model.attributes[gcn] = ActionHelper.CopyModel.attributes[gcn];
                }
            });

            ActionHelper.CopyModel = null;
            delete ActionHelper.CopyModel;
        }
        if (that.options.refModelId != "null") {
            that.refModel = _.first(_.filter(window.genericData.models, function (model) {
                return model.attributes.ObjectId == that.options.refModelId;
            }));
        }

        require(["lib/text!js/view/generic/html/InsertView.html"], function (template) {
            $(that.el).html(_.template(template)());

            $('#backButton').css('display', '');

            that.buildView(that);

            $('#Insert').trigger('create');
            bodyMinHeightFix($('#InsertView'));
            ActionHelper.globalOnload();
        });

        this.delegateEvents();
        return this;
    },
});