﻿/**
* Generischer Viee zum Erzeugen einer Berichtsversandsansicht
*
* @class ReportView.js
*/
window.ReportView = Backbone.View.extend({
    events: {
        "click #email_textbaustein": "textbaustein",
        "click #email_adressbuch": "adressbuch_mail",
    },

    textbaustein: function () {
        //this.attr('model', 'email_address');
        var emailField = $('#pagecontent').find('#email_address');
        emailField.attr('model', 'email_address');
        ActionHelper.lookupPropertySelect(emailField[0], 'dd4262fd-ea8e-5d67-366d-f4580c849e25', -99, 'true', null, null, null, null, null);
        //$(ActionHelper.CurrentView.el).delegate("#" + viewAction.attributes.ViewActionId, viewAction.attributes.Event, function () {
        //    eval(preCommands);
        //    eval(Command);
        //    eval(postCommands);
        //});
    },

    adressbuch_mail: function () {
        var emailField = $('#pagecontent').find('#email_address');
        emailField.attr('model', 'email_address');
        ActionHelper.lookupPropertySelect(emailField[0], '3778a797-5c24-9d93-0083-35a4e49cf1c9', -99, 'true', null, null, null, null, null);
    },

    buildView: function (that) {
        ActionHelper.CurrentView = this;
        var genericView = that.options.view;
        var fieldContainer = $(that.el).find('#reportViewFieldContainer');

        if (genericView.attributes.ViewName != null || genericView.attributes.ViewName != '') {
            $('#title').text(genericView.attributes.ViewName);
        }
        var genericFieldsSorted = GenericHelper.getViewFields(genericView);

        emailField = $('#pagecontent').find('#email_address')[0];

        if (emailField.id == ActionHelper.ReturnField) {
            emailField.value = ActionHelper.ReturnValue;
            ActionHelper.ReturnValue = undefined;
            ActionHelper.ReturnField = undefined;
            ActionHelper.ReturnID = undefined;
        }
        //model.attributes.EntityId;


        var Reports = _.first(
        _.filter(window.genericData.models, function (rep) {
            return rep.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_CONFIG
                && rep.attributes.Custom_001 == genericView.attributes.EntityId
                && rep.attributes.IsActive
                && (genericView.attributes.Param01 == undefined || genericView.attributes.Param01 == '' || rep.attributes.ObjectId == genericView.attributes.Param01.toLowerCase());
        })
        );

        if (Reports != undefined) {
            var Reportparameter =
            _.filter(window.genericData.models, function (repp) {
                return repp.attributes.EntityId == CONSTS.GENERIC_ENTITY_ID_REPORT_PARAMS && repp.attributes.Custom_005 == Reports.attributes.ObjectId && repp.attributes.IsActive && repp.attributes.Custom_008 != 1;
            });
            _.each(Reportparameter, function (param) {
                var genField = new window.GenericViewFieldRawElement();
                var genProp = new window.GenericPropertyRawElement();

                genField.attributes.FieldId = param.attributes.Custom_002;
                genField.attributes.DefaultValue = '';
                genField.attributes.IsReadonly = false;

                genProp.attributes.Size = 200
                genProp.attributes.PropertyName = param.attributes.Custom_001;//Display
                genProp.attributes.GenericColumnName = param.attributes.Custom_002;
                genProp.attributes.DataType = param.attributes.Custom_003;
                ViewBuilder.createFieldForReport(that, genField, ActionHelper.CurrentView.Type, genProp);
            });

            //var genProp = new window.GenericPropertyRawElement();
            //var genField= new window.GenericViewFieldRawElement();
            subject = Reports.attributes.Custom_003;
        }

        //GENERIC FIELDS
        _.each(genericFieldsSorted, function (field) {
            var genericProperty = window.genericProperties.get(field.attributes.PropertyId);

            ViewBuilder.createField(that, field, ActionHelper.CurrentView.Type);

        }, this);

        //GENERIC ACTIONS
        var viewActions = GenericHelper.getViewActions(genericView);

        _.each(viewActions, function (viewAction) {
            ActionHelper.prepareAction(genericView, viewAction);
        });

        //ONLOAD ACTIONS
        var onloadActions = _.filter(viewActions, function (action) {
            return action.attributes.ActionType == 'onload';
        });

        _.each(onloadActions, function (onloadAction) {
            var Command = 'ActionHelper.' + onloadAction.attributes.CommandName + ActionHelper.prepareParams(onloadAction);
            eval(Command);
        });


        //Css
        //$("#email_textbaustein").css("-webkit-border-radius", "1em !important");
        //$("#email_textbaustein").css("border-radius", "1em !important");
    },

    render: function (eventName) {
        var that = this;
        ActionHelper.CurrentView = this;
        ActionHelper.CurrentView.Type = this.options.view.attributes.ViewType;
        if (that.options.modelId != "null") {
            that.model = window.genericData.get(that.options.modelId);
        }
        if (that.options.refModelId != "null") {
            that.refModel = _.first(_.filter(window.genericData.models, function (model) {
                return model.attributes.ObjectId == that.options.refModelId;
            }));
        }
        if (that.model != undefined)
            that.options.refNavId = that.model.attributes.ObjectId;
        require(["lib/text!js/view/generic/html/ReportView.html"], function (template) {
            $(that.el).html(_.template(template)());
            $('#backButton').css('display', '');

            that.buildView(that);

            $('#Report').trigger('create');
            ActionHelper.globalOnload();
        });

        this.delegateEvents();
        return this;
    },
});